<?php
namespace application\personal_messenger\integration\core\home;

/**
 * This block contains the values to display the most recent messages.
 *
 * @version 1.0.0
 * @author Stijn Van Hoecke
 */
class MostRecentMessages extends Block
{

    /**
     * Inherited from PersonalMessengerBlock Main function to display content -> delegates to the function
     * display_messages.
     */
    public function display_content()
    {
        return $this->display_messages();
    }

    /**
     * Specifies the folder to display.
     *
     * @return boolean
     */
    public function get_folder()
    {
        return \application\personal_messenger\PersonalMessengerFolder :: INBOX;
    }

    /**
     * Specifies if only new messages should be displayed.
     *
     * @return boolean
     */
    public function new_only()
    {
        return false;
    }

    /**
     * Specifies if the content of the message should be displayed.
     *
     * @return boolean
     */
    public function show_content()
    {
        return false;
    }
}
