<?php
namespace application\personal_messenger;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;

/** * ***************************************************************************
 * This class handles the AJAX call for the count of new messages in the browser.
 *
 * @name Chamilo Personal Messenger > PersonalMessengerAjaxHasNewMessages
 * @version 1.0.0
 * @author Stijn Van Hoecke
 * **************************************************************************** */
class PersonalMessengerAjaxHasNewMessages extends AjaxManager
{
    const PARAM_LAST_CHECKED = 'last_checked';
    
    const PROPERTY_HAS = 'has_messages';
    const PROPERTY_LAST_CHECKED = 'last_checked';

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_LAST_CHECKED);
    }

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::run()
     */
    public function run()
    {       
        // get count
        $has = PersonalMessengerDataManager :: count_all_messages(true, $this->get_parameter(self :: PARAM_LAST_CHECKED)) != 0;
        
        // save checktime
        $checked = time();

        // construct result
        $result = new JsonAjaxResult(200);
        
        // set properties
        $result->set_property(self :: PROPERTY_LAST_CHECKED, $checked);
        $result->set_property(self :: PROPERTY_HAS, $has);
        
        // return result
        $result->display();
    }
}
