<?php
namespace application\personal_messenger;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'PersonalMessengerAjaxHasNewMessages' => '/ajax/has_new_messages.class.php',
         'PersonalMessengerAjaxHasNewReplies' => '/ajax/has_new_replies.class.php',
         'PersonalMessengerAjaxQuickReply' => '/ajax/quick_reply.class.php',
         'PersonalMessengerAjaxRetrieveNewReplies' => '/ajax/retrieve_new_replies.class.php',
         'Message' => '/lib/message.class.php',
         'MessageAttachment' => '/lib/message_attachment.class.php',
         'MessageGroupRecipient' => '/lib/message_group_recipient.class.php',
         'MessageRecipient' => '/lib/message_recipient.class.php',
         'MessageUserRecipient' => '/lib/message_user_recipient.class.php',
         'PersonalMessengerDataClass' => '/lib/personal_messenger_data_class.class.php',
         'PersonalMessengerDataManager' => '/lib/personal_messenger_data_manager.class.php',
         'PersonalMessengerDataManagerInterface' => '/lib/personal_messenger_data_manager_interface.class.php',
         'PersonalMessengerFolder' => '/lib/personal_messenger_folder.class.php',
         'UserIgnore' => '/lib/user_ignore.class.php',
         'UserMessage' => '/lib/user_message.class.php',
         'UserCategory' => '/lib/category_manager/user_category.class.php',
         'UserCategoryManager' => '/lib/category_manager/user_category_manager.class.php',
         'UserCategoryRenderer' => '/lib/category_manager/user_category_renderer.class.php',
         'DatabasePersonalMessengerDataManager' => '/lib/data_manager/database_personal_messenger_data_manager.class.php',
         'Mdb2PersonalMessengerDataManager' => '/lib/data_manager/mdb2.class.php',
         'MessageForm' => '/lib/forms/message_form.class.php',
         'MoveForm' => '/lib/forms/move_form.class.php',
         'QuickReplyForm' => '/lib/forms/quick_reply_form.class.php',
         'QuickReplyFormAjax' => '/lib/forms/quick_reply_form_ajax.class.php',
         'SelectUserForm' => '/lib/forms/select_user_form.class.php',
         'PersonalMessengerManager' => '/lib/personal_messenger_manager/personal_messenger_manager.class.php',
         'PersonalMessengerManagerAttachmentViewerComponent' => '/lib/personal_messenger_manager/component/attachment_viewer.class.php',
         'PersonalMessengerManagerBrowserComponent' => '/lib/personal_messenger_manager/component/browser.class.php',
         'PersonalMessengerManagerCategoryManagerComponent' => '/lib/personal_messenger_manager/component/category_manager.class.php',
         'PersonalMessengerManagerCategoryMoverComponent' => '/lib/personal_messenger_manager/component/category_mover.class.php',
         'PersonalMessengerManagerCreatorComponent' => '/lib/personal_messenger_manager/component/creator.class.php',
         'PersonalMessengerManagerCreatorFromTemplateComponent' => '/lib/personal_messenger_manager/component/creator_from_template.class.php',
         'PersonalMessengerManagerDeleterComponent' => '/lib/personal_messenger_manager/component/deleter.class.php',
         'PersonalMessengerManagerDeleterMessageComponent' => '/lib/personal_messenger_manager/component/deleter_message.class.php',
         'PersonalMessengerManagerDeleterUserMessageComponent' => '/lib/personal_messenger_manager/component/deleter_user_message.class.php',
         'PersonalMessengerManagerForwarderComponent' => '/lib/personal_messenger_manager/component/forwarder.class.php',
         'PersonalMessengerManagerMarkerComponent' => '/lib/personal_messenger_manager/component/marker.class.php',
         'PersonalMessengerManagerMarkerIgnoreComponent' => '/lib/personal_messenger_manager/component/marker_ignore.class.php',
         'PersonalMessengerManagerMarkerReadComponent' => '/lib/personal_messenger_manager/component/marker_read.class.php',
         'PersonalMessengerManagerMarkerTrashComponent' => '/lib/personal_messenger_manager/component/marker_trash.class.php',
         'PersonalMessengerManagerMarkerUnignoreComponent' => '/lib/personal_messenger_manager/component/marker_unignore.class.php',
         'PersonalMessengerManagerMarkerUnreadComponent' => '/lib/personal_messenger_manager/component/marker_unread.class.php',
         'PersonalMessengerManagerMarkerUntrashComponent' => '/lib/personal_messenger_manager/component/marker_untrash.class.php',
         'PersonalMessengerManagerReplyComponent' => '/lib/personal_messenger_manager/component/reply.class.php',
         'PersonalMessengerManagerTemplatorComponent' => '/lib/personal_messenger_manager/component/templator.class.php',
         'PersonalMessengerManagerUpdaterComponent' => '/lib/personal_messenger_manager/component/updater.class.php',
         'PersonalMessengerManagerUserAdderComponent' => '/lib/personal_messenger_manager/component/user_adder.class.php',
         'PersonalMessengerManagerUserDeleterComponent' => '/lib/personal_messenger_manager/component/user_deleter.class.php',
         'PersonalMessengerManagerUserIgnoreComponent' => '/lib/personal_messenger_manager/component/user_ignore.class.php',
         'PersonalMessengerManagerUserManagerComponent' => '/lib/personal_messenger_manager/component/user_manager.class.php',
         'PersonalMessengerManagerUserManagerDiscussionComponent' => '/lib/personal_messenger_manager/component/user_manager_discussion.class.php',
         'PersonalMessengerManagerUserManagerIgnoredComponent' => '/lib/personal_messenger_manager/component/user_manager_ignored.class.php',
         'PersonalMessengerManagerUserUnignoreComponent' => '/lib/personal_messenger_manager/component/user_unignore.class.php',
         'PersonalMessengerManagerViewerComponent' => '/lib/personal_messenger_manager/component/viewer.class.php',
         'PersonalMessengerManagerViewerDiscussionComponent' => '/lib/personal_messenger_manager/component/viewer_discussion.class.php',
         'PersonalMessengerManagerViewerMessageComponent' => '/lib/personal_messenger_manager/component/viewer_message.class.php',
         'DiscussionUserTable' => '/lib/personal_messenger_manager/component/discussion_user/discussion_user_table.class.php',
         'DiscussionUserTableCellRenderer' => '/lib/personal_messenger_manager/component/discussion_user/discussion_user_table_cell_renderer.class.php',
         'DiscussionUserTableColumnModel' => '/lib/personal_messenger_manager/component/discussion_user/discussion_user_table_column_model.class.php',
         'DiscussionUserTableDataProvider' => '/lib/personal_messenger_manager/component/discussion_user/discussion_user_table_data_provider.class.php',
         'IgnoredUserTable' => '/lib/personal_messenger_manager/component/ignored_user/ignored_user_table.class.php',
         'IgnoredUserTableCellRenderer' => '/lib/personal_messenger_manager/component/ignored_user/ignored_user_table_cell_renderer.class.php',
         'IgnoredUserTableColumnModel' => '/lib/personal_messenger_manager/component/ignored_user/ignored_user_table_column_model.class.php',
         'IgnoredUserTableDataProvider' => '/lib/personal_messenger_manager/component/ignored_user/ignored_user_table_data_provider.class.php',
         'MessageBrowserTable' => '/lib/personal_messenger_manager/component/message_browser/message_browser_table.class.php',
         'MessageBrowserTableCellRenderer' => '/lib/personal_messenger_manager/component/message_browser/message_browser_table_cell_renderer.class.php',
         'MessageBrowserTableColumnModel' => '/lib/personal_messenger_manager/component/message_browser/message_browser_table_column_model.class.php',
         'MessageBrowserTableDataProvider' => '/lib/personal_messenger_manager/component/message_browser/message_browser_table_data_provider.class.php',
         'DefaultMessageTableCellRenderer' => '/lib/tables/message_table/default_message_table_cell_renderer.class.php',
         'DefaultMessageTableColumnModel' => '/lib/tables/message_table/default_message_table_column_model.class.php',
         'DefaultUserTableCellRenderer' => '/lib/tables/user_table/default_user_table_cell_renderer.class.php',
         'DefaultUserTableColumnModel' => '/lib/tables/user_table/default_user_table_column_model.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>