<?php

namespace application\personal_messenger;

use common\libraries\AndCondition;
use common\libraries\EqualityCondition;

/** * ***************************************************************************
 * This component offers the functionality to delete a (series of) user message(s)
 * from the users folder.
 *
 * @name Chamilo Personal Messenger > PersonalMessengerManagerDeleterUserMessageComponent
 * @version 1.0.0
 * @author Stijn Van Hoecke
 * **************************************************************************** */
class PersonalMessengerManagerDeleterUserMessageComponent extends PersonalMessengerManagerDeleterComponent
{

    //**************************************************************************
    // INHERITED FUNCTIONS
    //**************************************************************************
    /**
     * Returns the object to delete.
     * @param $object_id The id of the object to delete
     * @return UserMessage The UserMessage to delete
     */
    public function get_object($object_id)
    {
        // construct the condition
        $conditions = array();
        $conditions[] = new EqualityCondition(
                        UserMessage :: PROPERTY_USER_MESSAGE_MESSAGE_ID,
                        $object_id
        );
        $conditions[] = new EqualityCondition(
                        UserMessage :: PROPERTY_USER_MESSAGE_USER_ID,
                        $this->get_user_id()
        );
        $condition = new AndCondition($conditions);

        // get the UserMessage
        return $this->retrieve_user_message($condition);
    }

}
