<?php

namespace application\personal_messenger;

use common\libraries\Utilities;

/** * ***************************************************************************
 * Marker for the status UNREAD
 *
 * @name Chamilo Personal Messenger > PersonalMessengerManagerMarkerUnreadComponent
 * @version 1.0.0
 * @author Stijn Van Hoecke
 * @see PersonalMessengerManagerMarkerComponent
 * **************************************************************************** */
class PersonalMessengerManagerMarkerUnreadComponent extends PersonalMessengerManagerMarkerComponent
{

    //**************************************************************************
    // INHERITED FUNCTIONS
    //**************************************************************************
    /**
     * Updates the status of the message to the appropriate implementation.
     * @param UserMessage The user message
     */
    public function update_status($user_message)
    {
        $user_message->set_status(UserMessage :: STATUS_UNREAD);
    }

    /**
     * Returns the status (identifier for translation).
     * @return string The status
     */
    public function get_translation_status()
    {
        return Utilities :: underscores_to_camelcase(UserMessage :: get_status_name(UserMessage :: STATUS_UNREAD));
    }
}
