<?php

namespace application\personal_messenger;

use common\libraries\ObjectTableDataProvider;

/** * ***************************************************************************
 * Data provider for a message browser table.
 *
 * @name Chamilo Personal Messenger > MessageBrowserTableDataProvider
 * @version 1.0.0
 * @author Stijn Van Hoecke
 * **************************************************************************** */
class MessageBrowserTableDataProvider extends ObjectTableDataProvider
{

    //**************************************************************************
    // CONSTRUCTOR
    //**************************************************************************
    /**
     * Constructor
     * @param PersonalMessengerManagerComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    //**************************************************************************
    // GENERAL FUNCTIONS
    //**************************************************************************
    /**
     * Gets the messages
     * @param int $offset
     * @param int $max_objects
     * @param string $order_by
     * @return ResultSet A set of matching messages.
     */
    public function get_objects($offset, $max_objects, $order_by = null)
    {
        $order_by = $this->get_order_property($order_by);
        return $this->get_browser()->retrieve_user_messages($this->get_condition(), $order_by, $offset, $max_objects);
    }

    /**
     * Gets the number of messages
     * @return int
     */
    public function get_object_count()
    {
        return PersonalMessengerDataManager :: get_instance()->count_user_messages($this->get_condition());
    }

}
