<?php

namespace application\personal_messenger;

use common\libraries\ObjectTableCellRenderer;
use user\User;

/** * ***************************************************************************
 * This class is the default cell renderer for users.
 *
 * @name Chamilo Personal Messenger > DefaultUserTableCellRenderer
 * @version 1.0.0
 * @author Stijn Van Hoecke
 * **************************************************************************** */
class DefaultUserTableCellRenderer extends ObjectTableCellRenderer
{

    //**************************************************************************
    // CONSTRUCTOR
    //**************************************************************************
    /**
     * Constructor
     */
    public function __construct()
    {
    }

    //**************************************************************************
    // GENERAL FUNCTIONS
    //**************************************************************************
    /**
     * Renders a table cell based on the given parameters column and message.
     * The message contains additional parameters obtained by a join between the
     * user message and actual message in the database data manager.
     * @param MessageTableColumn $column The column which should be rendered
     * @param Message $message The message to render
     * @return String A HTML representation of the rendered table cell
     */
    public function render_cell($column, $user)
    {
        switch ($column->get_name())
        {
            // last name column gets the last name of the user
            case User :: PROPERTY_LASTNAME :
                return $user->get_lastname();

            // first name column gets the first name of the user
            case User :: PROPERTY_FIRSTNAME :
                return $user->get_firstname();

            // default return blank
            default :
                return '&nbsp;';
        }
    }

    public function render_id_cell($object)
    {
        return $object->get_id();
    }

}
