// This function will poll to the server retrieving new replies on the given message. The retrieved messages are
// formatted and added to the DOM.
function retrieveNewReplies()
{    
    // postback
    var result = doAjaxPost(
            ajaxUri,
            {
                'context' : 'application\\personal_messenger',
                'method' : 'retrieve_new_replies',
                'message_id' : messageId,
                'last_retrieved' : lastRetrieved
            });
    result = eval('(' + result + ')');
    // update last checked
    lastRetrieved = result.properties.last_retrieved;
    // process new replies
    replies = result.properties.replies;
    for (var reply_nr = 0; reply_nr < replies.length; reply_nr++)
    {
        // - format reply
        reply_node = formatReply(result, replies[reply_nr]);
        // - add node
        message_node = document.getElementById('message_' + messageId);
        quick_reply_node = message_node.childNodes[message_node.childNodes.length - 1];
        message_node.insertBefore(reply_node, quick_reply_node);
    }
}

function formatReply(result, reply)
{
    // manipulate DOM to match original HTML
    // - global node
    var reply_node = document.createElement('div');
    reply_node.className = 'reply';
    reply_node.style.backgroundImage = result.properties.background_img_style;
    // -- title div
    var title_div = document.createElement('div');
    title_div.className = 'title';
    inner_html = '<b>' + reply.author + '</b>';
    if(reply.title)
    {
        inner_html = inner_html + ' - ' + reply.title;
    }
    title_div.innerHTML = inner_html;
    // -- message div
    var message_div = document.createElement('div');
    message_div.className = 'message';
    message_div.innerHTML = reply.content;
    // -- attachments
    if(reply.attachments.length > 0)
    {
        table = document.createElement('table');
        row = document.createElement('tr');
        header_cell = document.createElement('td');
        header_cell.className = 'header_value';
        icon = document.createElement('img');
        icon.src = result.properties.attachment_image;
        header_cell.appendChild(icon);
        data_cell = document.createElement('td');
        attachments_value = '';
        for (var att_nr = 0; att_nr < reply.attachments.length; att_nr++)
        {
            attachment = reply.attachments[att_nr];
            attachments_value = attachments_value + result.properties.attachment_prefix + ' ';
            attachments_value = attachments_value + attachment.url;
            attachments_value = attachments_value + attachment.title + ' (' + attachment.type + ')';
            attachments_value = attachments_value + '</a>';
            attachments_value = attachments_value + ' ' + result.properties.attachment_suffix;
            if(att_nr < reply.attachments.length - 1)
            {
                attachments_value = attachments_value + result.properties.attachment_separator;
            }
        }
        data_cell.innerHTML = attachments_value;
        row.appendChild(header_cell);
        row.appendChild(data_cell);
        table.appendChild(row);
        message_div.appendChild(table);
    }
    // -- modification div
    var modification_div = document.createElement('div');
    modification_div.className = 'modification';
    modification_div.innerHTML = reply.modification;
    // - construct node
    reply_node.appendChild(title_div);
    reply_node.appendChild(message_div);
    reply_node.appendChild(modification_div);
    return reply_node;
}