<?php
namespace application\portfolio;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'PortfolioDataManager' => '/lib/portfolio_data_manager.class.php',
         'PortfolioDataManagerInterface' => '/lib/portfolio_data_manager.interface.class.php',
         'PortfolioInformation' => '/lib/portfolio_information.class.php',
         'PortfolioMenu' => '/lib/portfolio_menu.class.php',
         'PortfolioPublication' => '/lib/portfolio_publication.class.php',
         'UserMenu' => '/lib/user_menu.class.php',
         'Mdb2PortfolioDataManager' => '/lib/data_manager/mdb2.class.php',
         'PortfolioIntroductionForm' => '/lib/forms/portfolio_introduction_form.class.php',
         'PortfolioPublicationForm' => '/lib/forms/portfolio_publication_form.class.php',
         'PortfolioManager' => '/lib/portfolio_manager/portfolio_manager.class.php',
         'PortfolioManagerAdminDefaultSettingsCreatorComponent' => '/lib/portfolio_manager/component/admin_default_settings_creator.class.php',
         'PortfolioManagerBrowserComponent' => '/lib/portfolio_manager/component/browser.class.php',
         'PortfolioManagerPortfolioBookmarkCreatorComponent' => '/lib/portfolio_manager/component/portfolio_bookmark_creator.class.php',
         'PortfolioManagerPortfolioBuilderComponent' => '/lib/portfolio_manager/component/portfolio_builder.class.php',
         'PortfolioManagerPortfolioIntroductionCreatorComponent' => '/lib/portfolio_manager/component/portfolio_introduction_creator.class.php',
         'PortfolioManagerPortfolioItemCreatorComponent' => '/lib/portfolio_manager/component/portfolio_item_creator.class.php',
         'PortfolioManagerPortfolioItemDeleterComponent' => '/lib/portfolio_manager/component/portfolio_item_deleter.class.php',
         'PortfolioManagerPortfolioPublicationCreatorComponent' => '/lib/portfolio_manager/component/portfolio_publication_creator.class.php',
         'PortfolioManagerPortfolioPublicationDeleterComponent' => '/lib/portfolio_manager/component/portfolio_publication_deleter.class.php',
         'PortfolioManagerRightsOverviewComponent' => '/lib/portfolio_manager/component/rights_overview.class.php',
         'PortfolioManagerViewerComponent' => '/lib/portfolio_manager/component/viewer.class.php',
         'PortfolioBrowserTable' => '/lib/portfolio_manager/component/portfolio_browser/portfolio_browser_table.class.php',
         'PortfolioBrowserTableCellRenderer' => '/lib/portfolio_manager/component/portfolio_browser/portfolio_browser_table_cell_renderer.class.php',
         'PortfolioBrowserTableColumnModel' => '/lib/portfolio_manager/component/portfolio_browser/portfolio_browser_table_column_model.class.php',
         'PortfolioBrowserTableDataProvider' => '/lib/portfolio_manager/component/portfolio_browser/portfolio_browser_table_data_provider.class.php',
         'PortfolioGroupRightLocation' => '/lib/rights/portfolio_group_right_location.class.php',
         'PortfolioLocation' => '/lib/rights/portfolio_location.class.php',
         'RightsLocation' => '/lib/rights/rights_location_new.class.php',
         'PortfolioLocation' => '/lib/rights/portfolio_location_old.class.php',
         'PortfolioRights' => '/lib/rights/portfolio_rights_old.class.php',
         'PortfolioUserRightLocation' => '/lib/rights/portfolio_user_right_location.class.php',
         'PortfolioPublicationRSS' => '/lib/rss/publication_rss.class.php',
         'DefaultPortfolioTableCellRenderer' => '/lib/tables/portfolio_table/default_portfolio_table_cell_renderer.class.php',
         'DefaultPortfolioTableColumnModel' => '/lib/tables/portfolio_table/default_portfolio_table_column_model.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'PortfolioInstaller' => '/package/install/portfolio_installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>