<?php
namespace application\portfolio;

use common\libraries\WebApplicationInstaller;
use common\libraries\Translation;
use common\libraries\Utilities;

/**
 * This installer can be used to create the storage structure for the portfolio application.
 *
 * @author Sven Vanpoucke
 */
class PortfolioInstaller extends WebApplicationInstaller
{

    /**
     * Constructor
     */
    public function __construct($values)
    {
        parent :: __construct($values, PortfolioDataManager :: get_instance());
    }

    public function get_path()
    {
        return parent :: get_path();
    }

    /**
     * Runs the install-script.
     */
    public function extra()
    {
        if (! parent :: extra())
        {
            return false;
        }

        if (! $this->create_default_location())
        {
            return false;
        }
        else
        {
            $this->add_message(self :: TYPE_NORMAL, Translation :: get('DefaultLocationCreated'), null,
                    Utilities :: COMMON_LIBRARIES);
        }

        return true;
    }

    /**
     * create a location with tree identifier 0 to apply default settings for the portfolio
     */
    public function create_default_location()
    {
        return PortfolioRights :: create_default_location();
    }
    
    public function get_additional_packages()
    {
        $installers = array();
        $installers[] = 'application\portfolio\integration\core\home';
        return $installers;
    }
}
