<?php
namespace application\weblcms\integration\core\home;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'Block' => '/lib/block.class.php',
         'Connector' => '/lib/connector.class.php',
         'NewBlock' => '/lib/new_block.class.php',
         'AssignmentSubmissions' => '/lib/type/assignment_submissions.class.php',
         'CourseList' => '/lib/type/course_list.class.php',
         'CourseMenu' => '/lib/type/course_menu.class.php',
         'CourseTypeCourseList' => '/lib/type/course_type_course_list.class.php',
         'EndingAssignments' => '/lib/type/ending_assignments.class.php',
         'FilteredCourseList' => '/lib/type/filtered_course_list.class.php',
         'NewAnnouncements' => '/lib/type/new_announcements.class.php',
         'NewAssignments' => '/lib/type/new_assignments.class.php',
         'NewDocuments' => '/lib/type/new_documents.class.php',
         'WeblcmsBookmarkDisplay' => '/lib/type/weblcms_bookmark_display.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>