<?php

namespace application\weblcms\integration\core\home;

//use application\weblcms\course\CourseManager;
//use common\libraries\AndCondition;
//use common\libraries\DataClassRetrievesParameters;
//use common\libraries\EqualityCondition;
//use common\libraries\PropertyConditionVariable;
//use common\libraries\StaticConditionVariable;
//use common\libraries\StringUtilities;
use common\libraries\Translation;
use repository\ContentObjectDisplay;
use common\libraries\StringUtilities;
use common\libraries\EqualityCondition;
use common\libraries\PropertyConditionVariable;
use repository\content_object\bookmark\Bookmark;
use common\libraries\Session;
use common\libraries\StaticConditionVariable;
use common\libraries\AndCondition;
use common\libraries\DataClassRetrievesParameters;
use repository\ContentObject;
//use repository\content_object\bookmark\Bookmark;
//use repository\ContentObject;
//use repository\ContentObjectDisplay;
//use repository\DataManager;
//use user\integration\reporting\Block;
//use user\Session;



/**
 * Block to display all bookmarks foor the handbooks application
 * 
 * @package handbook.block
 */
class WeblcmsBookmarkDisplay extends NewBlock
{

    public function __construct($parent, $block_info, $configuration)
    {
        parent :: __construct($parent, $block_info, $configuration, Translation :: get('WeblcmsBookmarks'));
    }

    public function is_configured()
    {
        // no configuration needed for now
        return true;
    }

    public function is_visible()
    {
        if ($this->is_empty() && ! $this->show_when_empty())
        {
            return false;
        }
        return true; // i.e.display on homepage when anonymous
    }

    public function is_hidable()
    {
        return true;
    }

    public function is_deletable()
    {
        return true;
    }

    /**
     * Returns the html to display when the block is configured.
     * 
     * @return string
     */
    public function display_content()
    {
        $bookmarks_resultset = $this->get_bookmarks();
        
        while ($bookmarks_resultset && $bm = $bookmarks_resultset->next_result())
        {
            $display = ContentObjectDisplay :: factory($bm);
            $html[] = $display->get_short_html();
            $html[] = '</br>';
        }
        return implode(StringUtilities :: NEW_LINE, $html);
    }

    public function show_when_empty()
    {
        $configuration = $this->get_configuration();
        $result = isset($configuration['show_when_empty']) ? $configuration['show_when_empty'] : true;
        $result = (bool) $result;
        return $result;
    }

    public function is_empty()
    {
        $bookmarks = $this->get_bookmarks();
        return $bookmarks->size() == 0;
    }

    public function get_bookmarks()
    {
        $conditions = array();
        $conditions[] = new EqualityCondition(
            new PropertyConditionVariable(Bookmark :: class_name(), Bookmark :: PROPERTY_APPLICATION),
            new StaticConditionVariable(\application\weblcms\WeblcmsManager::APPLICATION_NAME)
        );
        $conditions[] = new EqualityCondition(
            new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_OWNER_ID),
            new StaticConditionVariable(Session :: get_user_id())
        );

        $condition = new AndCondition($conditions);
        $parameters = new DataClassRetrievesParameters($condition);

        $bookmarks_resultset = \repository\DataManager :: retrieve_active_content_objects(Bookmark :: class_name(), $parameters);

        return $bookmarks_resultset;
    }

    public function count_data() {
        
    }

    public function get_views() {
        
    }

    public function retrieve_data() {
        
    }   
}
