<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\course\Course;
use application\weblcms\course\DataManager as CourseDataManager;
use reporting\ReportingData;
use reporting\ReportingFormatter;
use common\libraries\Translation;

class CourseInformationBlock extends CourseBlock
{

    public function count_data()
    {
        $reporting_data = new ReportingData();

        $course = CourseDataManager :: retrieve(Course :: class_name(), $this->get_course_id());

        $reporting_data->set_categories(array(Translation :: get('Name'), Translation :: get('Titular')));
        $reporting_data->set_rows(array(Translation :: get('count')));

        $reporting_data->add_data_category_row(
            Translation :: get('Name'),
            Translation :: get('count'),
            $course->get_title());
        $reporting_data->add_data_category_row(
            Translation :: get('Titular'),
            Translation :: get('count'),
            $course->get_titular_string());

        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_views()
    {
        return array(\reporting\viewer\HtmlBlockRendition :: VIEW_TABLE);
    }
}
