<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\course\Course;
use application\weblcms\course\DataManager as CourseDataManager;
use reporting\ReportingData;
use reporting\ReportingChartFormatter;
use reporting\ReportingFormatter;
use common\libraries\EqualityCondition;
use common\libraries\Translation;

class CoursesPerCategoryBlock extends CourseBlock
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $reporting_data->set_rows(array(Translation :: get('count')));

        $categories = \application\weblcms\DataManager :: retrieve_course_categories_ordered_by_name();

        while ($category = $categories->next_result())
        {
            $condition = new EqualityCondition(Course :: PROPERTY_CATEGORY_ID, $category->get_id());

            $reporting_data->add_category($category->get_name());
            $reporting_data->add_data_category_row(
                $category->get_name(),
                Translation :: get('count'),
                CourseDataManager :: count(Course :: class_name(), $condition));
        }

        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_views()
    {
        return array(
            \reporting\viewer\HtmlBlockRendition :: VIEW_TABLE,
            \reporting\viewer\HtmlBlockRendition :: VIEW_PIE);
    }
}
