<?php
namespace application\weblcms\integration\reporting;

use reporting\ReportingData;
use application\weblcms\course\CourseUserRelation;
use reporting\ReportingChartFormatter;
use reporting\ReportingFormatter;
use user\UserDataManager;
use common\libraries\Translation;

class NoOfUsersSubscribedCourseBlock extends CourseBlock
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $udm = UserDataManager :: get_instance();
        $users = $udm->count_users();

        $courses = \application\weblcms\DataManager :: count_distinct(
            CourseUserRelation :: class_name(),
            new \common\libraries\DataClassCountDistinctParameters(null, CourseUserRelation :: PROPERTY_USER_ID));

        $reporting_data->set_categories(
            array(Translation :: get('UsersSubscribedToCourse'), Translation :: get('UsersNotSubscribedToCourse')));
        $reporting_data->set_rows(array(Translation :: get('count')));

        $reporting_data->add_data_category_row(
            Translation :: get('UsersSubscribedToCourse'),
            Translation :: get('count'),
            $courses);
        $reporting_data->add_data_category_row(
            Translation :: get('UsersNotSubscribedToCourse'),
            Translation :: get('count'),
            $users - $courses);
        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \application\weblcms\WeblcmsManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(
            \reporting\viewer\HtmlBlockRendition :: VIEW_TABLE,
            \reporting\viewer\HtmlBlockRendition :: VIEW_PIE,
            \reporting\viewer\HtmlBlockRendition :: VIEW_BAR,
            \reporting\viewer\HtmlBlockRendition :: VIEW_LINE,
            \reporting\viewer\HtmlBlockRendition :: VIEW_STACKED_AREA);
    }
}
