<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\ContentObjectPublication;
use application\weblcms\course\Course;
use common\libraries\AndCondition;
use application\weblcms\course\DataManager as CourseDataManager;
use reporting\ReportingData;
use reporting\ReportingChartFormatter;
use reporting\ReportingFormatter;
use common\libraries\EqualityCondition;
use common\libraries\Translation;

class AverageLearningPathScoreBlock extends CourseBlock
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $reporting_data->set_rows(array(Translation :: get('LearningPath')));

        $course_id = $this->get_course_id();

        $course = CourseDataManager :: retrieve(Course :: class_name(), $course_id);

        $conditions = array();
        $conditions[] = new EqualityCondition(ContentObjectPublication :: PROPERTY_COURSE_ID, $course->get_id());
        $conditions[] = new EqualityCondition(ContentObjectPublication :: PROPERTY_TOOL, 'learning_path');

        $condition = new AndCondition($conditions);
        $lops = \application\weblcms\DataManager :: retrieve_content_object_publications($condition);

        while ($lop = $lops->next_result())
        {
            $lpo = $lop->get_content_object();
            // $arr[$lpo->get_title()] = 0;
            $reporting_data->add_data_category_row(
                Translation :: get('LearningPath'),
                Translation :: get('Average'),
                $lpo->get_title());
        }

        // $datadescription[0] = Translation :: get('LearningPath');
        // $datadescription[1] = Translation :: get('Average');

        // $reporting_data->add_category($learn);

        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \application\weblcms\WeblcmsManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(
            \reporting\viewer\HtmlBlockRendition :: VIEW_TABLE,
            \reporting\viewer\HtmlBlockRendition :: VIEW_PIE);
    }
}
