<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\Tool;
use application\weblcms\WeblcmsManager;
use reporting\ReportingData;
use reporting\ReportingFormatter;
use common\libraries\PatternMatchCondition;
use user\User;
use user\UserDataManager;
use common\libraries\ObjectTableOrder;
use common\libraries\AndCondition;
use common\libraries\EqualityCondition;
use common\libraries\Translation;
use common\libraries\DatetimeUtilities;
use common\libraries\Utilities;
use common\libraries\Request;
use application\weblcms\tool\reporting\ReportingTool;

class PublicationUserAccessBlock extends ToolBlock
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $content_object_publication_id = $this->get_publication_id();
        $content_object_publication = \application\weblcms\DataManager :: retrieve(
            ContentObjectPublication :: class_name(), $content_object_publication_id
        );

        $reporting_data->set_categories(
            array(
                Translation :: get('User', null, 'user'),
                Translation :: get('OfficialCode', null, 'user')
            )
        );

        $this->add_reporting_data_categories_for_course_visit_data($reporting_data);

        $reporting_data->set_rows(array(Translation :: get('count')));

        $user = \user\DataManager :: retrieve_by_id(User :: class_name(), $this->get_user_id());

        $reporting_data->add_data_category_row(
            Translation :: get('User', null, 'user'), Translation :: get('count'), $user->get_fullname()
        );

        $reporting_data->add_data_category_row(
            Translation :: get('OfficialCode', null, 'user'), Translation :: get('count'), $user->get_official_code()
        );

        $course_visit = $this->get_course_visit_summary_from_publication($content_object_publication);

        $this->add_reporting_data_from_course_visit_as_row(
            Translation :: get('count'), $reporting_data, $course_visit
        );

        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \application\weblcms\WeblcmsManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(\reporting\viewer\HtmlBlockRendition :: VIEW_TABLE);
    }
}
