<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\WeblcmsManager;
use common\libraries\Request;
use reporting\ReportingTemplate;

/**
 * $Id: course_data_reporting_template.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.reporting.templates
 */
class CourseDataTemplate extends ReportingTemplate
{

    public function __construct($parent)
    {
        parent :: __construct($parent);
        $this->add_reporting_block($this->get_no_of_courses());
        $this->add_reporting_block($this->get_no_of_courses_by_language());
        $this->add_reporting_block($this->get_most_active_inactive_last_visit());
        $this->add_reporting_block($this->get_most_active_inactive_last_publication());
        $this->add_reporting_block($this->get_most_active_inactive_last_detail());
        // $this->add_reporting_block($this->get_no_of_objects_per_type());
        // $this->add_reporting_block($this->get_no_of_published_objects_per_type());
        $this->add_reporting_block($this->get_courses_per_category());
        $this->add_reporting_block($this->get_last_access_to_tools_platform());
        $this->add_reporting_block($this->get_no_of_users());
    }

    public function display_context()
    {
    }

    public function get_application()
    {
        return WeblcmsManager :: APPLICATION_NAME;
    }

    public function is_platform()
    {
        return true;
    }

    public function get_no_of_courses()
    {
        $course_weblcms_block = new NoOfCoursesBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }

    public function get_no_of_courses_by_language()
    {
        $course_weblcms_block = new NoOfCoursesByLanguageBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }

    public function get_most_active_inactive_last_visit()
    {
        $course_weblcms_block = new MostActiveInactiveLastVisitBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }

    public function get_most_active_inactive_last_publication()
    {
        $course_weblcms_block = new MostActiveInactiveLastPublicationBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }

    public function get_most_active_inactive_last_detail()
    {
        $course_weblcms_block = new MostActiveInactiveLastDetailBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }

    public function get_no_of_objects_per_type()
    {
        $course_weblcms_block = new NoOfObjectsPerTypeBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }

    public function get_no_of_published_objects_per_type()
    {
        $course_weblcms_block = new NoOfPublishedObjectsPerTypeBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }

    public function get_courses_per_category()
    {
        $course_weblcms_block = new CoursesPerCategoryBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }

    public function get_last_access_to_tools_platform()
    {
        $course_weblcms_block = new LastAccessToToolsPlatformBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }

    public function get_no_of_users()
    {
        $course_weblcms_block = new NoOfUsersSubscribedCourseBlock($this);
        // $course_id = Request :: get(WeblcmsManager::PARAM_COURSE);
        // if ($course_id)
        // {
        // $course_weblcms_block->set_course_id($course_id);
        // $this->add_parameters(WeblcmsManager::PARAM_COURSE, $course_id);
        // }
        return $course_weblcms_block;
    }
}
