<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\Tool;
use application\weblcms\WeblcmsManager;
use application\weblcms\tool\learning_path\LearningPathTool;
use common\libraries\Request;
use reporting\ReportingTemplate;

/**
 * $Id: learning_path_attempt_progress_reporting_template.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.reporting.templates
 */
/**
 *
 * @author Michael Kyndt
 */
class LearningPathAttemptProgressDetailsTemplate extends ReportingTemplate
{

    public function __construct($parent)
    {
        parent :: __construct($parent);
        $this->initialize_parameters();
        $this->add_reporting_block($this->get_learning_path_progress_details());
    }

    private function initialize_parameters()
    {
        $course_id = Request :: get(WeblcmsManager :: PARAM_COURSE);
        if ($course_id)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_COURSE, $course_id);
        }

        $tool = Request :: get(WeblcmsManager :: PARAM_TOOL);
        $this->set_parameter(WeblcmsManager :: PARAM_TOOL, $tool);

        $attempt_id = Request :: get(LearningPathTool :: PARAM_ATTEMPT_ID);
        if ($attempt_id)
        {
            $this->set_parameter(LearningPathTool :: PARAM_ATTEMPT_ID, $attempt_id);
        }

        if ($this->get_parent()->get_parameter(Tool :: PARAM_ACTION) == Tool :: ACTION_VIEW)
        {
            $this->set_parameter('lp_action', 'view_progress');
        }

        $pid = Request :: get(Tool :: PARAM_PUBLICATION_ID);
        $this->set_parameter(Tool :: PARAM_PUBLICATION_ID, $pid);

        $parent_id = Request :: get(Tool :: PARAM_COMPLEX_ID);
        $this->set_parameter(Tool :: PARAM_COMPLEX_ID, $parent_id);
    }

    public function display_context()
    {
    }

    public function get_application()
    {
        return WeblcmsManager :: APPLICATION_NAME;
    }

    public function get_learning_path_progress_details()
    {
        $course_weblcms_block = new LearningPathAttemptProgressDetailsBlock($this);
        return $course_weblcms_block;
    }
}
