<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\ContentObjectPublication;
use application\weblcms\WeblcmsManager;
use common\libraries\Request;
use reporting\ReportingTemplate;
use common\libraries\Breadcrumb;

/**
 * $Id: learning_path_attempts_reporting_template.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.reporting.templates
 */
/**
 *
 * @author Michael Kyndt
 */
class LearningPathAttemptsTemplate extends ReportingTemplate
{

    public function __construct($parent)
    {
        parent :: __construct($parent);

        $this->publication_id = Request :: get(WeblcmsManager :: PARAM_PUBLICATION);
        $this->tool = Request :: get(WeblcmsManager :: PARAM_TOOL);
        $this->add_reporting_block($this->get_learning_path_attempts());

        $lp = \application\weblcms\DataManager :: retrieve(
            ContentObjectPublication :: class_name(),
            $this->publication_id)->get_content_object();

        $custom_breadcrumbs = array();
        $custom_breadcrumbs[] = new Breadcrumb($this->get_url(), $lp->get_title());
        $this->set_custom_breadcrumb_trail($custom_breadcrumbs);
    }

    public function display_context()
    {
    }

    public function get_application()
    {
        return WeblcmsManager :: APPLICATION_NAME;
    }

    public function get_learning_path_attempts()
    {
        $course_weblcms_block = new LearningPathAttemptsBlock($this);
        $course_weblcms_block->set_sorting(0);

        $course_id = Request :: get(WeblcmsManager :: PARAM_COURSE);
        if ($course_id)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_COURSE, $course_id);
        }

        if ($this->publication_id)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_PUBLICATION, $this->publication_id);
        }

        if ($this->tool)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_TOOL, $this->tool);
        }

        return $course_weblcms_block;
    }
}
