<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\Tool;
use application\weblcms\WeblcmsManager;
use application\weblcms\tool\reporting\ReportingTool;
use common\libraries\Breadcrumb;
use common\libraries\BreadcrumbTrail;
use common\libraries\Request;
use common\libraries\Utilities;
use reporting\ReportingTemplate;
use reporting\ReportingManager;
use reporting\Reporting;
use user\UserDataManager;
use common\libraries\Translation;

/**
 * $Id: tool_publications_detail_reporting_template.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.reporting.templates
 */
/**
 *
 * @author Michael Kyndt
 */
class ToolPublicationsDetailTemplate extends ReportingTemplate
{

    public function __construct($parent)
    {
        parent :: __construct($parent);

        $this->tool = Request :: get(ReportingTool :: PARAM_REPORTING_TOOL);
        $this->user_id = Request :: get(WeblcmsManager :: PARAM_USERS);

        $this->add_reporting_block($this->get_tool_publications());

        $this->add_breadcrumbs();
    }

    public function display_context()
    {
    }

    public function get_application()
    {
        return WeblcmsManager :: APPLICATION_NAME;
    }

    public function get_tool_publications()
    {
        $course_weblcms_block = new ToolPublicationsBlock($this);
        $course_weblcms_block->set_sorting(0);

        $course_id = Request :: get(WeblcmsManager :: PARAM_COURSE);
        if ($course_id)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_COURSE, $course_id);
        }
        if ($this->user_id)
        {
            $this->set_parameter(WeblcmsManager :: PARAM_USERS, $this->user_id);
        }
        if ($this->tool)
        {
            $this->set_parameter(ReportingTool :: PARAM_REPORTING_TOOL, $this->tool);
        }
        return $course_weblcms_block;
    }

    /**
     * Adds the breadcrumbs to the breadcrumbtrail
     */
    protected function add_breadcrumbs()
    {
        $trail = BreadcrumbTrail :: get_instance();

        $trail->add(
            new Breadcrumb(
                $this->get_url(
                    array(\reporting\Viewer\Manager :: PARAM_BLOCK_ID => 4),
                    array(ReportingManager :: PARAM_TEMPLATE_ID)
                ),
                Translation :: get('LastAccessToToolsBlock')
            )
        );

        $trail->add(
            new Breadcrumb(
                $this->get_url(), Translation :: get('TypeName', null, Tool :: get_tool_type_namespace($this->tool))
            )
        );
    }
}
