<?php
namespace application\weblcms\integration\reporting;

use application\weblcms\WeblcmsManager;
use reporting\ReportingTemplateRegistration;
use reporting\ReportingTemplate;
use common\libraries\Request;
use repository\ComplexDisplay;

/**
 *
 * @package application.lib.weblcms.reporting.templates
 * @author Michael Kyndt
 */
class WikiPageTemplate extends ReportingTemplate
{

    public function __construct($parent)
    {
        parent :: __construct($parent);

        $complex_content_object_item_id = Request :: get(
            ComplexDisplay :: PARAM_SELECTED_COMPLEX_CONTENT_OBJECT_ITEM_ID);
        if ($complex_content_object_item_id)
        {
            $this->set_parameter(
                ComplexDisplay :: PARAM_SELECTED_COMPLEX_CONTENT_OBJECT_ITEM_ID,
                $complex_content_object_item_id);
        }

        $this->add_reporting_block(new WikiPageMostActiveUsersBlock($this));
        $this->add_reporting_block(new WikiPageUsersContributionsBlock($this));
    }

    public function display_context()
    {
        // publicatie, content_object, application ...
    }

    public function get_application()
    {
        return WeblcmsManager :: APPLICATION_NAME;
    }
}
