<?php
namespace application\weblcms\integration\webservice;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'ContentObjectPublicationCreateWebserviceHandler' => '/lib/content_object_publication/create.class.php',
         'ContentObjectPublicationDeleteWebserviceHandler' => '/lib/content_object_publication/delete.class.php',
         'ContentObjectPublicationGetWebserviceHandler' => '/lib/content_object_publication/get.class.php',
         'ContentObjectPublicationGetListWebserviceHandler' => '/lib/content_object_publication/get_list.class.php',
         'ContentObjectPublicationUpdateWebserviceHandler' => '/lib/content_object_publication/update.class.php',
         'ContentObjectPublicationCategoryCreateWebserviceHandler' => '/lib/content_object_publication_category/create.class.php',
         'ContentObjectPublicationCategoryDeleteWebserviceHandler' => '/lib/content_object_publication_category/delete.class.php',
         'ContentObjectPublicationCategoryGetWebserviceHandler' => '/lib/content_object_publication_category/get.class.php',
         'ContentObjectPublicationCategoryGetListWebserviceHandler' => '/lib/content_object_publication_category/get_list.class.php',
         'ContentObjectPublicationCategoryUpdateWebserviceHandler' => '/lib/content_object_publication_category/update.class.php',
         'CourseGetListWebserviceHandler' => '/lib/course/get_list.class.php',
         'CourseGroupRelationCreateWebserviceHandler' => '/lib/course_group_relation/create.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>