<?php
namespace application\weblcms\integration\webservice;

use common\libraries\Translation;
use common\libraries\CreateObjectWebserviceHandler;

class ContentObjectPublicationCategoryCreateWebserviceHandler extends CreateObjectWebserviceHandler
{

    public function get_object()
    {
        return new \application\weblcms\ContentObjectPublicationCategory();
    }

    public function get_object_translation()
    {
        return Translation :: get('ContentObjectPublicationCategory');
    }

    public function manipulate_data($object, $extra_properties = null)
    {
        return $object;
    }

    public function is_allowed_to_create_object($object)
    {
        if ($this->get_user()->is_platform_admin())
        {
            return true;
        }

        $course = \application\weblcms\course\DataManager :: retrieve_by_id(
            Course :: class_name(), $object->get_course_id()
        );
        return $course->is_course_admin($this->get_user());
    }
}
