<?php

namespace application\weblcms;

use application\weblcms\integration\tracking\CourseVisit;
use common\libraries\AjaxManager;
use tracking\Event;

/**
 * Tracks the time when a course is left
 *
 * @author Sven Vanpoucke
 *
 * @package application.weblcms
 */
class WeblcmsAjaxLeaveCourse extends AjaxManager
{
    const PARAM_COURSE_VISIT_TRACKER_ID = 'course_visit_tracker_id';

    /**
     * Run the AJAX component
     */
    public function run()
    {
        Event :: trigger(
            'leave_course', WeblcmsManager :: context(),
            array(CourseVisit :: PROPERTY_ID => $this->get_parameter(self :: PARAM_COURSE_VISIT_TRACKER_ID))
        );
    }

    /**
     * Get an array of parameters which should be
     * set for this call to work
     * @return array
     */
    public function required_parameters()
    {
        return array(self :: PARAM_COURSE_VISIT_TRACKER_ID);
    }
}