<?php
namespace application\weblcms;

use common\extensions\category_manager\CategoryManager;
use common\libraries\DataClassRetrievesParameters;
use common\libraries\BreadcrumbTrail;

/**
 * $Id: weblcms_category_manager.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.category_manager
 */
class WeblcmsCategoryManager extends CategoryManager
{

    public function __construct($parent)
    {
        $trail = BreadcrumbTrail :: get_instance();

        parent :: __construct($parent, $trail);
    }

    public function get_category()
    {
        return new CourseCategory();
    }

    public function get_category_form()
    {
        return new WeblcmsCategoryForm();
    }

    public function count_categories($condition)
    {
        return DataManager :: count(CourseCategory :: class_name(), $condition);
    }

    public function retrieve_categories($condition, $offset, $count, $order_property)
    {
        return DataManager :: retrieves(
            CourseCategory :: class_name(),
            new DataClassRetrievesParameters($condition, $count, $offset, $order_property)
        );
    }

    // Runs through dataclass
    public function get_next_category_display_order($parent_id)
    {
        return null;
    }

}
