<?php

namespace application\weblcms;



use common\libraries\DataClass;
use common\libraries\Utilities;

/**
 * This class defines that a right on a right location is locked
 *
 * @package application\weblcms;
 *
 * @author Sven Vanpoucke - Hogeschool Gent
 */
class RightsLocationLockedRight extends DataClass
{
    /**
     * **************************************************************************************************************
     * Table Properties *
     * **************************************************************************************************************
     */

    const PROPERTY_LOCATION_ID = 'location_id';
    const PROPERTY_RIGHT_ID = 'right_id';

    /**
     * **************************************************************************************************************
     * Inherited Functionality *
     * **************************************************************************************************************
     */

    /**
     * Returns the default properties of this dataclass
     *
     * @return String[] - The property names.
     */
    static function get_default_property_names($extended_property_names = array())
    {
        $extended_property_names[] = self :: PROPERTY_LOCATION_ID;
        $extended_property_names[] = self :: PROPERTY_RIGHT_ID;

        return parent :: get_default_property_names($extended_property_names);
    }


    /**
     * **************************************************************************************************************
     * Getters and Setters *
     * **************************************************************************************************************
     */

    /**
     * Returns the location_id property of this object
     *
     * @return int
     */
    function get_location_id()
    {
        return $this->get_default_property(self :: PROPERTY_LOCATION_ID);
    }

    /**
     * Sets the location_id property of this object
     *
     * @param $location_id int
     */
    function set_location_id($location_id)
    {
        $this->set_default_property(self :: PROPERTY_LOCATION_ID, $location_id);
    }

    /**
     * Returns the right_id property of this object
     *
     * @return int
     */
    function get_right_id()
    {
        return $this->get_default_property(self :: PROPERTY_RIGHT_ID);
    }

    /**
     * Sets the right_id property of this object
     *
     * @param $right_id int
     */
    function set_right_id($right_id)
    {
        $this->set_default_property(self :: PROPERTY_RIGHT_ID, $right_id);
    }
}

?>
