<?php

namespace application\weblcms;

use common\libraries\Breadcrumb;

use common\libraries\BreadcrumbTrail;

use common\libraries\Translation;
use common\libraries\Request;
use repository\ComplexBuilder;
use repository\RepositoryRights;

/**
 * $Id: complex_builder.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.component
 */
class ToolComponentComplexBuilderComponent extends ToolComponent
{

    private $content_object;

    public function run()
    {
        $pid = Request :: get(Tool :: PARAM_PUBLICATION_ID);

        $publication = DataManager :: retrieve(ContentObjectPublication :: class_name(), $pid);

        $content_object = $publication->get_content_object();
        BreadcrumbTrail :: get_instance()->add(
            new Breadcrumb(
                $this->get_url(), Translation :: get(
                    'ToolComplexBuilderComponent', array(
                        'TITLE' => $content_object->get_title()
                    )
                )
            )
        );
        if (!($content_object->get_owner_id() == $this->get_user_id()) &&
            !RepositoryRights :: get_instance()->is_allowed_in_user_subtree(
                RepositoryRights :: COLLABORATE_RIGHT, $content_object->get_id(),
                RepositoryRights :: TYPE_USER_CONTENT_OBJECT, $content_object->get_owner_id()
            )
        )
        {
            $this->redirect(
                Translation :: get("NotAllowed"), '', array(
                    Tool :: PARAM_PUBLICATION_ID => null,
                    'tool_action'                => null
                )
            );
        }
        else
        {
            $this->content_object = $publication->get_content_object();
            $this->set_parameter(Tool :: PARAM_PUBLICATION_ID, $pid);

            ComplexBuilder :: launch($this->content_object->get_type(), $this);
        }

    }

    public function get_root_content_object()
    {
        return $this->content_object;
    }

}
