<?php
namespace application\weblcms;



use common\libraries\Display;
use common\libraries\Session;
use common\libraries\Translation;
use repository\content_object\introduction\Introduction;
use common\libraries\Utilities;

/**
 * $Id: introduction_publisher.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.component
 */

class ToolComponentIntroductionPublisherComponent extends ToolComponent implements \repository\viewer\ViewerInterface
{

    public function run()
    {
        if (!$this->is_allowed(WeblcmsRights :: ADD_RIGHT))
        {
            Display :: not_allowed();
            return;
        }

        if (!\repository\viewer\Manager :: is_ready_to_be_published())
        {
            $repository_viewer = \repository\viewer\Manager :: construct($this);
            $repository_viewer->set_maximum_select(\repository\viewer\Manager :: SELECT_SINGLE);
            $repository_viewer->set_parameter(Tool :: PARAM_ACTION, Tool :: ACTION_PUBLISH_INTRODUCTION);
            $repository_viewer->run();
        }
        else
        {
            $pub = new ContentObjectPublication();
            $pub->set_content_object_id(\repository\viewer\Manager :: get_selected_objects());
            $pub->set_course_id($this->get_course_id());
            $pub->set_tool($this->get_tool_id());
            $pub->set_category_id(0);
            $pub->set_from_date(0);
            $pub->set_to_date(0);
            $pub->set_publisher_id(Session :: get_user_id());
            $pub->set_publication_date(time());
            $pub->set_modified_date(time());
            $pub->set_hidden(0);
            $pub->set_email_sent(false);
            $pub->set_show_on_homepage(0);

            $pub->ignore_display_order();

            $pub->create();

            $parameters = $this->get_parameters();
            $parameters['tool_action'] = null;

            $this->redirect(
                Translation :: get(
                    'ObjectPublished', array(
                        'OBJECT' => Translation :: get('Introduction')
                    ), Utilities :: COMMON_LIBRARIES
                ), (false), $parameters
            );
        }
    }

    public function get_allowed_content_object_types()
    {
        return array(Introduction :: class_name());
    }
}
