<?php

namespace application\weblcms;

use common\libraries\Request;
use common\libraries\NotAllowedException;
use common\libraries\Translation;

/**
 * $Id: move.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.component
 */
class ToolComponentMoverComponent extends ToolComponent
{
    /**
     * Executes this controller
     *
     * @throws \common\libraries\NotAllowedException
     */
    public function run()
    {
        $publication_id = Request :: get(Tool :: PARAM_PUBLICATION_ID);
        $publication = DataManager :: retrieve(ContentObjectPublication :: class_name(), $publication_id);

        if (!$this->is_allowed(WeblcmsRights :: EDIT_RIGHT, $publication))
        {
            throw new NotAllowedException();
        }

        $move = $this->get_parent()->get_move_direction();

        if ($publication->move($move))
        {
            $message = htmlentities(Translation :: get('ContentObjectPublicationMoved'));
        }

        $this->redirect(
            $message, false, array(
                Tool :: PARAM_ACTION       => null,
                Tool :: PARAM_BROWSER_TYPE => Request :: get(Tool :: PARAM_BROWSER_TYPE)
            )
        );
    }

}
