<?php

namespace application\weblcms;

use common\libraries\Request;
use common\libraries\Translation;

/**
 * $Id: toggle_visibility.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.component
 */
class ToolComponentToggleVisibilityComponent extends ToolComponent
{

    public function run()
    {

        if (Request :: get(Tool :: PARAM_PUBLICATION_ID))
        {
            $publication_ids = Request :: get(Tool :: PARAM_PUBLICATION_ID);
        }
        else
        {
            $publication_ids = $_POST[Tool :: PARAM_PUBLICATION_ID];
        }

        if (isset($publication_ids))
        {
            if (!is_array($publication_ids))
            {
                $publication_ids = array($publication_ids);
            }

            $failures = 0;

            foreach ($publication_ids as $pid)
            {
                $publication = DataManager :: retrieve(ContentObjectPublication :: class_name(), $pid);

                if ($this->is_allowed(WeblcmsRights :: EDIT_RIGHT, $publication))
                {

                    if (!$this instanceof ToolComponentToggleVisibilityComponent)
                    {
                        $publication->set_hidden($this->get_hidden());
                    }
                    else
                    {
                        $publication->toggle_visibility();
                    }

                    $publication->update();
                }
                else
                {
                    $message = htmlentities(Translation :: get('NotAllowed'));
                    $failures++;
                }
            }
            if ($failures == 0)
            {
                if (count($publication_ids) > 1)
                {
                    $message = htmlentities(Translation :: get('ContentObjectPublicationsVisibilityChanged'));
                }
                else
                {
                    $message = htmlentities(Translation :: get('ContentObjectPublicationVisibilityChanged'));
                }
            }

            $params = array();
            $params['tool_action'] = null;
            if (Request :: get('details') == 1)
            {
                $params[Tool :: PARAM_PUBLICATION_ID] = $pid;
                $params['tool_action'] = 'view';
            }

            $this->redirect($message, $failures > 0, $params);
        }
        else
        {
            $this->display_header();
            $this->display_error_message(Translation :: get('NoObjectsSelected'));
            $this->display_footer();
        }
    }

}
