<?php
namespace application\weblcms;

use common\libraries\Request;
use common\libraries\DataClassRetrievesParameters;
use common\libraries\ObjectTableDataProvider;

/**
 * $Id: admin_course_type_browser_table_data_provider.class.php 218 2010-03-10
 * 14:21:26Z yannick $
 *
 * @package
 *          application.lib.weblcms.weblcms_manager.component.admin_course_type_browser
 */
/**
 * Data provider for a repository browser table.
 *
 * This class implements some functions to allow repository browser tables to
 * retrieve information about the learning objects to display.
 */
class AdminRequestBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     *
     * @param $browser WeblcmsManagerComponent
     * @param $condition Condition
     */
    /*function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }*/

    /**
     * Gets the coursetypes
     *
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching coursetypes.
     */

    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        return DataManager :: retrieves(
            $this->get_data_class_name(),
            new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property)
        );
    }

    /**
     * Gets the number of coursetypes in the table
     *
     * @return int
     */

    public function get_object_count()
    {
        return DataManager :: count($this->get_data_class_name(), $this->get_condition());
    }

    /**
     * Returns the data class name that must be used in the data provider depending on the request type
     *
     * @return string
     */
    protected function get_data_class_name()
    {
        switch ($this->get_browser()->get_request_type())
        {
            case CommonRequest :: SUBSCRIPTION_REQUEST :
                $class_name = CourseRequest :: class_name();
                break;
            case CommonRequest :: CREATION_REQUEST :
                $class_name = CourseCreateRequest :: class_name();
                break;
        }

        return $class_name;
    }

}
