<?php

namespace application\weblcms;

use common\libraries\Translation;
use common\libraries\DeleteObjectWebserviceHandler;

class ContentObjectPublicationDeleteWebserviceHandler extends DeleteObjectWebserviceHandler
{

    public function get_object()
    {
        return DataManager :: retrieve(ContentObjectPublication :: class_name(), $this->get_id());
    }

    public function get_object_translation()
    {
        return Translation :: get('ContentObjectPublication');
    }

    public function is_allowed_to_delete_object($object)
    {
        if ($this->get_user()->is_platform_admin())
        {
            return true;
        }

        $course = \application\weblcms\course\DataManager :: retrieve(Course :: class_name(), $object->get_course_id());
        return $course->is_course_admin($this->get_user());
    }

}
