<?php
namespace application\weblcms\tool\announcement;

use application\weblcms\ContentObjectPublication;
use common\libraries\NotAllowedException;
use common\libraries\Request;
use common\libraries\DelegateComponent;

use application\weblcms\ToolComponent;
use application\weblcms\Tool;


class AnnouncementToolShareContentObjectsComponent extends AnnouncementTool implements DelegateComponent
{

    public function run()
    {
        $publication_id = Request::get(Tool::PARAM_PUBLICATION_ID);

        $publication = \application\weblcms\DataManager :: retrieve(
            ContentObjectPublication :: class_name(),
            $publication_id
        );

        if ($publication->get_content_object()->get_owner_id() != $this->get_user_id())
        {
            throw new NotAllowedException();
        }
        ToolComponent :: launch($this);
    }

    public function get_additional_parameters()
    {
        return array(Tool :: PARAM_PUBLICATION_ID);
    }
}
