<?php
namespace application\weblcms\tool\assessment;




/**
 * $Id: export.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package
 *          application.lib.weblcms.tool.assessment.component.assessment_results_export_form
 */

abstract class ResultsExport
{
    const FILETYPE_CSV = 'csv';
    const FILETYPE_PDF = 'pdf';
    const FILETYPE_XML = 'xml';

    protected $rdm;

    public function __construct()
    {
        $this->rdm = \repository\DataManager :: get_instance();
    }

    public function export_results($type, $id)
    {
        if ($type == 'assessment')
        {
            $data = $this->export_publication_id($id);
        }
        else
        {
            $data = $this->export_user_assessment_id($id);
        }
        return $data;
    }

    abstract public function export_publication_id($id);

    abstract public function export_user_assessment_id($id);

    public function factory($filetype)
    {
        switch ($filetype)
        {
            case self :: FILETYPE_XML :
                return new ResultsXmlExport();
            case self :: FILETYPE_CSV :
                return new ResultsCsvExport();
            case self :: FILETYPE_PDF :
                return new ResultsPdfExport();
            default :
                return null;
        }
        return null;
    }
}
