<?php
namespace application\weblcms\tool\assessment;

use repository\ContentObjectExportController;
use application\weblcms\ContentObjectPublication;

use repository\ExportParameters;


use application\weblcms\WeblcmsRights;

use common\libraries\Display;
use common\libraries\Request;

use repository\ContentObjectExport;

/**
 * $Id: assessment_qti_export.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.assessment.component
 */
class AssessmentToolQtiExporterComponent extends AssessmentTool
{

    public function run()
    {
        $pid = Request :: get(AssessmentTool :: PARAM_PUBLICATION_ID);
        $publication = \application\weblcms\DataManager :: retrieve(
            ContentObjectPublication :: class_name(),
            $pid
        );

        if (!$this->is_allowed(WeblcmsRights :: EDIT_RIGHT, $publication))
        {
            Display :: not_allowed();
            return;
        }

        //$assessment = $publication->get_content_object();
        $export_parameters = new ExportParameters(
            $this->get_user_id(), ContentObjectExport :: FORMAT_QTI, $publication->get_content_object_id()
        );
        $exporter = ContentObjectExportController :: factory($export_parameters);
        $exporter->download();
    }
}
