<?php

namespace application\weblcms\tool\assignment;

use common\libraries\ObjectTableFormAction;
use application\weblcms\WeblcmsRights;
use common\libraries\TableFormActionsSupport;
use common\libraries\RecordTable;
use common\libraries\ObjectTableFormActions;
use common\libraries\Translation;

/**
 * Abstract table to browse a list of submitters.
 *
 * @package application.weblcms.tool.assignment.php.component.submission_browser
 *
 * @author Joris Willems <joris.willems@gmail.com>
 * @author Alexander Van Paemel
 * @author Anthony Hurst (Hogeschool Gent)
 *
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring to RecordTable
 */
abstract class SubmissionBrowserTable extends RecordTable implements TableFormActionsSupport
{
    /**
     * The identifier for the table (used for table actions)
     */
    const TABLE_IDENTIFIER = AssignmentTool :: PARAM_TARGET_ID;

    /****************************************************************************************************************
     * Inherited Functionality                                                                                      *
     ****************************************************************************************************************/

    /**
     * Returns the available table actions
     */
    public function get_implemented_form_actions()
    {
        $actions = new ObjectTableFormActions(__NAMESPACE__, AssignmentTool :: PARAM_ACTION);

        if ($this->get_component()->is_allowed(WeblcmsRights :: EDIT_RIGHT))
        {
            $actions->add_form_action(
                new ObjectTableFormAction(
                    AssignmentTool :: ACTION_DOWNLOAD_SUBMISSIONS, Translation :: get('DownloadSubmissionsSelected'),
                    false
                )
            );
        }

        return $actions;
    }
}
