<?php
namespace application\weblcms\tool\assignment;

use application\weblcms\tool\assignment\AssignmentTool;

use common\libraries\RecordTableColumnModel;
use common\libraries\NewTableColumn;
use common\libraries\TableColumnModelActionsColumnSupport;

/**
 * Abstract table column model for the submitters browser table
 *
 * @package application.weblcms.tool.assignment.php.component.submission_browser
 *
 * @author Joris Willems <joris.willems@gmail.com>
 * @author Alexander Van Paemel
 * @author Anthony Hurst (Hogeschool Gent)
 *
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring
 */
abstract class SubmissionBrowserTableColumnModel extends RecordTableColumnModel
    implements TableColumnModelActionsColumnSupport
{
    /**
     * Initializes the columns for the table
     */
    public function initialize_columns()
    {
        $this->add_column(new NewTableColumn(AssignmentTool :: PROPERTY_FIRST_SUBMISSION, null, true, ''));
        $this->add_column(new NewTableColumn(AssignmentTool :: PROPERTY_LAST_SUBMISSION, null, true, ''));
        $this->add_column(new NewTableColumn(AssignmentTool :: PROPERTY_NUMBER_OF_SUBMISSIONS, null, true, ''));
        $this->add_column(new NewTableColumn(AssignmentTool :: PROPERTY_NUMBER_OF_FEEDBACKS, null, false, ''));
    }
}
