<?php
namespace application\weblcms\tool\assignment;

use common\libraries\ObjectTableOrder;

use application\weblcms\tool\course_group\CourseGroup;

/**
 * @package application.weblcms.tool.assignment.php.component.submission_browser
 *
 * Data provider for a course group submissions browser table.
 *
 * @author Joris Willems <joris.willems@gmail.com>
 * @author Alexander Van Paemel
 *
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring to RecordTable
 */
class SubmissionCourseGroupsBrowserTableDataProvider extends SubmissionBrowserTableDataProvider
{
    /****************************************************************************************************************
     * Inherited Functionality                                                                                      *
     ****************************************************************************************************************/

    /**
     * Returns the order properties for this data provider
     *
     * @param ObjectTableOrder[] $order_properties
     *
     * @return ObjectTableOrder[]
     */
    public function get_order_properties($order_properties = array())
    {
        $order_properties[] = new ObjectTableOrder(
            CourseGroup :: PROPERTY_NAME, SORT_ASC,
            \application\weblcms\DataManager :: get_instance()->get_alias(CourseGroup::get_table_name())
        );

        return $order_properties;
    }

    /**
     * Calls the datamanager to retrieve the actual data
     *
     *
     * @param int $publication_id
     * @param int $course_id
     * @param int $offset
     * @param int $count
     * @param ObjectTableOrder[] $order_properties
     * @param Condition $condition
     *
     * @return RecordResultSet
     */
    public function retrieve_from_data_manager($publication_id, $course_id, $offset, $count, $order_properties, $condition)
    {
        return DataManager :: retrieve_assignment_publication_target_course_groups(
            $publication_id, $course_id, $offset, $count, $order_properties, $condition
        );
    }
}
