<?php

namespace application\weblcms\tool\assignment;

use application\weblcms\ObjectPublicationTableColumnModel;
use common\libraries\NewTableColumn;
use common\libraries\DataClassPropertyTableColumn;
use repository\content_object\assignment\Assignment;

/**
 * Extension on the content object publication table column model for this tool
 *
 * @author Sven Vanpoucke - Hogeschool Gent
 */
class PublicationTableColumnModel extends ObjectPublicationTableColumnModel
{
    /****************************************************************************************************************
     * Inherited Functionality                                                                                      *
     ****************************************************************************************************************/

    /**
     * Initializes the columns for the table
     */
    public function initialize_columns()
    {
        parent :: initialize_columns();

        $this->add_column(
            new DataClassPropertyTableColumn(Assignment :: class_name(), Assignment :: PROPERTY_END_TIME, null, false)
        );

        $this->add_column(
            new NewTableColumn(AssignmentTool :: PROPERTY_NUMBER_OF_SUBMISSIONS, null, false)
        );

        $this->add_column(
            new DataClassPropertyTableColumn(
                Assignment :: class_name(), Assignment :: PROPERTY_ALLOW_GROUP_SUBMISSIONS, null, false
            ),
            1
        );
    }
}