<?php
namespace application\weblcms\tool\calendar;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'CalendarTool' => '/lib/calendar_tool.class.php',
         'CalendarToolAttachmentViewerComponent' => '/lib/component/attachment_viewer.class.php',
         'CalendarToolBrowserComponent' => '/lib/component/browser.class.php',
         'CalendarToolContentObjectUpdaterComponent' => '/lib/component/content_object_updater.class.php',
         'CalendarToolDeleterComponent' => '/lib/component/deleter.class.php',
         'CalendarToolEvaluateComponent' => '/lib/component/evaluate.class.php',
         'CalendarToolHidePublicationComponent' => '/lib/component/hide_publication.class.php',
         'CalendarToolIntroductionPublisherComponent' => '/lib/component/introduction_publisher.class.php',
         'CalendarToolMoverComponent' => '/lib/component/mover.class.php',
         'CalendarToolPublicationUpdaterComponent' => '/lib/component/publication_updater.class.php',
         'CalendarToolPublisherComponent' => '/lib/component/publisher.class.php',
         'CalendarToolReportingViewerComponent' => '/lib/component/reporting_viewer.class.php',
         'CalendarToolRightsEditorComponent' => '/lib/component/rights_editor.class.php',
         'CalendarToolShareContentObjectsComponent' => '/lib/component/share_content_objects.class.php',
         'CalendarToolShowPublicationComponent' => '/lib/component/show_publication.class.php',
         'CalendarToolToggleVisibilityComponent' => '/lib/component/toggle_visibility.class.php',
         'CalendarToolUpdaterComponent' => '/lib/component/updater.class.php',
         'CalendarToolViewerComponent' => '/lib/component/viewer.class.php',
         'CalendarBrowser' => '/lib/component/calendar_viewer/calendar_browser.class.php',
         'CalendarDetailsRenderer' => '/lib/component/calendar_viewer/calendar_details_renderer.class.php',
         'CalendarListRenderer' => '/lib/component/calendar_viewer/calendar_list_renderer.class.php',
         'DataManager' => '/lib/storage/data_manager/data_manager.class.php',
         'DoctrineDataManager' => '/lib/storage/data_manager/implementation/doctrine.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>