<?php
namespace application\weblcms\tool\course_group;

use application\weblcms\Tool;


use common\libraries\Translation;

/**
 * $Id: course_group_self_subscriber.class.php 216 2009-11-13 14:08:06Z kariboe $
 * @package application.lib.weblcms.tool.course_group.component
 */
class CourseGroupToolSelfSubscriberComponent extends CourseGroupTool
{

    public function run()
    {
        $course_group = $this->get_course_group();

        if($course_group->is_self_registration_allowed() &&
            ($course_group->count_members() < $course_group->get_max_number_of_members() ||
                $course_group->get_max_number_of_members() == 0) && ! $course_group->is_member($this->get_user()) &&
            DataManager :: more_subscriptions_allowed_for_user_in_group(
                $course_group->get_parent_id(), $this->get_user_id()
            ))
        {
            $course_group->subscribe_users($this->get_user());
            $this->redirect(
                Translation :: get('UserSubscribed'), false,
                array(
                    Tool :: PARAM_ACTION => CourseGroupTool :: ACTION_UNSUBSCRIBE,
                    CourseGroupTool :: PARAM_COURSE_GROUP => $course_group->get_id()
                )
            );
        }
        else
        {
            $this->redirect(
                Translation :: get('UserNotSubscribed'), true,
                array(
                    Tool :: PARAM_ACTION => CourseGroupTool :: DEFAULT_ACTION,
                    CourseGroupTool :: PARAM_COURSE_GROUP => $course_group->get_parent_id()
                )
            );
        }
    }

}
