<?php
namespace application\weblcms\tool\course_group;


use application\weblcms\tool\course_group\CourseGroup;
use application\weblcms\Tool;
use common\libraries\Request;

/**
 * $Id: course_group_tool.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.course_group
 */
/**
 * This tool allows a course_group to publish course_groups in his or her
 * course.
 */
class CourseGroupTool extends Tool
{
    const TOOL_NAME = 'course_group';

    const PARAM_COURSE_GROUP_ACTION = 'tool_action';
    const PARAM_DELETE_COURSE_GROUPS = 'delete_course_groups';
    const PARAM_UNSUBSCRIBE_USERS = 'unsubscribe_users';

    const ACTION_SUBSCRIBE = 'subscribe_browser';
    const ACTION_UNSUBSCRIBE = 'unsubscribe_browser';
    const ACTION_ADD_COURSE_GROUP = 'creator';
    const ACTION_EDIT_COURSE_GROUP = 'editor';
    const ACTION_DELETE_COURSE_GROUP = 'deleter';
    const ACTION_USER_SELF_SUBSCRIBE = 'self_subscriber';
    const ACTION_USER_SELF_UNSUBSCRIBE = 'self_unsubscriber';
    const ACTION_VIEW_GROUPS = 'browser';
    const ACTION_MANAGE_SUBSCRIPTIONS = 'manage_subscriptions';

    const ACTION_SUBSCRIPTIONS_OVERVIEW = 'subscriptions_overviewer';
    const ACTION_EXPORT_SUBSCRIPTIONS_OVERVIEW = 'exporter';

    const PARAM_COURSE_GROUP = 'course_group';
    const PARAM_TAB = 'tab';

    public function __construct($parent)
    {
        parent :: __construct($parent);
        $this->set_parameter(self :: PARAM_COURSE_GROUP, Request :: get(self :: PARAM_COURSE_GROUP));

    }

    public function get_course_group()
    {
        $course_group_id = Request :: get(CourseGroupTool :: PARAM_COURSE_GROUP);

        return \application\weblcms\DataManager :: retrieve(
            CourseGroup :: class_name(),
            $course_group_id
        );
    }

    /**
     * Helper function for the SubManager class,
     * pending access to class constants via variables in PHP 5.3
     * e.g.
     * $name = $class :: DEFAULT_ACTION
     *
     * DO NOT USE IN THIS SUBMANAGER'S CONTEXT
     * Instead use:
     * - self :: DEFAULT_ACTION in the context of this class
     * - YourSubManager :: DEFAULT_ACTION in all other application classes
     */
    public static function get_default_action()
    {
        return self :: DEFAULT_ACTION;
    }

    /**
     * Helper function for the SubManager class,
     * pending access to class constants via variables in PHP 5.3
     * e.g.
     * $name = $class :: PARAM_ACTION
     *
     * DO NOT USE IN THIS SUBMANAGER'S CONTEXT
     * Instead use:
     * - self :: PARAM_ACTION in the context of this class
     * - YourSubManager :: PARAM_ACTION in all other application classes
     */
    public static function get_action_parameter()
    {
        return self :: PARAM_ACTION;
    }
}
