<?php

namespace application\weblcms\tool\course_group;

use common\libraries\RecordTableColumnModel;
use common\libraries\Translation;
use user\User;
use common\libraries\DataClassPropertyTableColumn;

/**
 * Table column model for the course users table
 *
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring from ObjectTable to RecordTable
 */
class CourseUsersTableColumnModel extends RecordTableColumnModel
{
    const DEFAULT_ORDER_COLUMN_INDEX = 1;

    /**
     * Initializes the columns for the table
     */
    public function initialize_columns()
    {
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_OFFICIAL_CODE));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_USERNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_LASTNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_FIRSTNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_EMAIL));

        $this->add_column(
            new DataClassPropertyTableColumn(
                CourseGroup :: class_name(), CourseGroup :: PROPERTY_ID, Translation :: get('CourseGroups')
            )
        );
    }

}