<?php
namespace application\weblcms\tool\course_group;

use application\weblcms\WeblcmsRights;
use application\weblcms\WeblcmsManager;
use common\libraries\ObjectTableFormAction;
use common\libraries\NewObjectTableFormActionsSupport;
use common\libraries\ObjectTableFormActions;
use common\libraries\NewObjectTable;
use common\libraries\Translation;

/**
 * $Id: course_group_subscribed_user_browser_table.class.php 216 2009-11-13 14:08:06Z kariboe $
 * @package application.lib.weblcms.tool.course_group.component.user_table
 */
class CourseGroupSubscribedUserBrowserTable extends NewObjectTable implements NewObjectTableFormActionsSupport
{
    const TABLE_IDENTIFIER = WeblcmsManager :: PARAM_USERS;

    public function get_implemented_form_actions()
    {
        $actions = new ObjectTableFormActions(__NAMESPACE__, WeblcmsManager :: PARAM_TOOL_ACTION);
        $browser = $this->get_component();
        if ($browser->is_allowed(WeblcmsRights :: EDIT_RIGHT))
        {
            $actions->add_form_action(
                new ObjectTableFormAction(
                    CourseGroupTool :: ACTION_UNSUBSCRIBE,
                    Translation :: get('UnsubscribeUsers')
                )
            );
        }

        return $actions;
    }
}
