<?php
namespace application\weblcms\tool\course_group;

use user\DefaultUserTableColumnModel;
use common\libraries\StaticTableColumn;
use common\libraries\ObjectTableColumn;
use user\User;

/**
 * $Id: course_group_unsubscribed_user_browser_table_column_model.class.php 216
 * 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.course_group.component.user_table
 */
class CourseGroupUnsubscribedUserBrowserTableColumnModel extends DefaultUserTableColumnModel
{
    /**
     * The tables modification column
     */
    private static $modification_column;

    /**
     * Constructor
     */
    public function __construct()
    {
        parent :: __construct();
        $this->add_column(new ObjectTableColumn(User :: PROPERTY_USERNAME, true, null, true, User::context()));
        $this->add_column(new ObjectTableColumn(User :: PROPERTY_EMAIL, true, null, true, User::context()));
        $this->set_default_order_column(1);
        $this->add_column(self :: get_modification_column());
    }

    /**
     * Gets the modification column
     *
     * @return ContentObjectTableColumn
     */
    public static function get_modification_column()
    {
        if (!isset(self :: $modification_column))
        {
            self :: $modification_column = new StaticTableColumn('');
        }
        return self :: $modification_column;
    }
}
