<?php
namespace application\weblcms\tool\course_group;

use application\weblcms\tool\course_group\DataManager as CourseGroupDataManager;
use common\libraries\NewObjectTableDataProvider;

/**
 * $Id: course_group_unsubscribed_user_browser_table_data_provider.class.php 216
 * 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.course_group.component.user_table
 */
class CourseGroupUnsubscribedUserBrowserTableDataprovider extends NewObjectTableDataProvider
{
    /**
     * Constructor
     *
     * @param $browser WeblcmsManagerComponent
     * @param $condition Condition
     */
    public function __construct($obj_table) //$browser, $condition)
    {
        parent :: __construct($obj_table); //$browser, $condition);
    }

    /**
     * Gets the users
     *
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching learning objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);

        return CourseGroupDataManager :: retrieve_possible_course_group_users(
            $this->get_object_tabel()->get_component()->get_course_group(), $this->get_condition(), $offset, $count,
            $order_property
        );
    }

    /**
     * Gets the number of users in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return CourseGroupDataManager :: count_possible_course_group_users(
            $this->get_object_tabel()->get_component()->get_course_group(), $this->get_condition()
        );
    }
}
