<?php
namespace application\weblcms\tool\course_sections;


use common\libraries\DataClassRetrievesParameters;
use common\libraries\ObjectTableOrder;
use application\weblcms\CourseSection;
use common\libraries\ObjectTableDataProvider;

/**
 * $Id: course_sections_browser_table_data_provider.class.php 216 2009-11-13
 * 14:08:06Z kariboe $
 *
 * @package
 *          application.lib.weblcms.tool.course_sections.component.course_sections_browser
 */
/**
 * Data provider for a repository browser table.
 *
 * This class implements some functions to allow repository browser tables to
 * retrieve information about the learning objects to display.
 */
class CourseSectionsBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Gets the courses
     *
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching courses.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = array(new ObjectTableOrder(CourseSection :: PROPERTY_DISPLAY_ORDER));

        return \application\weblcms\DataManager :: retrieves(
            CourseSection :: class_name(),
            new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property)
        );
    }

    /**
     * Gets the number of courses in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return \application\weblcms\DataManager :: count(
            CourseSection :: class_name(), $this->get_condition()
        );
    }
}
