<?php
namespace application\weblcms\tool\course_sections;

use common\libraries\DelegateComponent;

use common\libraries\ActionBarRenderer;
use common\libraries\ToolbarItem;
use common\libraries\Theme;
use common\libraries\EqualityCondition;
use common\libraries\Translation;
use common\libraries\Utilities;
use application\weblcms\CourseSection;

/**
 * $Id: course_sections_viewer.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.course_sections.component
 */
class CourseSectionsToolViewerComponent extends CourseSectionsTool implements DelegateComponent
{
    private $action_bar;

    public function run()
    {
        if (!$this->get_course()->is_course_admin($this->get_parent()->get_user()))
        {
            throw new \common\libraries\NotAllowedException();
        }

        $this->action_bar = $this->get_action_bar();
        $table = $this->get_table_html();

        $this->display_header();
        echo '<br />';
        echo $this->action_bar->as_html();
        echo '<div id="action_bar_browser">';
        echo $table;
        echo '</div>';
        $this->display_footer();
    }

    public function get_action_bar()
    {
        $action_bar = new ActionBarRenderer(ActionBarRenderer :: TYPE_HORIZONTAL);

        $action_bar->set_search_url($this->get_url());
        $action_bar->add_common_action(
            new ToolbarItem(
                Translation :: get('Create', null, Utilities :: COMMON_LIBRARIES),
                Theme :: get_common_image_path() . 'action_publish.png', $this->get_url(
                    array(
                        CourseSectionsTool :: PARAM_ACTION => CourseSectionsTool :: ACTION_CREATE_COURSE_SECTION
                    )
                ), ToolbarItem :: DISPLAY_ICON_AND_LABEL
            )
        );
        $action_bar->add_common_action(
            new ToolbarItem(
                Translation :: get('ShowAll', null, Utilities :: COMMON_LIBRARIES),
                Theme :: get_common_image_path() . 'action_browser.png', $this->get_url(
                ), ToolbarItem :: DISPLAY_ICON_AND_LABEL
            )
        );
        return $action_bar;
    }

    public function get_table_html()
    {
        $table = new CourseSectionsBrowserTable($this, array(), $this->get_condition());

        $html = array();
        $html[] = '<div style="float: right; width: 100%;">';
        $html[] = $table->as_html();
        $html[] = '</div>';

        return implode($html, "\n");
    }

    public function get_condition()
    {
        return new EqualityCondition(CourseSection :: PROPERTY_COURSE_ID, $this->get_course_id());
    }
}
