<?php
namespace application\weblcms\tool\course_sections;


use common\libraries\EqualityCondition;
use application\weblcms\CourseSection;
use common\libraries\Request;
use common\libraries\Translation;

/**
 * $Id: course_sections_visibility_changer.class.php 216 2009-11-13 14:08:06Z
 * kariboe $
 *
 * @package application.lib.weblcms.tool.course_sections.component
 */
class CourseSectionsToolVisibilityChangerComponent extends CourseSectionsTool
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        if (!$this->get_course()->is_course_admin($this->get_parent()->get_user()))
        {
            throw new \common\libraries\NotAllowedException();
        }

        $ids = Request :: get(CourseSectionsTool :: PARAM_COURSE_SECTION_ID);
        $failures = 0;

        if (!empty($ids))
        {
            if (!is_array($ids))
            {
                $ids = array($ids);
            }

            foreach ($ids as $id)
            {
                $course_section = \application\weblcms\DataManager :: retrieves(
                    CourseSection :: class_name(),
                    new EqualityCondition('id', $id)
                )->next_result();

                $course_section->set_visible(!$course_section->is_visible());

                if (!$course_section->update())
                {
                    $failures++;
                }
            }

            if ($failures)
            {
                if (count($ids) == 1)
                {
                    $message = 'SelectedCourseSectionVisibilityChanged';
                }
                else
                {
                    $message = 'SelectedCourseSectionVisibilityChanged';
                }
            }
            else
            {
                if (count($ids) == 1)
                {
                    $message = 'SelectedCourseSectionsVisibilityChanged';
                }
                else
                {
                    $message = 'SelectedCourseSectionsVisibilityChanged';
                }
            }

            $this->redirect(
                Translation :: get($message), ($failures != 0 ? true : false), array(
                    CourseSectionsTool :: PARAM_ACTION => CourseSectionsTool :: ACTION_VIEW_COURSE_SECTIONS
                )
            );
        }
        else
        {
            $this->display_error_page(htmlentities(Translation :: get('NoCourseSectionsSelected')));
        }
    }
}
