<?php
namespace application\weblcms\tool\course_settings;

use common\libraries\Request;
use application\weblcms\course\CourseManager;
use application\weblcms\course\CourseSubManagerSupport;
use common\libraries\DelegateComponent;
use common\libraries\NotAllowedException;


/**
 * $Id: course_settings_updater.class.php 216 2009-11-13 14:08:06Z kariboe $
 * @package application.lib.weblcms.tool.course_settings.component
 */

class CourseSettingsToolUpdaterComponent extends CourseSettingsTool
    implements DelegateComponent, CourseSubManagerSupport
{

    public function run()
    {
        if (!$this->get_course()->is_course_admin($this->get_user()))
        {
            throw new NotAllowedException();
        }

        Request :: set_get(CourseManager :: PARAM_ACTION, CourseManager :: ACTION_QUICK_UPDATE);
        Request :: set_get(CourseManager :: PARAM_COURSE_ID, $this->get_course_id());

        CourseManager :: launch($this);
    }

    public function redirect_after_quick_create($succes, $message)
    {
        $this->redirect($message, !$succes, array(), array(self :: PARAM_ACTION, self :: ACTION_UPDATE));
    }

    /**
     * Redirects the submanager to another component after a quick update
     *
     * @param boolean $succes
     * @param String $message
     */
    public function redirect_after_quick_update($succes, $message)
    {
        $this->redirect_after_quick_create($succes, $message);
    }
}
