<?php
namespace application\weblcms\tool\forum;

use application\weblcms\WeblcmsRights;
use common\extensions\category_manager\CategoryManager;
use application\weblcms\ContentObjectPublicationCategoryManager;
use application\weblcms\Tool;
use common\libraries\Display;
use common\libraries\DelegateComponent;

class ForumToolCategoryManagerComponent extends ForumTool implements DelegateComponent
{

    public function run()
    {
        if (!$this->is_allowed(WeblcmsRights :: EDIT_RIGHT))
        {
            Display :: not_allowed();
            return;
        }

        $category_manager = new ContentObjectPublicationCategoryManager($this, null, false);
        $category_manager->run();
    }

    public function get_additional_parameters()
    {
        return array(CategoryManager :: PARAM_CATEGORY_ID);
    }

}
