<?php
namespace application\weblcms\tool\glossary;

use application\weblcms\Tool;
use common\libraries\Breadcrumb;
use common\libraries\BreadcrumbTrail;
use common\libraries\Request;
use application\weblcms\ToolComponent;
use common\libraries\DelegateComponent;
use common\libraries\Translation;

class GlossaryToolReportingViewerComponent extends GlossaryTool implements DelegateComponent
{

    public function run()
    {
        ToolComponent :: launch($this);
    }

    public function add_additional_breadcrumbs(BreadcrumbTrail $breadcrumbtrail)
    {
        $breadcrumbtrail->add(
            new Breadcrumb(
                $this->get_url(array(Tool :: PARAM_ACTION => Tool :: ACTION_BROWSE)),
                Translation :: get('GlossaryToolBrowserComponent')
            )
        );

        $breadcrumbtrail->add(
            new Breadcrumb(
                $this->get_url(
                    array(
                        Tool :: PARAM_ACTION => Tool :: ACTION_VIEW,
                        Tool :: PARAM_PUBLICATION_ID => Request :: get(Tool :: PARAM_PUBLICATION_ID)
                    )
                ),
                Translation :: get('GlossaryToolViewerComponent')
            )
        );
    }

    public function get_additional_parameters()
    {
        return array(Tool :: PARAM_PUBLICATION_ID, Tool :: PARAM_COMPLEX_ID, Tool :: PARAM_TEMPLATE_NAME);
    }
}
