<?php
namespace application\weblcms\tool\home;

use application\weblcms\Tool;
use application\weblcms\ContentObjectPublication;
use common\libraries\Request;
use common\libraries\Translation;

class HomeToolLinksDeleterComponent extends HomeTool
{

    public function run()
    {
        $pub_id = Request :: get(Tool :: PARAM_PUBLICATION_ID);

        $publication = \application\weblcms\DataManager :: retrieve(
            ContentObjectPublication :: class_name(),
            $pub_id
        );

        $publication->set_show_on_homepage(0);
        $succes = $publication->update();

        $message = $succes ? 'PublicationRemovedFromHomepage' : 'PublicationNotRemovedFromHomepage';

        $this->redirect(
            Translation :: get($message), !$succes, array(
                HomeTool :: PARAM_ACTION => HomeTool :: ACTION_BROWSE
            )
        );
    }
}
