<?php
namespace application\weblcms\tool\learning_path;


use application\weblcms\ContentObjectPublication;
use application\weblcms\WeblcmsRights;
use application\weblcms\Tool;

use common\libraries\EqualityCondition;
use common\libraries\Request;
use common\libraries\Translation;
use common\libraries\Utilities;

/**
 * $Id: learning_path_deleter.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.learning_path.component
 */

class LearningPathToolDeleterComponent extends LearningPathTool
{

    public function run()
    {
        if (Request :: get(Tool :: PARAM_PUBLICATION_ID))
        {
            $publication_ids = Request :: get(Tool :: PARAM_PUBLICATION_ID);
        }
        else
        {
            $publication_ids = $_POST[Tool :: PARAM_PUBLICATION_ID];
        }

        if (!is_array($publication_ids))
        {
            $publication_ids = array($publication_ids);
        }

        foreach ($publication_ids as $pid)
        {
            $publication = \application\weblcms\DataManager :: retrieve(
                ContentObjectPublication :: class_name(),
                $pid
            );

            if ($this->is_allowed(WeblcmsRights :: DELETE_RIGHT, $publication) ||
                $publication->get_publisher_id() == $this->get_user_id())
            {
                $condition = new EqualityCondition(\application\weblcms\integration\tracking\LpAttempt :: PROPERTY_LP_ID, $pid);
                $dummy = new \application\weblcms\integration\tracking\LpAttempt();
                $trackers = $dummy->retrieve_tracker_items($condition);
                foreach ($trackers as $tracker)
                {
                    $tracker->delete();
                }

                $publication->delete();
            }
            
            else {
                $message = Translation :: get('NotAllowed', null, Utilities :: COMMON_LIBRARIES);
                $this->redirect($message, true, array('tool_action' => null, Tool :: PARAM_PUBLICATION_ID => null));
            }
            
        }
        if (count($publication_ids) > 1)
        {
            $message = htmlentities(
                Translation :: get(
                    'ObjectsDeleted', array(
                        'OBJECT' => Translation :: get('LearningPath')
                    ), Utilities :: COMMON_LIBRARIES
                )
            );
        }
        else
        {
            $message = htmlentities(
                Translation :: get(
                    'ObjectDeleted', array(
                        'OBJECT' => Translation :: get('LearningPath')
                    ), Utilities :: COMMON_LIBRARIES
                )
            );
        }

        $this->redirect($message, '', array('tool_action' => null, Tool :: PARAM_PUBLICATION_ID => null));
    }
}
