<?php
namespace application\weblcms\tool\link;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'LinkTool' => '/lib/link_tool.class.php',
         'LinkToolBrowserComponent' => '/lib/component/browser.class.php',
         'LinkToolCategoryManagerComponent' => '/lib/component/category_manager.class.php',
         'LinkToolCategoryMoverComponent' => '/lib/component/category_mover.class.php',
         'LinkToolContentObjectUpdaterComponent' => '/lib/component/content_object_updater.class.php',
         'LinkToolDeleterComponent' => '/lib/component/deleter.class.php',
         'LinkToolEvaluateComponent' => '/lib/component/evaluate.class.php',
         'LinkToolHidePublicationComponent' => '/lib/component/hide_publication.class.php',
         'LinkToolIntroductionPublisherComponent' => '/lib/component/introduction_publisher.class.php',
         'LinkToolMoverComponent' => '/lib/component/mover.class.php',
         'LinkToolPublicationUpdaterComponent' => '/lib/component/publication_updater.class.php',
         'LinkToolPublisherComponent' => '/lib/component/publisher.class.php',
         'LinkToolReportingViewerComponent' => '/lib/component/reporting_viewer.class.php',
         'LinkToolRightsEditorComponent' => '/lib/component/rights_editor.class.php',
         'LinkToolShareContentObjectsComponent' => '/lib/component/share_content_objects.class.php',
         'LinkToolShowPublicationComponent' => '/lib/component/show_publication.class.php',
         'LinkToolToggleVisibilityComponent' => '/lib/component/toggle_visibility.class.php',
         'LinkToolUpdaterComponent' => '/lib/component/updater.class.php',
         'LinkToolViewerComponent' => '/lib/component/viewer.class.php',
         'LinkBrowser' => '/lib/component/link_viewer/link_browser.class.php',
         'LinkDetailsRenderer' => '/lib/component/link_viewer/link_details_renderer.class.php',
         'LinkPublicationListRenderer' => '/lib/component/link_viewer/link_publication_list_renderer.class.php',
         'DataManager' => '/lib/storage/data_manager/data_manager.class.php',
         'DoctrineDataManager' => '/lib/storage/data_manager/implementation/doctrine.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>