<?php
namespace application\weblcms\tool\user;

use common\libraries\DataClassPropertyTableColumn;
use user\User;
use common\libraries\NewTableColumn;
use common\libraries\TableColumnModelActionsColumnSupport;
use common\libraries\RecordTableColumnModel;

/**
 * Table column model for an all course user browser table.
 *
 * @author Stijn Van Hoecke
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring from ObjectTable to RecordTable
 */
class AllSubscribedUserBrowserTableColumnModel extends RecordTableColumnModel  implements
    TableColumnModelActionsColumnSupport
{
    const SUBSCRIPTION_STATUS = 'subscription_status';
    const SUBSCRIPTION_TYPE = 'subscription_type';

    const DEFAULT_ORDER_COLUMN_INDEX = 1;

    /**
     * Initializes the columns for the table
     */
    public function initialize_columns()
    {
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_OFFICIAL_CODE));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_LASTNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_FIRSTNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_USERNAME));
        $this->add_column(new DataClassPropertyTableColumn(User :: class_name(), User :: PROPERTY_EMAIL));
        $this->add_column(new NewTableColumn(self :: SUBSCRIPTION_STATUS, null, true, ''));
        $this->add_column(new NewTableColumn(self :: SUBSCRIPTION_TYPE, null, false));

    }

}
