<?php
namespace application\weblcms\tool\user;

use common\extensions\email_manager\EmailManager;

use application\weblcms\WeblcmsManager;
use application\weblcms\Tool;

use user\UserDataManager;

use common\libraries\Breadcrumb;
use common\libraries\BreadcrumbTrail;
use common\libraries\Request;
use common\libraries\Translation;

/**
 * $Id: user_details.class.php 216 2009-11-13 14:08:06Z kariboe $
 *
 * @package application.lib.weblcms.tool.user.component
 */
class UserToolEmailerComponent extends UserTool
{

    public function run()
    {

        $ids = Request :: get(WeblcmsManager :: PARAM_USERS);
        $udm = UserDataManager :: get_instance();

        if (!is_array($ids))
        {
            $ids = array($ids);
        }

        if (count($ids) > 0)
        {
            foreach ($ids as $id)
            {
                $users[] = $udm->retrieve_user($id);
            }

            $manager = EmailManager :: construct($this);
            $manager->set_target_users($users);
            $manager->set_parameter(WeblcmsManager :: PARAM_USERS, $ids);
            $manager->run();

        }
        else
        {
            throw new \common\libraries\NoObjectSelectedException(Translation :: get('user'));
        }
    }

    public function display_header($trail)
    {
        $ids = Request :: get(WeblcmsManager :: PARAM_USERS);

        $this->set_parameter(WeblcmsManager :: PARAM_USERS, null);

        $trail = BreadcrumbTrail :: get_instance();

        $trail->add(
            new Breadcrumb(
                $this->get_url(array(WeblcmsManager :: PARAM_USERS => $ids)),
                Translation :: get('EmailUsers')
            )
        );

        return parent :: display_header();
    }

}
