<?php
namespace application\weblcms\tool\user;

use group\GroupRelUser;
use group\DataManager as GroupDataManager;

use common\libraries\ObjectTableDataProvider;
use common\libraries\DataClassRetrievesParameters;

/**
 * * ***************************************************************************
 * Data provider for a platform group rel user browser table.
 *
 * @author Stijn Van Hoecke
 *
 *         ****************************************************************************
 */
class PlatformGroupRelUserBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Gets the users
     *
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching users.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        return GroupDataManager :: retrieves(
            GroupRelUser :: class_name(),
            new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property)
        );
    }

    /**
     * Counts the users.
     *
     * @return int
     */
    public function get_object_count()
    {
        return GroupDataManager :: count(GroupRelUser:: class_name(), $this->get_condition());
    }
}
