<?php
namespace application\weblcms\tool\user;
use common\libraries\Utilities;
use common\libraries\Translation;
use group\DefaultGroupTableCellRenderer;
use group\Group;

/**
 * * ***************************************************************************
 * Cell renderer for a course subgroup browser table.
 *
 * @author Stijn Van Hoecke
 *
 *         ****************************************************************************
 */
class SubSubscribedPlatformGroupBrowserTableCellRenderer extends DefaultGroupTableCellRenderer
{

    /**
     * The repository browser component
     */
    private $browser;

    /**
     * Constructor
     *
     * @param $browser RepositoryManagerBrowserComponent
     */
    public function __construct($browser)
    {
        parent :: __construct();
        $this->browser = $browser;
    }

    // Inherited
    public function render_cell($column, $group)
    {
        // Add special features here
        switch ($column->get_name())
        {
            // Exceptions that need post-processing go here ...
            case Group :: PROPERTY_DESCRIPTION :
                $description = strip_tags(parent :: render_cell($column, $group));
                return Utilities :: truncate_string($description);
            case Translation :: get('Users', null, 'user') :
                return $group->count_users();
            case Translation :: get('Subgroups') :
                return $group->count_subgroups(true, true);
        }

        return parent :: render_cell($column, $group);
    }

}
