<?php
namespace application\weblcms\tool\user;

use common\libraries\RecordTableDataProvider;

/**
 * Data provider for a direct subscribed course user browser table, or users
 * in a direct subscribed group.
 *
 * @author Stijn Van Hoecke
 * @author Sven Vanpoucke - Hogeschool Gent - Refactoring to RecordTable
 */
class SubscribedUserBrowserTableDataProvider extends RecordTableDataProvider
{
    /****************************************************************************************************************
     * Inherited Functionality                                                                                      *
     ****************************************************************************************************************/

    /**
     * Gets the users
     *
     * @param $condition
     * @param int $offset
     * @param int $count
     * @param ObjectTableOrder[] $order_property
     *
     * @return ResultSet A set of matching users.
     */
    public function retrieve_data($condition, $offset, $count, $order_property = null)
    {
        return \application\weblcms\course\DataManager :: retrieve_users_directly_subscribed_to_course(
            $condition, $offset, $count, $order_property
        );
    }

    /**
     * Gets the number of users.
     *
     * @param \common\libraries\Condition $condition
     *
     * @return int
     */
    public function count_data($condition)
    {
        return \application\weblcms\course\DataManager :: count_users_directly_subscribed_to_course($condition);
    }
}
