<?php
namespace application\weblcms\tool\user;

use common\libraries\ObjectTableDataProvider;
use common\libraries\DataClassRetrievesParameters;
use group\Group;
use group\DataManager as GroupDataManager;

/**
 * * ***************************************************************************
 * Data provider for an unsubscribed course group browser table.
 *
 * @author Stijn Van Hoecke
 *
 *         ****************************************************************************
 */
class UnsubscribedGroupBrowserTableDataProvider extends ObjectTableDataProvider
{

    // **************************************************************************
    // CONSTRUCTOR
    // **************************************************************************
    /**
     * Constructor
     *
     * @param $browser WeblcmsManagerComponent
     * @param $condition Condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    // **************************************************************************
    // GENERAL FUNCTIONS
    // **************************************************************************
    /**
     * Gets the groups
     *
     * @param $offset int
     * @param $max_objects int
     * @param $order_by string
     * @return ResultSet A set of matching groups.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        return GroupDataManager :: retrieves(
                Group :: class_name(),
                new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property)
        );
    }

    /**
     * Gets the number of groups.
     *
     * @return int
     */
    public function get_object_count()
    {
        return GroupDataManager :: count(Group :: class_name(), $this->get_condition());
    }
}
