<?php
namespace application\weblcms\tool\user;


use common\libraries\NewObjectTableDataProvider;

/**
 * * ***************************************************************************
 * Data provider for an unsubscribed course user browser table.
 *
 * @author Stijn Van Hoecke
 *
 *         ****************************************************************************
 */
class UnsubscribedUserBrowserTableDataProvider extends NewObjectTableDataProvider
{

    // **************************************************************************
    // GENERAL FUNCTIONS
    // **************************************************************************
    /**
     * Gets the users
     *
     * @param $offset int
     * @param $max_objects int
     * @param $order_by string
     * @return ResultSet A set of matching users.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        return \application\weblcms\course\DataManager :: retrieve_users_not_subscribed_to_course(
            $this->get_object_table()->get_component()->get_course_id(), $this->get_condition(), $offset, $count,
            $order_property
        );
    }

    /**
     * Gets the number of users.
     *
     * @return int
     */
    public function get_object_count()
    {
        return \application\weblcms\course\DataManager :: count_users_not_subscribed_to_course(
            $this->get_object_table()->get_component()->get_course_id(), $this->get_condition()
        );
    }
}
