<?php
namespace common\extensions\dynamic_form_manager;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'DynamicForm' => '/lib/data_class/dynamic_form.class.php',
         'DynamicFormElement' => '/lib/data_class/dynamic_form_element.class.php',
         'DynamicFormElementOption' => '/lib/data_class/dynamic_form_element_option.class.php',
         'DynamicFormElementValue' => '/lib/data_class/dynamic_form_element_value.class.php',
         'DynamicFormElementBuilderForm' => '/lib/form/dynamic_form_element_builder_form.class.php',
         'DynamicFormExecuteForm' => '/lib/form/dynamic_form_execute_form.class.php',
         'DynamicFormManager' => '/lib/manager/dynamic_form_manager.class.php',
         'DynamicFormManagerAddElementComponent' => '/lib/manager/component/add_element.class.php',
         'DynamicFormManagerBuilderComponent' => '/lib/manager/component/builder.class.php',
         'DynamicFormManagerDeleteElementComponent' => '/lib/manager/component/delete_element.class.php',
         'DynamicFormManagerExecuterComponent' => '/lib/manager/component/executer.class.php',
         'DynamicFormManagerUpdateElementComponent' => '/lib/manager/component/update_element.class.php',
         'DynamicFormManagerViewerComponent' => '/lib/manager/component/viewer.class.php',
         'DynamicFormElementBrowserTable' => '/lib/table/browser/dynamic_form_element_browser_table.class.php',
         'DynamicFormElementBrowserTableCellRenderer' => '/lib/table/browser/dynamic_form_element_browser_table_cell_renderer.class.php',
         'DynamicFormElementBrowserTableColumnModel' => '/lib/table/browser/dynamic_form_element_browser_table_column_model.class.php',
         'DynamicFormElementBrowserTableDataProvider' => '/lib/table/browser/dynamic_form_element_browser_table_data_provider.class.php',
         'DefaultDynamicFormElementTableCellRenderer' => '/lib/table/dynamic_form_element/default_dynamic_form_element_table_cell_renderer.class.php',
         'DefaultDynamicFormElementTableColumnModel' => '/lib/table/dynamic_form_element/default_dynamic_form_element_table_column_model.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>