<?php
namespace common\extensions\dynamic_form_manager;
use common\libraries\DataClass;
use common\libraries\Utilities;
use common\libraries\EqualityCondition;
use core\admin\AdminDataManager;

//use core\admin\AdminDataManager;


/**
 * $Id: dynamic_form.class.php 227 2009-11-13 14:45:05Z kariboe $
 * @package application.common.dynamic_form_manager
 * @author Sven Vanpoucke
 */

class DynamicForm extends DataClass
{
    const CLASS_NAME = __CLASS__;

    const PROPERTY_NAME = 'name';
    const PROPERTY_APPLICATION = 'application';

    private $elements;

    public function __construct($defaultProperties)
    {
        parent :: __construct($defaultProperties);

     //$this->elements = array();
    }

    public function get_name()
    {
        return $this->get_default_property(self :: PROPERTY_NAME);
    }

    public function set_name($name)
    {
        $this->set_default_property(self :: PROPERTY_NAME, $name);
    }

    public function get_application()
    {
        return $this->get_default_property(self :: PROPERTY_APPLICATION);
    }

    public function set_application($application)
    {
        $this->set_default_property(self :: PROPERTY_APPLICATION, $application);
    }

    public function get_elements()
    {
        if (! $this->elements)
            $this->load_elements();

        return $this->elements;
    }

    public function get_element($index)
    {
        return $this->elements[$index];
    }

    public function set_elements($elements)
    {
        $this->elements = $elements;
    }

    public function add_elements($elements)
    {
        if (! is_array($elements))
        {
            $elements = array($elements);
        }

        foreach ($elements as $element)
        {
            $this->elements[] = $element;
        }
    }

    public function load_elements()
    {
        $condition = new EqualityCondition(DynamicFormElement :: PROPERTY_DYNAMIC_FORM_ID, $this->get_id());
        $elements = AdminDataManager :: get_instance()->retrieve_dynamic_form_elements($condition);
        $this->set_elements($elements->as_array());

        return $this->elements;
    }

    /**
     * Get the default properties of all user course categories.
     * @return array The property names.
     */
    public static function get_default_property_names()
    {
        return parent :: get_default_property_names(array(self :: PROPERTY_NAME, self :: PROPERTY_APPLICATION));
    }

    /**
     * inherited
     */
    public function get_data_manager()
    {
        return AdminDataManager :: get_instance();
    }

    public static function get_table_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }
}
