<?php
namespace common\extensions\email_manager;

use common\libraries\SubManager;
use common\libraries\Path;
use common\libraries\Request;

/**
 * $Id: email_manager.class.php 191 2009-11-13 11:50:28Z chellee $
 *
 * @package application.common.email_manager
 */
class EmailManager extends SubManager
{
    const ACTION_EMAIL = 'emailer';
    const DEFAULT_ACTION = self :: ACTION_EMAIL;
    const PARAM_EMAIL_MANAGER_ACTION = 'eaction';

    private $target_users;

    public function __construct($parent)
    {
        parent :: __construct($parent);

        $this->target_users = array();

        $email_action = Request :: get(self :: PARAM_EMAIL_MANAGER_ACTION);
        if ($email_action)
        {
            $this->set_parameter(self :: PARAM_EMAIL_MANAGER_ACTION, $email_action);
        }
    }

    public function set_target_users($target_users)
    {
        $this->target_users = $target_users;
    }

    public function get_target_users()
    {
        return $this->target_users;
    }

    /**
     * Helper function for the SubManager class, pending access to class constants via variables in PHP 5.3 e.g. $name =
     * $class :: DEFAULT_ACTION DO NOT USE IN THIS SUBMANAGER'S CONTEXT Instead use: - self :: DEFAULT_ACTION in the
     * context of this class - YourSubManager :: DEFAULT_ACTION in all other application classes
     */
    public static function get_default_action()
    {
        return self :: DEFAULT_ACTION;
    }

    /**
     * Helper function for the SubManager class, pending access to class constants via variables in PHP 5.3 e.g. $name =
     * $class :: PARAM_ACTION DO NOT USE IN THIS SUBMANAGER'S CONTEXT Instead use: - self :: PARAM_ACTION in the context
     * of this class - YourSubManager :: PARAM_ACTION in all other application classes
     */
    public static function get_action_parameter()
    {
        return self :: PARAM_EMAIL_MANAGER_ACTION;
    }

    /**
     *
     * @param Application $application
     * @return EmailManager
     */
    public static function construct($application)
    {
        return parent :: construct(__CLASS__, $application);
    }

    /**
     *
     * @param Application $application
     */
    public static function launch($application)
    {
        self :: construct(__CLASS__, $application)->run();
    }
}
