<?php
namespace common\extensions\external_repository_manager\implementation\youtube;

use common\extensions\external_repository_manager\StreamingMediaExternalObjectDisplay;

use common\libraries\Utilities;
use common\libraries\Translation;

class ExternalObjectDisplay extends StreamingMediaExternalObjectDisplay
{

    public function get_title()
    {
        $object = $this->get_object();
        return '<h3>' . $object->get_title() . ' (' . Utilities :: format_seconds_to_minutes($object->get_duration()) . ')</h3>';
    }

    public function get_display_properties()
    {
        $properties = parent :: get_display_properties();
        $properties[Translation :: get('Status')] = $this->get_object()->get_status_text();
        $properties[Translation :: get('Category')] = Translation :: get($this->get_object()->get_category());
        $properties[Translation :: get('Tags')] = $this->get_object()->get_tags_string();
        return $properties;
    }

    public function get_preview($is_thumbnail = false)
    {
        $object = $this->get_object();
        $html = array();
        $html[] = '<embed height="344" width="425" type="application/x-shockwave-flash" src="' . $object->get_video_url() . '"></embed>';
        return implode("\n", $html);
    }
}
