<?php
namespace common\extensions\external_repository_manager\implementation\youtube;

use common\libraries\Redirect;
use common\libraries\Path;

class UploaderComponent extends Manager
{

    public function run()
    {
        if (! $this->get_external_repository()->get_user_setting('session_token'))
        {
            $this->not_allowed();
        }
        else
        {
            $form = new ExternalObjectForm(ExternalObjectForm :: TYPE_CREATE, $this->get_url(), $this);
            
            if ($form->validate())
            {
                $upload_token = $form->get_upload_token();
                
                if ($upload_token)
                {
                    $parameters = $this->get_parameters();
                    $parameters[Manager :: PARAM_EXTERNAL_REPOSITORY_MANAGER_ACTION] = Manager :: ACTION_BROWSE_EXTERNAL_REPOSITORY;
                    $parameters[Manager :: PARAM_FEED_TYPE] = Manager :: FEED_TYPE_MYVIDEOS;
                    
                    if ($this->is_stand_alone())
                    {
                        $platform_url = Redirect :: get_web_link(
                                Path :: get(WEB_PATH) . 'common/libraries/php/shared/launcher/index.php', $parameters);
                    }
                    else
                    {
                        $platform_url = Redirect :: get_web_link(Path :: get(WEB_PATH) . 'index.php', $parameters);
                    }
                    
                    $next_url = $upload_token['url'] . '?nexturl=' . urlencode($platform_url);
                    $form = new UploadForm($next_url, $upload_token['token']);
                    $this->display_header();
                    $form->display();
                    $this->display_footer();
                }
            }
            else
            {
                $this->display_header();
                $form->display();
                $this->display_footer();
            }
        }
    }
}
