<?php

namespace common\extensions\new_rights_editor_manager;

use common\libraries\ObjectTable;
use common\libraries\Utilities;

/**
 * @author Sven Vanpoucke
 * @package application.common.rights_editor_manager.component.location_entity_browser
 */
/**
 * Table to display the entities for the rights editor
 */
class LocationEntityBrowserTable extends ObjectTable
{

    /**
     * Constructor
     * @see ContentObjectTable::ContentObjectTable()
     */
    public function __construct($browser, $parameters, $condition)
    {
        $selected_entity = $browser->get_selected_entity();
        
        $renderer = $selected_entity->get_entity_cell_renderer($browser);
        if (! $renderer)
        {
            $renderer = new LocationEntityBrowserTableCellRenderer($browser);
        }
        
        $model = $selected_entity->get_entity_column_model($browser);
        
        $data_provider = new LocationEntityBrowserTableDataProvider($browser, $condition);
        
        parent :: __construct($data_provider, Utilities :: get_classname_from_namespace(__CLASS__, true), $model, $renderer);
        
        $this->set_additional_parameters($parameters);
        $this->set_default_row_count(20);
    }
}
