<?php
namespace common\extensions\rights_editor_manager;
use common\libraries\StaticTableColumn;
use common\libraries\Utilities;
use common\libraries\Translation;
use group\DefaultGroupTableColumnModel;

/**
 * $Id: location_group_browser_table_column_model.class.php 191 2009-11-13 11:50:28Z chellee $
 * @package application.common.rights_editor_manager.component.location_group_bowser
 */
/**
 * Table column model for the user browser table
 */
class LocationGroupBrowserTableColumnModel extends DefaultGroupTableColumnModel
{
    /**
     * The tables modification column
     */
    private static $modification_column;
    private static $rights_columns;
    private $browser;

    /**
     * Constructor
     */
    public function __construct($browser)
    {
        parent :: __construct();
        $this->browser = $browser;
        $this->set_default_order_column(1);
        $this->set_columns(array_slice($this->get_columns(), 0, 2));
        $this->add_column(new StaticTableColumn(Translation :: get('Users', null, 'user')));
        $this->add_column(new StaticTableColumn(Translation :: get('Subgroups', null, 'group')));
        $this->add_rights_columns();

     //		$this->add_column(self :: get_modification_column());
    }

    /**
     * Gets the modification column
     * @return ContentObjectTableColumn
     */
    public static function get_modification_column()
    {
        if (! isset(self :: $modification_column))
        {
            self :: $modification_column = new StaticTableColumn('');
        }
        return self :: $modification_column;
    }

    public static function is_rights_column($column)
    {
        return in_array($column, self :: $rights_columns);
    }

    public function add_rights_columns()
    {
        $rights = $this->browser->get_available_rights();

        foreach ($rights as $right_name => $right_id)
        {
            $column_name = Utilities :: underscores_to_camelcase(strtolower($right_name));
            $column = new StaticTableColumn(Translation :: get($column_name));
            $this->add_column($column);
            self :: $rights_columns[] = $column;
        }
    }
}
