<?php
namespace common\extensions\rights_editor_manager;

use common\libraries\NewObjectTableDataProvider;
use common\libraries\DataClassCountParameters;
use common\libraries\DataClassRetrievesParameters;
/**
 * Data provider for a user browser table.
 *
 * This class implements some functions to allow user browser tables to
 * retrieve information about the users to display.
 */
class LocationUserBrowserTableDataProvider extends NewObjectTableDataProvider
{
    /**
     * Gets the users
     *
     * @param $user String
     * @param $category String
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching learning objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        return \user\DataManager :: retrieves(\user\User :: class_name(), new DataClassRetrievesParameters(
                $this->get_condition(), $count, $offset, $order_property));
    }

    /**
     * Gets the number of users in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return \user\DataManager :: count(\user\User :: class_name(),
                new DataClassCountParameters($this->get_condition()));
    }
}
