<?php
namespace common\extensions\validation_manager;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'ValidationForm' => '/lib/form/validation_form.class.php',
         'ValidationManager' => '/lib/manager/validation_manager.class.php',
         'ValidationManagerComponent' => '/lib/manager/validation_manager_component.class.php',
         'ValidationManagerBrowserComponent' => '/lib/manager/component/browser.class.php',
         'ValidationManagerCreatorComponent' => '/lib/manager/component/creator.class.php',
         'ValidationManagerDeleterComponent' => '/lib/manager/component/deleter.class.php',
         'ValidationBrowserTab' => '/lib/table/browser/validation_browser_table.class.php',
         'ValidationBrowserTableCellRenderer' => '/lib/table/browser/validation_browser_table_cell_renderer.class.php',
         'ValidationBrowserTableColumnModel' => '/lib/table/browser/validation_browser_table_column_model.class.php',
         'ValidationBrowserTableDataProvid' => '/lib/table/browser/validation_browser_table_data_provider.class.php',
         'DefaultValidationTableCellRenderer' => '/lib/table/validation/default_validation_table_cell_renderer.class.php',
         'DefaultValidationTableColumnModel' => '/lib/table/validation/default_validation_table_column_model.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>