<?php
namespace common\extensions\validation_manager;
/**
 * $Id: validation_manager_component.class.php 191 2009-11-13 11:50:28Z chellee
 * $
 *
 * @package application.common.validation_manager
 */

/**
 * Description of validation_manager_componentclass
 *
 * @author pieter
 */
use common\libraries\Utilities;

class ValidationManagerComponent
{
    /**
     * The ObjectPublisher instance that created this object.
     */
    private $parent;

    /**
     * Constructor.
     *
     * @param $parent ObjectPublisher
     *            The creator of this object.
     */
    public function __construct($parent)
    {
        $this->parent = $parent;
    }

    /**
     * Returns the creator of this object.
     *
     * @return ObjectPublisher The creator.
     */
    protected function get_parent()
    {
        return $this->parent;
    }

    /**
     *
     * @see ObjectPublisher::get_user_id()
     */
    public function get_user_id()
    {
        return $this->parent->get_user_id();
    }

    public function get_user()
    {
        return $this->parent->get_user();
    }

    public function display_header()
    {
        return $this->parent->display_header();
    }

    public function display_footer()
    {
        return $this->parent->display_footer();
    }

    /**
     *
     * @see ObjectPublisher::get_url()
     */
    public function get_url($parameters = array(), $encode = false)
    {

        return $this->parent->get_url($parameters, $encode);
    }

    /**
     *
     * @see ObjectPublisher::get_parameters()
     */
    public function get_parameters()
    {
        return $this->parent->get_parameters();
    }

    /**
     *
     * @see ObjectPublisher::get_parameter()
     */
    public function get_parameter($name)
    {
        $parameters = $this->get_parameters();
        return $parameters[$name];
    }

    /**
     *
     * @see ObjectPublisher::set_parameter()
     */
    public function set_parameter($name, $value)
    {
        $this->parent->set_parameter($name, $value);
    }

    public function redirect($action = null, $message = null, $error_message = false, $extra_params = array())
    {
        return $this->parent->redirect($action, $message, $error_message, $extra_params);
    }

    public function repository_redirect($action = null, $message = null, $cat_id = 0, $error_message = false, $extra_params = array())
    {
        return $this->parent->repository_redirect($action, $message, $cat_id, $error_message, $extra_params);
    }

    public function get_extra_parameters()
    {
        return $this->parent->get_extra_parameters();
    }

    public function set_extra_parameters($parameters)
    {
        $this->parent->set_extra_parameters($parameters);
    }

    /*
     * function retrieve_validations($pid,$cid,$application){ return
     * $this->parent->retrieve_validations($pid,$cid,$application); }
     */

    public function retrieve_validations($condition = null, $order_by = array (), $offset = 0, $max_objects = -1)
    {
        return $this->parent->retrieve_validations($condition, $order_by, $offset, $max_objects);

    }

    public function count_validations($condition = null)
    {
        return $this->parent->count_validations($condition);
    }

    public function retrieve_validation($id)
    {
        return $this->parent->retrieve_validation($id);
    }

    public function get_validation()
    {
        return $this->get_parent()->get_validation();
    }

    public static function factory($type, $parent)
    {

        $filename = dirname(__FILE__) . '/component/' . Utilities :: camelcase_to_underscores($type) . '.class.php';
        if (! file_exists($filename) || ! is_file($filename))
        {
            die('Failed to load "' . $type . '" component');
        }
        $class = 'ValidationManager' . $type . 'Component';

        return new $class($parent);
    }
}
