<?php
namespace common\libraries\form;
/*
 * Class for an imagebutton
 */
class ImageButton extends Element
{
    const TEMPLATE = '<input type="image" name="{NAME}" src="{SOURCE}" id="{ID}"{ATTRIBUTES}>';

    protected $source; // URL of the image

    /*
     * Constructor for a imagebutton
     */
    public function __construct($name, $source)
    {
        parent :: __construct($name);
        $this->source = $source;
    }

    public function html()
    {
        $parameters = array();
        $parameters['NAME'] = $this->get_name();
        $parameters['ID'] = $this->get_fully_qualified_id();
        $parameters['SOURCE'] = $this->get_source();

        $attributes = $this->get_attribute_storage()->get_attributes();
        if ($attributes)
        {
            $parameters['ATTRIBUTES'] = ' ' . $attributes;
        }

        return Renderer :: process(self :: TEMPLATE, $parameters);
    }

    public function get_source()
    {
        return $this->source;
    }
}
