<?php
namespace common\libraries\form;
/*
 * Class to render the elements that were added to the form
 */

use common\libraries\DynamicTabsRenderer;

class DefaultTabsRenderer extends DefaultContainerRenderer
{

    public function get_default_template()
    {
        $html = array();
        
        $html[] = '<div>';
        $html[] = '    {HEADER}';
        $html[] = '    {BODY}';
        $html[] = '    {FOOTER}';
        $html[] = '    <div class="clear">&nbsp;</div>';
        $html[] = '</div>';
        
        return implode("\n", $html);
    }

    public function get_parameters()
    {
        $parameters = array();
        
        $tabs_renderer = new DynamicTabsRenderer($this->get_element()->get_name());
        $tabs_renderer->set_tabs($this->get_element()->get_tabs());
        
        $html = array();
        
        $parameters['HEADER'] = $tabs_renderer->header();
        
        $tabs = array();
        foreach ($this->get_element()->get_tabs() as $tab)
        {
            $tabs[] = $tab->body_header();
            $tabs[] = $tab->get_element()->render();
            $tabs[] = $tab->body_footer();
        }
        
        $parameters['BODY'] = implode("\n", $tabs);
        $parameters['ERRORS'] = $this->get_element()->get_errors();
        $parameters['FOOTER'] = $tabs_renderer->footer();
        
        return $parameters;
    }

}
