<?php
namespace common\libraries;

/**
 * This type of aggregate condition negates a single condition, thus requiring that that condition not be met.
 *
 * @author Tim De Pauw
 * @author Hans De Bisschop
 * @package common.libraries
 */
class NotCondition extends AggregateCondition
{
    /**
     * The condition to negate
     *
     * @var \common\libraries\Condition
     */
    private $condition;

    /**
     * Constructor
     *
     * @param $condition \common\libraries\Condition
     */
    public function __construct(Condition $condition)
    {
        $this->condition = $condition;
    }

    /**
     * Gets the condition to negate
     *
     * @return \common\libraries\Condition
     */
    public function get_condition()
    {
        return $this->condition;
    }
    
    /*
     * (non-PHPdoc) @see common\libraries.Condition::hash()
     */
    public function hash()
    {
        $hashes = array();
        
        $hashes[] = 'not';
        $hashes[] = $this->condition->hash();
        
        return parent :: hash($hashes);
    }
}
