<?php
namespace common\libraries;

if (! function_exists('today'))
{

    public function today()
    {
        $date = getdate();
        $year = $date['year'];
        $month = $date['mon'];
        $day = $date['mday'];
        return mktime(0, 0, 0, $month, $day, $year);
    }
}

if (! function_exists('this_week'))
{

    public function this_week()
    {
        $date = getdate();
        $year = $date['year'];
        $month = $date['mon'];
        $mdays = $date['mday'];
        $days = $date['wday'];
        $result = mktime(0, 0, 0, $month, $mdays - $days + 1, $year);
        return $result;
    }
}

if (! function_exists('last_week'))
{

    public function last_week($week_count = 1)
    {
        $date = getdate(this_week());
        $year = $date['year'];
        $month = $date['mon'];
        $mdays = $date['mday'];
        $days = $date['wday'];
        $result = mktime(0, 0, 0, $month, $mdays - 7 * $week_count, $year);
        return $result;
    }
}

if (! function_exists('endoftime'))
{

    public function endoftime()
    {
        static $result = 0;
        if (empty($result))
        {
            $result = mktime(24, 60, 60, 12, 31, 10000);
        }
        return $result;
    }
}

/**
 * Time utility functions
 *
 * @copyright (c) 2010 University of Geneva
 * @license GNU General Public License
 * @author laurent.opprecht@unige.ch
 *
 */
class TimeUtil
{

    /**
     * Returns today date as a unix time stamp. That is with hour = 0, minutes = 0 and seconds = 0
     */
    public function today()
    {
        $date = getdate();
        $year = $date['year'];
        $month = $date['mon'];
        $day = $date['mday'];
        return mktime(0, 0, 0, $month, $day, $year);
    }

    public function this_week()
    {
        $date = getdate();
        $year = $date['year'];
        $month = $date['mon'];
        $mdays = $date['mday'];
        $days = $date['wday'];
        $result = mktime(0, 0, 0, $month, $mdays - $days + 1, $year);
        return $result;
    }

    public function last_week($week_count = 1)
    {
        $date = getdate(this_week());
        $year = $date['year'];
        $month = $date['mon'];
        $mdays = $date['mday'];
        $days = $date['wday'];
        $result = mktime(0, 0, 0, $month, $mdays - 7 * $week_count, $year);
        return $result;
    }

    public function endoftime()
    {
        static $result = 0;
        if (empty($result))
        {
            $result = mktime(24, 60, 60, 12, 31, 10000);
        }
        return $result;
    }
}
