<?php
namespace common\libraries;

use application\wiki\WikiPublicationRSS;
use application\weblcms\WeblcmsPublicationRSS;
use application\profiler\ProfilerPublicationRSS;
use application\portfolio\PortfolioPublicationRSS;
use application\personal_messenger\PersonalMessengerPublicationRSS;
use application\personal_calendar\PersonalCalendarPublicationRSS;
use application\forum\ForumPublicationRSS;
use application\assessment\AssessmentPublicationRSS;
use application\alexia\AlexiaPublicationRSS;

require_once dirname(__FILE__) . '/../global.inc.php';

class AllPublicationsRSS extends CombinedRSS
{

    public function __construct()
    {
        parent :: __construct('Chamilo publications', htmlspecialchars(Path :: get(WEB_PATH)), 'Chamilo publications', htmlspecialchars(Path :: get(WEB_PATH) . 'common/rss/all_publications_rss.php'));
    }

    public function get_basic_rss_objects()
    {
        $streams = array();
        $streams[] = new AlexiaPublicationRSS();
        $streams[] = new AssessmentPublicationRSS();
        $streams[] = new ForumPublicationRSS();
        $streams[] = new PersonalCalendarPublicationRSS();
        $streams[] = new PersonalMessengerPublicationRSS();
        $streams[] = new PortfolioPublicationRSS();
        $streams[] = new ProfilerPublicationRSS();
        $streams[] = new WeblcmsPublicationRSS();
        $streams[] = new WikiPublicationRSS();
        return $streams;
    }

}

$pubrss = new AllPublicationsRSS();
echo $pubrss->build_rss();
