<?php
namespace common\libraries;

use Exception;

/**
 * The optional parameters for a DataClass storage layer COUNT action
 *
 * @author Hans De Bisschop
 * @package common.libraries
 */
class DataClassCountParameters extends DataClassParameters
{

    /**
     * Get an md5 representation of this object for identification purposes
     *
     * @param $hash_parts multitype:string
     * @return string
     */
    public function hash($hash_parts = array())
    {
        $hash_parts[] = ($this->get_condition() instanceof Condition ? $this->get_condition()->hash() : null);
        return parent :: hash($hash_parts);
    }

    /**
     * Dynamically generate a valid DataClassCountParameters object based on the type of the input parameter
     *
     * @param $parameter \common\libraries\Condition|\common\libraries\DataClassCountParameters
     * @return \common\libraries\DataClassCountParameters boolean
     */
    public static function generate($parameter)
    {
        // So you think you're being funny, eh? Right back at you ... you dog-blasted, ornery, no-account, long-eared
        // varmint!
        if (is_object($parameter) && $parameter instanceof DataClassCountParameters)
        {
            return $parameter;
        }
        
        // If the parameter is a Condition, generate a new DataClassCountParameters instance using the Condition
        // provided by the context
        elseif (is_object($parameter) && $parameter instanceof Condition)
        {
            return new self($parameter);
        }
        elseif (is_object($parameter) && $parameter instanceof Joins)
        {
            return new self(null, $parameter);
        }
        elseif (is_null($parameter))
        {
            return new self();
        }
        else
        {
            throw new Exception('Illegal parameter passed to the DataManager :: count() method.');
        }
    }

}
