<?php
namespace common\libraries;

/**
 * This class describes a single property for a data class with the name and the value
 * This class can be used in query structures
 *
 * @author Sven Vanpoucke - Hogeschool Gent
 */
class DataClassProperty implements Hashable
{
    /**
     * The property
     *
     * @var ConditionVariable
     */
    private $property;

    /**
     * The value
     *
     * @var ConditionVariable
     */
    private $value;

    /**
     * Constructor
     *
     * @param ConditionVariable $property
     * @param ConditionVariable $value
     */
    public function __construct($property, $value)
    {
        $this->set_property($property);
        $this->set_value($value);
    }

    /**
     * Returns the property
     *
     * @return ConditionVariable
     */
    public function get_property()
    {
        return $this->property;
    }

    /**
     * Sets the property
     *
     * @param ConditionVariable $property
     */
    public function set_property(ConditionVariable $property)
    {
        $this->property = $property;
    }

    /**
     * Returns the value
     *
     * @return ConditionVariable
     */
    public function get_value()
    {
        return $this->value;
    }

    /**
     * Sets the value
     *
     * @param $value
     */
    public function set_value($value)
    {
        $this->value = $value;
    }

    /**
     * Hashes this object
     *
     * @return string
     */
    public function hash()
    {
        $property = $this->get_property();
        $value = $this->get_value();

        return md5($property . $value);
    }
}
