<?php
namespace common\libraries;

/**
 * Translation of case element condition variables for the doctrine implementation
 *
 * @package common.libraries
 *
 * @author Sven Vanpoucke
 */
class DoctrineCaseElementConditionVariableTranslator extends DoctrineConditionVariableTranslator
{
    /**
     * Translates the condition variable
     *
     * @return string
     */
    public function translate()
    {
        $strings = array();

        $condition_variable = $this->get_condition_variable();

        if($condition_variable->get_condition() instanceof Condition)
        {
            $strings[] = 'WHEN ';
            $strings[] = DoctrineConditionTranslator :: render($condition_variable->get_condition(), null, $this->get_connection());
            $strings[] = ' THEN ';
        }
        else
        {
            $strings[] = ' ELSE ';
        }

        $strings[] = $condition_variable->get_statement();

        return implode('', $strings);
    }
}
