<?php
namespace common\libraries;

/**
 * This class represents a Doctrine object ResultSet
 *
 * @package common.libraries
 * @author Hans De Bisschop
 */
class DoctrineDataClassResultSet extends DataClassResultSet
{

    /**
     * Create a new DoctrineResultSet for handling a set of records
     *
     * @param $data_manager DoctrineDatabase
     * @param $handle Doctrine\DBAL\Driver\PDOStatement
     * @param $class_name string
     */
    public function __construct($data_manager, $handle, $class_name)
    {
        $objects = array();

        while ($record = $handle->fetch(\PDO :: FETCH_ASSOC))
        {
            $objects[] = $this->get_object($class_name, $this->process_record($record));
        }

        parent :: __construct($class_name, $objects);
    }
}
