<?php
namespace common\libraries;

/**
 * Translation of case condition variables for the doctrine implementation
 *
 * @package common.libraries
 * @author Sven Vanpoucke
 * @author Hans De Bisschop
 */
class Mdb2CaseConditionVariableTranslator extends Mdb2ConditionVariableTranslator
{

    /**
     * Translates the condition variable
     *
     * @return string
     */
    public function translate()
    {
        $strings = array();

        $strings[] = 'CASE ';

        foreach ($this->get_condition_variable()->get_case_elements() as $case_element)
        {
            $strings[] = static :: render($case_element, $this->get_connection());
        }

        $strings[] = ' END';

        if ($this->get_condition_variable()->get_alias())
        {
            return implode('', $strings) . ' AS ' . $this->get_condition_variable()->get_alias();
        }
        else
        {
            return implode('', $strings);
        }
    }
}
