<?php
namespace common\libraries;

/**
 * Translation of ConditionVariables in the context of an MDB2-based storage layer
 *
 * @package common.libraries
 * @author Hans De Bisschop
 */
class Mdb2FixedPropertyConditionVariableTranslator extends Mdb2ConditionVariableTranslator
{

    public function translate()
    {
        $data_manager = $this->get_condition_variable()->determine_data_manager();
        $class_name = $this->get_condition_variable()->get_class();

        $table_alias = $data_manager :: get_instance()->get_alias($class_name :: get_table_name());

        return Mdb2Database :: escape_column_name(
            $this->get_condition_variable()->get_property(),
            $table_alias,
            $this->get_connection()) . ' AS ' . $this->get_condition_variable()->get_alias();
    }
}
