<?php
namespace common\libraries;

/**
 * Translation of ConditionVariables in the context of an MDB2-based storage layer
 *
 * @package common.libraries
 * @author Hans De Bisschop
 */
class Mdb2FunctionConditionVariableTranslator extends Mdb2ConditionVariableTranslator
{

    public function translate()
    {
        $strings = array();
        switch ($this->get_condition_variable()->get_function())
        {
            case FunctionConditionVariable :: SUM :
                $strings[] = 'SUM';
                break;
            case FunctionConditionVariable :: COUNT :
                $strings[] = 'COUNT';
                break;
            case FunctionConditionVariable :: MIN :
                $strings[] = 'MIN';
                break;
            case FunctionConditionVariable :: MAX :
                $strings[] = 'MAX';
                break;
            case FunctionConditionVariable :: DISTINCT :
                $strings[] = 'DISTINCT';
                break;
        }

        $strings[] = '(';
        $strings[] = static :: render(
            $this->get_condition_variable()->get_condition_variable(),
            $this->get_connection());
        $strings[] = ')';
        if ($this->get_condition_variable()->get_alias())
        {
            return implode('', $strings) . ' AS ' . $this->get_condition_variable()->get_alias();
        }
        else
        {
            return implode('', $strings);
        }
    }
}
