<?php
namespace common\libraries;

use Exception;

class RecordResultCache extends RecordCache
{

    public static function add($record, RecordRetrieveParameters $parameters = null)
    {
        if (! is_array($record))
        {
            throw new Exception('The RecordResultCache only allows for caching of records. Currently trying to add: ' . gettype($record) . '.');
        }
        
        if ($parameters instanceof RecordRetrieveParameters)
        {
            self :: set_cache($parameters->hash(), $record);
        }
        
        return true;
    }

    /**
     * Process a DataClassNoResultException for the DataClassCache, preventing continued access to the storage layer for
     * empty results
     *
     * @param $exception DataClassNoResultException
     * @return boolean
     */
    public static function no_result(NoRecordException $exception)
    {
        self :: set_cache($exception->get_parameters()->hash(), false);
        return true;
    }
}
