<?php

namespace common\libraries;

/**
 * Used to register actions that will be executed at the end of the execution script.
 * I.e. during garbage collection.
 * 
 * @author laurent
 */
class ExitAction
{
    
    private static $count = 0;
    private static $actions = array();

    public static function register($action, $key = null)
    {
        $key = $key ? $key : self :: next_key();
        $f = new ExitAction($action);
        self :: $actions[$key] = $f;
        return $key;
    }

    public static function has($key)
    {
        return isset(self :: $actions[$key]);
    }

    public static function next_key()
    {
        return __CLASS__ . (self :: $count ++);
    }
    
    private $action = null;

    public function __construct($action)
    {
        $this->action = $action;
    }

    public function __invoke()
    {
        return $this->call();
    }

    public function call()
    {
        $action = $this->action;
        if ($action)
        {
            $this->action = null;
            return $action();
        }
    }

    public function __destruct()
    {
        $this->call();
    }
}
