<?php

namespace common\libraries;

/**
 * Abstract class to define the business logic of the retrieval of objects (data class) in the database
 * @author Sven Vanpoucke
 */
abstract class GetObjectListWebserviceHandler extends WebserviceHandler
{

    public function run()
    {
        $objects = $this->get_objects();
        $translation = $this->get_objects_translation();
        
        if (empty($objects) || $objects->size() == 0)
        {
            return new SuccessRestMessage(true, Translation :: get('NoObjectsFound', array('OBJECTS' => $translation), Utilities :: COMMON_LIBRARIES));
        }
        
        return $objects->as_array();
    }

    abstract public function get_objects();

    abstract public function get_objects_translation();
}
