<?php
namespace core\admin\announcement;

class Autoloader
{

    /**
     * The array mapping class names to paths
     * 
     * @var multitype:string
     */
    private static $map = array(
        'Autoloader' => '/autoloader.class.php', 
        'DataManager' => '/lib/data_manager.class.php', 
        'DataManagerInterface' => '/lib/data_manager_interface.class.php', 
        'Publisher' => '/lib/publisher.class.php', 
        'Rights' => '/lib/rights.class.php', 
        'Publication' => '/lib/data_class/publication.class.php', 
        'RightsLocation' => '/lib/data_class/rights_location.class.php', 
        'RightsLocationEntityRight' => '/lib/data_class/rights_location_entity_right.class.php', 
        'DoctrineDataManager' => '/lib/data_manager/doctrine.class.php', 
        'Mdb2DataManager' => '/lib/data_manager/mdb2.class.php', 
        'PublicationForm' => '/lib/form/publication.class.php', 
        'Manager' => '/lib/manager/manager.class.php', 
        'BrowserComponent' => '/lib/manager/component/browser.class.php', 
        'CreatorComponent' => '/lib/manager/component/creator.class.php', 
        'DeleterComponent' => '/lib/manager/component/deleter.class.php', 
        'EditorComponent' => '/lib/manager/component/editor.class.php', 
        'HiderComponent' => '/lib/manager/component/hider.class.php', 
        'ViewerComponent' => '/lib/manager/component/viewer.class.php', 
        'PublicationTable' => '/lib/table/publication/publication_table.class.php', 
        'PublicationTableCellRenderer' => '/lib/table/publication/publication_table_cell_renderer.class.php', 
        'PublicationTableColumnModel' => '/lib/table/publication/publication_table_column_model.class.php', 
        'PublicationTableDataProvider' => '/lib/table/publication/publication_table_data_provider.class.php', 
        'Activator' => '/package/activate/activator.class.php', 
        'Deactivator' => '/package/deactivate/deactivator.class.php', 
        'Installer' => '/package/install/installer.class.php');

    /**
     * Try to load the class
     * 
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }
        
        return false;
    }

    /**
     * Synchronize the autoloader
     * 
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }
}
?>