<?php
namespace core\admin;

use common\libraries\Breadcrumb;
use common\libraries\Translation;
use common\libraries\AdministrationComponent;
use common\libraries\DelegateComponent;
use common\extensions\rights_editor_manager\RightsEditorManager;


class AdminManagerEmailRightsEditorComponent extends AdminManager implements AdministrationComponent, DelegateComponent
{
    public function run()
    {
        $location[] = AdminRights::get_location_by_identifier(AdminManager::APPLICATION_NAME, AdminRights::TYPE_ADMIN_COMPONENT, AdminRights::LOCATION_EMAIL_MANAGER);

        $manager = new RightsEditorManager($this, $location);
        $manager->exclude_users(array($this->get_user_id()));
        $manager->run();
    }

    public function get_available_rights()
    {
       return array('E-mail' => 20);

    }

	public function add_additional_breadcrumbs(BreadcrumbTrail $breadcrumbtrail)
    {
    	$breadcrumbtrail->add(new Breadcrumb($this->get_url(array(AdminManager :: PARAM_ACTION => AdminManager :: ACTION_EDIT_EMAIL_RIGHTS)), Translation :: get('AdminManagerEmailRightsComponent')));
    	$breadcrumbtrail->add_help('admin_rights_editor');
    }

    public function get_additional_parameters()
    {
    	return array(AdminManager :: PARAM_SYSTEM_ANNOUNCEMENT_ID);
    }

}
