<?php
namespace core\admin;

use common\libraries\Utilities;
use common\libraries\Application;
use common\libraries\Translation;

class AdminManagerResourceCacheManagerComponent extends AdminManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        if (! $this->get_user()->get_platformadmin())
        {
            $this->display_header();
            $this->display_error_message(Translation :: get('NotAllowed', array(), Utilities :: COMMON_LIBRARIES));
            $this->display_footer();
            exit();
        }

        $form = new ResourceCacheManagerForm('cache', 'post', $this->get_url());

        if ($form->validate())
        {
            $form->reset_cache();
            $this->redirect(Translation :: get('CacheHasBeenReset'), false, array());
        }
        else
        {
            $this->display_header();
            $application_url = $this->get_url(
                array(
                    Application :: PARAM_ACTION => AdminManager :: ACTION_CONFIGURE_PLATFORM,
                    AdminManager :: PARAM_WEB_APPLICATION => Application :: PLACEHOLDER_APPLICATION));
            $form->display();
            $this->display_footer();
        }
    }
}
