<?php
namespace core\help;
use common\libraries\Utilities;
use common\libraries\DataClass;

/**
 * $Id: help_item.class.php 226 2009-11-13 14:44:03Z chellee $
 * @package help.lib
 */

class HelpItem extends DataClass
{
    const CLASS_NAME = __CLASS__;

    const PROPERTY_CONTEXT = 'context';
    const PROPERTY_IDENTIFIER = 'identifier';
    const PROPERTY_LANGUAGE = 'language';
    const PROPERTY_URL = 'url';

    /**
     * Get the default properties of all groups.
     * @return array The property names.
     */
    public static function get_default_property_names()
    {
        return parent :: get_default_property_names(array(self :: PROPERTY_CONTEXT, self :: PROPERTY_IDENTIFIER,
                self :: PROPERTY_URL, self :: PROPERTY_LANGUAGE));
    }

    /**
     * inherited
     */
    public function get_data_manager()
    {
        return HelpDataManager :: get_instance();
    }

    /**
     * Returns the name of this group.
     * @return String The name
     */
    public function get_context()
    {
        return $this->get_default_property(self :: PROPERTY_CONTEXT);
    }

    public function get_identifier()
    {
        return $this->get_default_property(self :: PROPERTY_IDENTIFIER);
    }

    /**
     * Returns the url of this group.
     * @return String The url
     */
    public function get_url()
    {
        return $this->get_default_property(self :: PROPERTY_URL);
    }

    public function get_language()
    {
        return $this->get_default_property(self :: PROPERTY_LANGUAGE);
    }

    /**
     * Sets the name of this group.
     * @param String $name the name.
     */
    public function set_context($context)
    {
        $this->set_default_property(self :: PROPERTY_CONTEXT, $context);
    }

    public function set_identifier($identifier)
    {
        $this->set_default_property(self :: PROPERTY_IDENTIFIER, $identifier);
    }

    /**
     * Sets the url of this group.
     * @param String $url the url.
     */
    public function set_url($url)
    {
        $this->set_default_property(self :: PROPERTY_URL, $url);
    }

    public function set_language($language)
    {
        $this->set_default_property(self :: PROPERTY_LANGUAGE, $language);
    }

    public static function get_table_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }

    public function has_url()
    {
        return $this->get_url() ? true : false;
    }

    public function create()
    {
        $hdm = $this->get_data_manager();

        if (! $hdm->create_help_item($this))
        {
            return false;
        }

        //        if(!HelpRights :: create_location_in_help_subtree($this->get_name(), $this->get_id(), HelpRights :: get_help_subtree_root_id()))
        //        {
        //
        //        }
        return true;
    }
}
