<?php
namespace core\help;
use common\libraries\Translation;
use common\libraries\package\Installer;
use common\libraries\Filesystem;
/**
 * $Id: help_installer.class.php 226 2009-11-13 14:44:03Z chellee $
 * @package help.install
 */
/**
 * This installer can be used to create the storage structure for the
 * group application.
 */
class HelpInstaller extends Installer
{

    /**
     * Constructor
     */
    public function __construct($values)
    {
        parent :: __construct($values, HelpDataManager :: get_instance());
    }

    public function extra()
    {
        //        if (! $this->install_help_items())
        //        {
        //            return false;
        //        }
        //        else
        //        {
        //            $this->add_message(self :: TYPE_NORMAL, Translation :: get('HelpItemsInstalled'));
        //        }


        return true;
    }

    public function install_help_items()
    {
        $path = dirname(__FILE__) . '/../help_items/';

        $files = Filesystem :: get_directory_content($path, Filesystem :: LIST_FILES);
        foreach ($files as $file)
        {
            if ((substr($file, - 3) == 'xml'))
            {
                $data = $this->extract_xml_file($file);

                if ($data)
                {
                    $filename = basename($file);
                    $language = substr($filename, 0, strlen($filename) - 4);

                    $items = $data['help_item'];
                    foreach ($items as $item)
                    {
                        $help_item = new HelpItem();
                        $help_item->set_name($item['name']);
                        $help_item->set_language($language);
                        $help_item->set_url($item['url']);
                        $help_item->create();
                    }
                }
                else
                {
                    return false;
                }
            }
        }

        return true;

    }

    public function get_path()
    {
        return parent :: get_path();
    }
}
