<?php
namespace core\home;

use common\libraries\Translation;
use common\libraries\JsonAjaxResult;
use common\libraries\AjaxManager;

/**
 *
 * @package home.ajax
 * @author Hans De Bisschop
 */

class HomeAjaxBlockEdit extends AjaxManager
{
    const PARAM_BLOCK = 'block';
    const PARAM_TITLE = 'title';

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_BLOCK, self :: PARAM_TITLE);
    }

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $user_id = DataManager :: determine_user_id();

        if ($user_id === false)
        {
            JsonAjaxResult :: not_allowed();
        }

        $block = intval($this->get_parameter(self :: PARAM_BLOCK));
        $title = $this->get_parameter(self :: PARAM_TITLE);

        $block = DataManager :: retrieve(HomeBlock :: class_name(), $block);

        if ($block->get_user() == $user_id)
        {
            $block->set_title($title);
            if ($block->update())
            {
                JsonAjaxResult :: success();
            }
            else
            {
                JsonAjaxResult :: general_error(Translation :: get('BlockNotUpdated'));
            }
        }
        else
        {
            JsonAjaxResult :: not_allowed();
        }
    }
}
