<?php
namespace core\home;

use common\libraries\Translation;
use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;

/**
 *
 * @author Hans De Bisschop @dependency repository.content_object.assessment_multiple_choice_question;
 */
class HomeAjaxBlockVisibility extends AjaxManager
{
    const PARAM_BLOCK = 'block';

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_BLOCK);
    }

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $user_id = DataManager :: determine_user_id();

        if ($user_id === false)
        {
            JsonAjaxResult :: not_allowed();
        }

        $block_data = explode('_', $this->get_parameter(self :: PARAM_BLOCK));

        $block = DataManager :: retrieve(HomeBlock :: class_name(), intval($block_data[2]));

        if ($block->get_user() == $user_id)
        {
            if ($block->is_visible())
            {
                $block->set_invisible();
            }
            else
            {
                $block->set_visible();
            }

            if ($block->update())
            {
                JsonAjaxResult :: success();
            }
            else
            {
                JsonAjaxResult :: error(409, Translation :: get('BlockNotUpdated'));
            }
        }
        else
        {
            JsonAjaxResult :: not_allowed();
        }
    }
}
