<?php
namespace core\home;

use common\libraries\Translation;
use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;

/**
 *
 * @author Hans De Bisschop @dependency repository.content_object.assessment_multiple_choice_question;
 */
class HomeAjaxTabSort extends AjaxManager
{
    const PARAM_ORDER = 'order';

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_ORDER);
    }

    public function get_tabs()
    {
        $element_data = explode('&', $this->get_parameter(self :: PARAM_ORDER));
        $elements = array();

        foreach ($element_data as $element)
        {
            $element_split = explode('=', $element);
            $elements[] = $element_split[1];
        }

        return $elements;
    }

    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $user_id = DataManager :: determine_user_id();

        if ($user_id === false)
        {
            JsonAjaxResult :: not_allowed();
        }

        $tabs = $this->get_tabs();

        $errors = 0;
        $i = 1;

        foreach ($tabs as $tab_id)
        {
            $tab = DataManager :: retrieve(HomeTab :: class_name(), intval($tab_id));
            $tab->set_sort($i);
            if (! $tab->update())
            {
                $errors ++;
            }
            $i ++;
        }

        if ($errors > 0)
        {
            JsonAjaxResult :: error(409, Translation :: get('OneOrMoreTabsNotUpdated'));
        }
        else
        {
            JsonAjaxResult :: success();
        }
    }
}
