<?php
namespace core\home;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'HomeAjaxBlockAdd' => '/ajax/block_add.class.php',
         'HomeAjaxBlockConfig' => '/ajax/block_config.class.php',
         'HomeAjaxBlockConfigForm' => '/ajax/block_config_form.class.php',
         'HomeAjaxBlockDelete' => '/ajax/block_delete.class.php',
         'HomeAjaxBlockEdit' => '/ajax/block_edit.class.php',
         'HomeAjaxBlockList' => '/ajax/block_list.class.php',
         'HomeAjaxBlockMove' => '/ajax/block_move.class.php',
         'HomeAjaxBlockSort' => '/ajax/block_sort.class.php',
         'HomeAjaxBlockVisibility' => '/ajax/block_visibility.class.php',
         'HomeAjaxColumnAdd' => '/ajax/column_add.class.php',
         'HomeAjaxColumnDelete' => '/ajax/column_delete.class.php',
         'HomeAjaxColumnWidth' => '/ajax/column_width.class.php',
         'HomeAjaxTabAdd' => '/ajax/tab_add.class.php',
         'HomeAjaxTabDelete' => '/ajax/tab_delete.class.php',
         'HomeAjaxTabEdit' => '/ajax/tab_edit.class.php',
         'HomeAjaxTabSort' => '/ajax/tab_sort.class.php',
         'Block' => '/lib/block.class.php',
         'DataManager' => '/lib/data_manager.class.php',
         'HomeBlock' => '/lib/home_block.class.php',
         'HomeBlockConfig' => '/lib/home_block_config.class.php',
         'HomeBlockRegistration' => '/lib/home_block_registration.class.php',
         'HomeColumn' => '/lib/home_column.class.php',
         'HomeDataManager' => '/lib/home_data_manager.class.php',
         'HomeDataManagerInterface' => '/lib/home_data_manager_interface.class.php',
         'HomeInstaller' => '/lib/home_installer.class.php',
         'HomeRemover' => '/lib/home_remover.class.php',
         'HomeRow' => '/lib/home_row.class.php',
         'HomeTab' => '/lib/home_tab.class.php',
         'DoctrineDataManager' => '/lib/data_manager/doctrine.class.php',
         'Mdb2DataManager' => '/lib/data_manager/mdb2.class.php',
         'HomeBlockConfigForm' => '/lib/forms/home_block_config_form.class.php',
         'HomeBlockForm' => '/lib/forms/home_block_form.class.php',
         'HomeColumnForm' => '/lib/forms/home_column_form.class.php',
         'HomeRowForm' => '/lib/forms/home_row_form.class.php',
         'HomeTabForm' => '/lib/forms/home_tab_form.class.php',
         'HomeManager' => '/lib/home_manager/home_manager.class.php',
         'HomeManagerAdminConfigurerComponent' => '/lib/home_manager/component/admin_configurer.class.php',
         'HomeManagerAdminEditorComponent' => '/lib/home_manager/component/admin_editor.class.php',
         'HomeManagerAttachmentViewerComponent' => '/lib/home_manager/component/attachment_viewer.class.php',
         'HomeManagerConfigurerComponent' => '/lib/home_manager/component/configurer.class.php',
         'HomeManagerCreatorComponent' => '/lib/home_manager/component/creator.class.php',
         'HomeManagerDeleterComponent' => '/lib/home_manager/component/deleter.class.php',
         'HomeManagerEditorComponent' => '/lib/home_manager/component/editor.class.php',
         'HomeManagerHomeComponent' => '/lib/home_manager/component/home.class.php',
         'HomeManagerHomeConfigurerComponent' => '/lib/home_manager/component/home_configurer.class.php',
         'HomeManagerHomeEditorComponent' => '/lib/home_manager/component/home_editor.class.php',
         'HomeManagerManagerComponent' => '/lib/home_manager/component/manager.class.php',
         'HomeManagerMoverComponent' => '/lib/home_manager/component/mover.class.php',
         'HomeManagerPersonalComponent' => '/lib/home_manager/component/personal.class.php',
         'HomeManagerTruncaterComponent' => '/lib/home_manager/component/truncater.class.php',
         'HomeManagerUserComponent' => '/lib/home_manager/component/user.class.php',
         'HomeRenderer' => '/lib/home_renderer/home_renderer.class.php',
         'DefaultHomeRenderer' => '/lib/home_renderer/renderer/default.class.php',
         'MyChamiloOsHomeRenderer' => '/lib/home_renderer/renderer/my_chamilo_os.class.php',
         'WidgetHomeRenderer' => '/lib/home_renderer/renderer/widget.class.php',
         'WidgetOpenSocialModuleHomeRenderer' => '/lib/home_renderer/renderer/widget_open_social_module.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>