<?php
namespace core\home;
use common\libraries\EqualityCondition;
use common\libraries\DataClass;
/**
 * $Id: home_row.class.php 227 2009-11-13 14:45:05Z kariboe $
 * @package home.lib
 */

class HomeRow extends DataClass
{
    const CLASS_NAME = __CLASS__;
    const TABLE_NAME = 'row';

    const PROPERTY_TITLE = 'title';
    const PROPERTY_SORT = 'sort';
    const PROPERTY_TAB = 'tab_id';
    const PROPERTY_USER = 'user_id';

    /**
     * Get the default properties of all user course categories.
     * @return array The property names.
     */
    public static function get_default_property_names()
    {
        return parent :: get_default_property_names(array(self :: PROPERTY_TITLE, self :: PROPERTY_SORT,
                self :: PROPERTY_TAB, self :: PROPERTY_USER));
    }

    /**
     * inherited
     */
    public function get_data_manager()
    {
        return HomeDataManager :: get_instance();
    }

    public function get_sort()
    {
        return $this->get_default_property(self :: PROPERTY_SORT);
    }

    public function set_sort($sort)
    {
        $this->set_default_property(self :: PROPERTY_SORT, $sort);
    }

    public function get_title()
    {
        return $this->get_default_property(self :: PROPERTY_TITLE);
    }

    public function set_title($title)
    {
        $this->set_default_property(self :: PROPERTY_TITLE, $title);
    }

    public function get_tab()
    {
        return $this->get_default_property(self :: PROPERTY_TAB);
    }

    public function set_tab($tab)
    {
        $this->set_default_property(self :: PROPERTY_TAB, $tab);
    }

    public function get_user()
    {
        return $this->get_default_property(self :: PROPERTY_USER);
    }

    public function set_user($user)
    {
        $this->set_default_property(self :: PROPERTY_USER, $user);
    }

    public function create()
    {
        $condition = new EqualityCondition(self :: PROPERTY_TAB, $this->get_tab());
        $this->set_sort(DataManager :: retrieve_next_value(self :: class_name(), self :: PROPERTY_SORT, $condition));
        return parent :: create();
    }

    public function delete()
    {
        $condition = new EqualityCondition(HomeColumn :: PROPERTY_ROW, $this->get_id());
        $columns = DataManager :: retrieves(HomeColumn :: class_name(), $condition);

        while ($column = $columns->next_result())
        {
            if (! $column->delete())
            {
                return false;
            }
        }

        return parent :: delete();
    }

    public static function get_table_name()
    {
        return self :: TABLE_NAME;
    }
}
