<?php
namespace core\install;
use common\libraries\Utilities;

use HTML_QuickForm_Page;
use common\libraries\Translation;
use common\libraries\PlatformSetting;
/**
 * $Id: install_wizard_page.class.php 225 2009-11-13 14:43:20Z vanpouckesven $
 *
 * @package install.lib.installmanager.component.inc.wizard
 */
/**
 * This abstract class defines a page which is used in a maintenance wizard.
 */
abstract class InstallWizardPage extends HTML_QuickForm_Page
{
    /**
     * The repository tool in which the wizard runs.
     */
    private $parent;

    /**
     * Constructor
     *
     * @param $name string A unique name of this page in the wizard
     * @param $parent Tool The repository tool in which the wizard runs.
     */
    public function __construct($name, $parent)
    {
        PlatformSetting :: set_instance(new InstallationPlatformSettings());
        $this->parent = $parent;
        parent :: __construct($name, 'post');

        $this->registerElementType('style_submit_button',
                dirname(__FILE__) . '/../../../../../../../../common/libraries/php/shared/html/formvalidator/Element/style_submit_button.php',
                'HTML_QuickForm_stylesubmitbutton');
        $this->registerElementType('style_reset_button',
                dirname(__FILE__) . '/../../../../../../../../common/libraries/php/shared/html/formvalidator/Element/style_reset_button.php',
                'HTML_QuickForm_styleresetbutton');
        $this->registerElementType('category',
                dirname(__FILE__) . '/../../../../../../../../common/libraries/php/shared/html/formvalidator/Element/category.php',
                'HTML_QuickForm_category');
    }

    /**
     * Returns the repository tool in which this wizard runs
     *
     * @return Tool
     */
    public function get_parent()
    {
        return $this->parent;
    }

    public function set_lang($lang)
    {
        Translation :: set_language($lang);
    }

    public function get_breadcrumb()
    {
        return Translation :: get(Utilities :: get_classname_from_object($this));
    }

    public function get_title()
    {
        return Translation :: get(Utilities :: get_classname_from_object($this) . 'Title');
    }

    public function get_info()
    {
        return Translation :: get(Utilities :: get_classname_from_object($this) . 'Information');
    }
}
