<?php
namespace core\lynx\manager;

use common\libraries\DelegateComponent;
use common\libraries\Breadcrumb;
use common\libraries\BreadcrumbTrail;
use common\libraries\Toolbar;
use common\libraries\Theme;
use common\libraries\Translation;
use common\libraries\ToolbarItem;
use common\libraries\Request;

class InstallerComponent extends Manager implements DelegateComponent
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $context = Request :: get(self :: PARAM_CONTEXT);
        $installer = new PackageInstaller($context);
        $installer->run();

        BreadcrumbTrail :: get_instance()->add(
                new Breadcrumb(null,
                        Translation :: get('InstallingPackage',
                                array('PACKAGE' => Translation :: get('TypeName', null, $context)))));

        $this->display_header();
        echo $installer->get_result(true);

        $toolbar = new Toolbar();
        $toolbar->add_item(
                new ToolbarItem(Translation :: get('BackToPackageOVerview'),
                        Theme :: get_common_image_path() . 'action_back.png', $this->get_url(array(self :: PARAM_ACTION => self :: ACTION_BROWSE))));
        echo $toolbar->as_html();

        $this->display_footer();
    }
}
