<?php
namespace core\lynx;

use common\libraries\CommonDataManager;
use common\libraries\Theme;
use common\libraries\Translation;

class ContentObjectUpgraderComponent extends UpgraderComponent
{

    public function initialize()
    {
        $content_object_registrations = CommonDataManager :: get_registrations_by_type('repository\content_object');

        foreach ($content_object_registrations as $content_object_registration)
        {
            $this->add_package($content_object_registration->get_context());
        }
    }

    public function upgrade_successfull()
    {
        $image = Theme :: get_image_path(__NAMESPACE__) . 'package_action/finished.png';
        $title = Translation :: get('PlatformUpgraded');
        $result = Translation :: get(
            'ContentObjectsUpgraded',
            array('URL' => $this->get_url(array(self :: PARAM_ACTION => self :: ACTION_APPLICATION_UPGRADE))));

        return $this->render_upgrade_step($image, $title, $result);
    }
}
