<?php
namespace core\menu;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'DataManager' => '/lib/data_manager.class.php',
         'Item' => '/lib/item.class.php',
         'ItemMenu' => '/lib/item_menu.class.php',
         'ItemTitle' => '/lib/item_title.class.php',
         'ItemTitles' => '/lib/item_titles.class.php',
         'MenuDataManager' => '/lib/menu_data_manager.class.php',
         'MenuDataManagerInterface' => '/lib/menu_data_manager_interface.class.php',
         'DoctrineDataManager' => '/lib/data_manager/doctrine.class.php',
         'Mdb2DataManager' => '/lib/data_manager/mdb2.class.php',
         'DatabaseItemResultSet' => '/lib/data_manager/database/database_item_result_set.class.php',
         'ItemForm' => '/lib/forms/item_form.class.php',
         'ApplicationItemForm' => '/lib/forms/item/application_form.class.php',
         'CategoryItemForm' => '/lib/forms/item/category_form.class.php',
         'LinkItemForm' => '/lib/forms/item/link_form.class.php',
         'ApplicationItem' => '/lib/item/application.class.php',
         'CategoryItem' => '/lib/item/category.class.php',
         'LinkItem' => '/lib/item/link.class.php',
         'LinkApplicationItem' => '/lib/item/link_application.class.php',
         'ItemRenderer' => '/lib/item_renderer/item_renderer.class.php',
         'MiniBarItemRenderer' => '/lib/item_renderer/mini_bar/mini_bar.class.php',
         'MiniBarApplicationItemRenderer' => '/lib/item_renderer/mini_bar/item/application.class.php',
         'MiniBarCategoryItemRenderer' => '/lib/item_renderer/mini_bar/item/category.class.php',
         'MiniBarLinkItemRenderer' => '/lib/item_renderer/mini_bar/item/link.class.php',
         'MiniBarLinkApplicationItemRenderer' => '/lib/item_renderer/mini_bar/item/link_application.class.php',
         'SiteMapItemRenderer' => '/lib/item_renderer/site_map/site_map.class.php',
         'SiteMapApplicationItemRenderer' => '/lib/item_renderer/site_map/item/application.class.php',
         'SiteMapCategoryItemRenderer' => '/lib/item_renderer/site_map/item/category.class.php',
         'SiteMapLinkItemRenderer' => '/lib/item_renderer/site_map/item/link.class.php',
         'SiteMapLinkApplicationItemRenderer' => '/lib/item_renderer/site_map/item/link_application.class.php',
         'DefaultItemTableCellRenderer' => '/lib/item_table/default_item_table_cell_renderer.class.php',
         'DefaultItemTableColumnModel' => '/lib/item_table/default_item_table_column_model.class.php',
         'MenuManager' => '/lib/menu_manager/menu_manager.class.php',
         'MenuManagerBrowserComponent' => '/lib/menu_manager/component/browser.class.php',
         'MenuManagerCreatorComponent' => '/lib/menu_manager/component/creator.class.php',
         'MenuManagerDeleterComponent' => '/lib/menu_manager/component/deleter.class.php',
         'MenuManagerEditorComponent' => '/lib/menu_manager/component/editor.class.php',
         'MenuManagerMoverComponent' => '/lib/menu_manager/component/mover.class.php',
         'ItemBrowserTable' => '/lib/menu_manager/component/item_browser/item_browser_table.class.php',
         'ItemBrowserTableCellRenderer' => '/lib/menu_manager/component/item_browser/item_browser_table_cell_renderer.class.php',
         'ItemBrowserTableColumnModel' => '/lib/menu_manager/component/item_browser/item_browser_table_column_model.class.php',
         'ItemBrowserTableDataProvider' => '/lib/menu_manager/component/item_browser/item_browser_table_data_provider.class.php',
         'MenuRenderer' => '/lib/menu_renderer/menu_renderer.class.php',
         'MiniBarMenuRenderer' => '/lib/menu_renderer/renderer/mini_bar.class.php',
         'SiteMapMenuRenderer' => '/lib/menu_renderer/renderer/site_map.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>