<?php

namespace core\menu;

use common\libraries\Header;

use common\libraries\Utilities;

class ApplicationItem extends Item
{
    const PROPERTY_USE_TRANSLATION = 'use_translation';
    const PROPERTY_APPLICATION = 'application';

    const CLASS_NAME = __CLASS__;

    public function __construct($default_properties = array(), $additional_properties = null)
    {
        parent :: __construct($default_properties, $additional_properties);
        $this->set_type(__CLASS__);
    }

    public static function get_type_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME);
    }

    public function get_use_translation()
    {
        return $this->get_additional_property(self :: PROPERTY_USE_TRANSLATION);
    }

    public function set_use_translation($use_translation = 0)
    {
        return $this->set_additional_property(self :: PROPERTY_USE_TRANSLATION, $use_translation);
    }

    public function get_application()
    {
        return $this->get_additional_property(self :: PROPERTY_APPLICATION);
    }

    public function set_application($application)
    {
        return $this->set_additional_property(self :: PROPERTY_APPLICATION, $application);
    }

    public static function get_additional_property_names()
    {
        return array(self :: PROPERTY_USE_TRANSLATION, self :: PROPERTY_APPLICATION);
    }

    public function is_selected()
    {
        $current_section = Header :: get_section();
        if ($current_section == $this->get_application())
        {
            return true;
        }
        return false;
    }

}
