<?php
namespace core\menu;

use common\libraries\Application;
use common\libraries\Translation;
use common\libraries\WebApplication;

class MiniBarApplicationItemRenderer extends MiniBarItemRenderer
{

    public function get_item_url()
    {
        $application = $this->get_item()->get_application();

        if (WebApplication :: exists($application) && ! WebApplication :: is_active('application\\' . $application))

        {
            return;
        }

        if ($application == 'root')
        {
            $url = 'index.php';
        }
        else
        {
            $url = 'index.php?application=' . $this->get_item()->get_application();
        }

        if ($this->get_item()->is_selected() && $this->get_item()->get_parent() == 0)
        {
            $class = 'class="current" ';
        }

        $html = array();
        if ($this->get_item()->get_use_translation())
        {
            $title = Translation :: get(
                'TypeName',
                null,
                Application :: determine_namespace($this->get_item()->get_application()));
        }
        else
        {
            $title = $this->get_item()->get_titles()->get_translation(Translation :: get_instance()->get_language());
        }

        $html[] = '<a ' . $class . 'href="' . $url . '">' . $title;

        $html[] = '</a>';

        return implode("\n", $html);
    }
}
