<?php
namespace core\menu;
use common\libraries\Theme;
use common\libraries\ObjectTableCellRenderer;
/**
 * $Id: default_item_table_cell_renderer.class.php 223 2009-11-13 14:39:28Z vanpouckesven $
 * @package menu.lib.item_table
 */
class DefaultItemTableCellRenderer extends ObjectTableCellRenderer
{

    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Renders a table cell
     * @param MenuManagerTableColumnModel $column The column which should be
     * rendered
     * @param Learning Object $menu_publication The learning object to render
     * @return string A HTML representation of the rendered table cell
     */
    public function render_cell($column, $item)
    {
        switch ($column->get_name())
        {
            case ItemTitle :: PROPERTY_TITLE :
                return $item->get_titles()->get_current_translation();
            case 'Type' :
                return '<img src="' . Theme :: get_image_path() . 'types/' . Item :: type_integer($item->get_type()) . '.png" />';
            default :
                return '&nbsp;';
        }
    }

    public function render_id_cell($object)
    {
        return $object->get_id();
    }
}
