<?php
namespace core\menu;
use common\libraries\Utilities;
use common\libraries\Translation;
use common\libraries\Request;
use common\libraries\ObjectTable;
use common\libraries\ObjectTableFormActions;
use common\libraries\ObjectTableFormAction;

class ItemBrowserTable extends ObjectTable
{
    const DEFAULT_NAME = 'item_browser_table';

    /**
     * Constructor
     */
    public function __construct($browser, $parameters, $condition)
    {
        $model = new ItemBrowserTableColumnModel($browser);
        $renderer = new ItemBrowserTableCellRenderer($browser);
        $data_provider = new ItemBrowserTableDataProvider($browser, $condition);
        parent :: __construct($data_provider, ItemBrowserTable :: DEFAULT_NAME, $model, $renderer);
        $actions = new ObjectTableFormActions(__NAMESPACE__);
        
        $actions->add_form_action(new ObjectTableFormAction(MenuManager :: ACTION_DELETE, Translation :: get('RemoveSelected', null, Utilities :: COMMON_LIBRARIES)));
        
        $user = $browser->get_user();
        $this->set_form_actions($actions);
        $this->set_default_row_count(10);
    }
    
    public static function handle_table_action()
    {
        $class = Utilities :: get_classname_from_namespace(__CLASS__, true);
        $ids = self :: get_selected_ids($class);
        Request :: set_get(MenuManager :: PARAM_ITEM, $ids);
    }
}
