<?php
namespace core\menu;
use common\libraries\StaticTableColumn;

class ItemBrowserTableColumnModel extends DefaultItemTableColumnModel
{
    /**
     * The tables modification column
     */
    private static $modification_column;

    /**
     * Constructor
     */
    public function __construct($browser)
    {
        parent :: __construct();
        $this->set_default_order_column(0);
        $this->set_default_order_direction(SORT_ASC);
        $this->add_column(self :: get_modification_column());
    }

    /**
     * Gets the modification column
     * @return MenuManagerTableColumn
     */
    public static function get_modification_column()
    {
        if (! isset(self :: $modification_column))
        {
            self :: $modification_column = new StaticTableColumn('');
        }
        return self :: $modification_column;
    }
}
