<?php
namespace core\menu;
use common\libraries\DataClassRetrievesParameters;

use common\libraries\ObjectTableDataProvider;
use common\libraries\ObjectTableOrder;

class ItemBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     * @param MenuManagerManagerComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Gets the menu objects
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of matching menu objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        $order_property[] = new ObjectTableOrder(Item :: PROPERTY_SORT);

        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property);
        return DataManager :: retrieves(Item :: class_name(), $parameters);
    }

    /**
     * Gets the number of menu objects in the table
     * @return int
     */
    public function get_object_count()
    {
        return DataManager :: count(Item :: class_name(), $this->get_condition());
    }
}
