<?php
namespace core\metadata;
use common\libraries\ObjectTableDataProvider;
use common\libraries\ObjectTableOrder;

class MetadataElementBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     * @param ApplicationComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Retrieves the objects
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of objects
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        $order_property = new ObjectTableOrder(MetadataElement :: PROPERTY_ORDER, SORT_ASC);
        return $this->get_browser()->retrieve_metadata_elements($this->get_condition(), $offset, $count, $order_property);
    }

    /**
     * Gets the number of objects in the table
     * @return int
     */
    public function get_object_count()
    {
        return $this->get_browser()->count_metadata_elements($this->get_condition());
    }
}
