<?php
namespace core\metadata;

use common\libraries\ObjectTableDataProvider;

/**
 * Data provider for a user browser table. This class implements some functions to allow user browser tables to retrieve
 * information about the users to display.
 */
class MetadataNamespaceBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     *
     * @param $browser UserManagerComponent
     * @param $condition Condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Gets the users
     *
     * @param $user String
     * @param $category String
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching learning objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);

        return MetadataDataManager :: get_instance()->retrieve_metadata_namespaces($this->get_condition(), $offset,
                $count, $order_property);
    }

    /**
     * Gets the number of users in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return MetadataDataManager :: get_instance()->count_metadata_namespaces($this->get_condition());
    }
}
