<?php
namespace core\metadata;

use common\libraries\ObjectTable;
/**
 * Table to display a list of metadata_element_values
 *
 * @author Jens Vanderheyden
 */
class UserMetadataElementValueBrowserTable extends ObjectTable
{
    const DEFAULT_NAME = 'user_metadata_element_value_browser_table';

    /**
     * Constructor
     */
    public function __construct($browser, $parameters, $condition)
    {
        $model = new UserMetadataElementValueBrowserTableColumnModel();
        $renderer = new UserMetadataElementValueBrowserTableCellRenderer($browser);
        $data_provider = new UserMetadataElementValueBrowserTableDataProvider($browser, $condition);
        parent :: __construct($data_provider, self :: DEFAULT_NAME, $model, $renderer);
        $this->set_additional_parameters($parameters);
        $actions = array();

        $this->set_form_actions($actions);
        $this->set_default_row_count(20);
    }
}
