<?php
namespace core\metadata;

use common\libraries\StaticTableColumn;
use common\libraries\ObjectTableColumn;
use user\DefaultUserTableColumnModel;

/**
 * Table column model for the metadata_element_value browser table
 *
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */

class UserMetadataElementValueBrowserTableColumnModel extends DefaultUserTableColumnModel
{
    /**
     * The tables modification column
     */
    private static $modification_column;

    /**
     * Constructor
     */
    public function __construct()
    {
        $this->add_column(new ObjectTableColumn(UserMetadataElementValue :: PROPERTY_USER_ID));
        parent :: __construct();
        $this->set_default_order_column(1);
        $this->add_column(self :: get_modification_column());
    }

    /**
     * Gets the modification column
     *
     * @return ContentObjectTableColumn
     */
    public static function get_modification_column()
    {
        if (! isset(self :: $modification_column))
        {
            self :: $modification_column = new StaticTableColumn('');
        }
        return self :: $modification_column;
    }
}
