<?php
namespace core\metadata;
use common\libraries\ObjectTableCellRenderer;
/**
 * Default cell renderer for the metadata_attribute table
 *
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */
class DefaultMetadataAttributeTableCellRenderer extends ObjectTableCellRenderer
{

    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Renders a table cell
     * @param ContentObjectTableColumnModel $column The column which should be
     * rendered
     * @param MetadataAttribute $metadata_attribute - The metadata_attribute
     * @return string A HTML representation of the rendered table cell
     */
    public function render_cell($column, $metadata_attribute)
    {
        switch ($column->get_name())
        {
            case MetadataAttribute :: PROPERTY_ID :
                return $metadata_attribute->get_id();
            case MetadataAttribute :: PROPERTY_NS_PREFIX :
                return $metadata_attribute->get_ns_prefix();
            case MetadataAttribute :: PROPERTY_NAME :
                return $metadata_attribute->get_name();
            
            default :
                return '&nbsp;';
        }
    }

    public function render_id_cell($object)
    {
        return $object->get_id();
    }
}
