<?php
namespace core\metadata;
use common\libraries\ObjectTableColumnModel;
use common\libraries\ObjectTableColumn;
/**
 * @package metadata.tables.metadata_attribute_table
 */

/**
 * Default column model for the metadata_attribute table
 *
 * @author Sven Vanpoucke
 * @author Jens Vanderheyden
 */
class DefaultMetadataAttributeTableColumnModel extends ObjectTableColumnModel
{

    /**
     * Constructor
     */
    public function __construct()
    {
        parent :: __construct(self :: get_default_columns(), 1);
    }

    /**
     * Gets the default columns for this model
     * @return Array(ObjectTableColumn)
     */
    private static function get_default_columns()
    {
        $columns = array();
        
        //$columns[] = new ObjectTableColumn(MetadataAttribute :: PROPERTY_ID);
        $columns[] = new ObjectTableColumn(MetadataAttribute :: PROPERTY_NS_PREFIX);
        $columns[] = new ObjectTableColumn(MetadataAttribute :: PROPERTY_NAME);
        //$columns[] = new ObjectTableColumn(MetadataAttribute :: PROPERTY_VALUE);
        //$columns[] = new ObjectTableColumn(MetadataAttribute :: PROPERTY_VALUE_TYPE);
        

        return $columns;
    }
}
