<?php

namespace core\migration;

use common\libraries\DataClass;
use common\libraries\Utilities;

/**
 * $Id: $
 * @package migration.lib
 */

/**
 * @author Sven Vanpoucke
 */
class MigrationBlockRegistration extends DataClass
{
    const CLASS_NAME = __CLASS__;
    
    const PROPERTY_NAME = 'name';
    const PROPERTY_IS_MIGRATED = 'is_migrated';

    public function get_name()
    {
        return $this->get_default_property(self :: PROPERTY_NAME);
    }

    public function set_name($name)
    {
        $this->set_default_property(self :: PROPERTY_NAME, $name);
    }

    public function get_is_migrated()
    {
        return $this->get_default_property(self :: PROPERTY_IS_MIGRATED);
    }

    public function set_is_migrated($is_migrated)
    {
        $this->set_default_property(self :: PROPERTY_IS_MIGRATED, $is_migrated);
    }

    /**
     * Get the default properties of all migrations.
     * @return array The property names.
     */
    public static function get_default_property_names()
    {
        return parent :: get_default_property_names(array(self :: PROPERTY_NAME, self :: PROPERTY_IS_MIGRATED));
    }

    /**
     * inherited
     */
    public function get_data_manager()
    {
        return MigrationDataManager :: get_instance();
    }

    public static function get_table_name()
    {
        return Utilities :: camelcase_to_underscores(Utilities :: get_classname_from_namespace(__CLASS__));
    }

}
