<?php

namespace core\migration;

use common\libraries\FormValidatorPage;

/**
 * $Id: migration_wizard_page.class.php 221 2009-11-13 14:36:41Z vanpouckesven $
 * @package migration.lib.migration_manager.component.inc.wizard
 *
 * This abstract class defines a page which is used in a migration wizard.
 */
abstract class MigrationWizardPage extends FormValidatorPage
{

    /**
     * The MigrationManager component in which the wizard runs.
     */
    private $parent;
    private $name;

    /**
     * Constructor
     * @param string $name A unique name of this page in the wizard
     * @param MigrationManagerComponent $parent The MigrationManager component
     * in which the wizard runs.
     */
    public function __construct($parent, $name)
    {
	parent :: __construct($name, 'post');
	$this->updateAttributes(array('action' => $parent->get_parent()->get_url()));

	$this->parent = $parent;
	$this->name = $name;
    }

    public function display_page_html()
    {

    }

    /**
     * Returns the MigrationManager component in which this wizard runs
     * @return MigrationManager
     */
    public function get_parent()
    {
	return $this->parent;
    }

    public function get_name()
    {
	return $this->name;
    }

    public function get_platform()
    {
	return $this->get_parent()->get_platform();
    }

    abstract public function display_page_info();

    abstract public function display_next_page_info();
}
