<?php
namespace core\migration;

use common\libraries\Utilities;

/**
 * $Id: dokeos185_track_eexercices.class.php 221 2009-11-13 14:36:41Z vanpouckesven $
 * @package migration.lib.platform.dokeos185
 */
require_once dirname(__FILE__) . '/../dokeos185_migration_data_class.class.php';

/**
 * This class presents a Dokeos185 track_e_exercices
 *
 * @author Sven Vanpoucke
 */
class Dokeos185TrackEExercices extends Dokeos185MigrationDataClass
{
    const CLASS_NAME = __CLASS__;
    const TABLE_NAME = 'track_e_exercices';
    const DATABASE_NAME = 'statistics_database';
    
    /**
     * Dokeos185TrackEExercices properties
     */
    const PROPERTY_EXE_ID = 'exe_id';
    const PROPERTY_EXE_USER_ID = 'exe_user_id';
    const PROPERTY_EXE_DATE = 'exe_date';
    const PROPERTY_EXE_COURS_ID = 'exe_cours_id';
    const PROPERTY_EXE_EXO_ID = 'exe_exo_id';
    const PROPERTY_EXE_RESULT = 'exe_result';
    const PROPERTY_EXE_WEIGHTING = 'exe_weighting';
    
    /**
     * Default properties stored in an associative array.
     */
    private $defaultProperties;

    /**
     * Creates a new Dokeos185TrackEExercices object
     * @param array $defaultProperties The default properties
     */
    public function __construct($defaultProperties = array())
    {
        $this->defaultProperties = $defaultProperties;
    }

    /**
     * Gets a default property by name.
     * @param string $name The name of the property.
     */
    public function get_default_property($name)
    {
        return $this->defaultProperties[$name];
    }

    /**
     * Gets the default properties
     * @return array An associative array containing the properties.
     */
    public function get_default_properties()
    {
        return $this->defaultProperties;
    }

    /**
     * Get the default properties
     * @return array The property names.
     */
    public static function get_default_property_names()
    {
        return array(self :: PROPERTY_EXE_ID, self :: PROPERTY_EXE_USER_ID, self :: PROPERTY_EXE_DATE, 
                self :: PROPERTY_EXE_COURS_ID, self :: PROPERTY_EXE_EXO_ID, self :: PROPERTY_EXE_RESULT, 
                self :: PROPERTY_EXE_WEIGHTING);
    }

    /**
     * Sets a default property by name.
     * @param string $name The name of the property.
     * @param mixed $value The new value for the property.
     */
    public function set_default_property($name, $value)
    {
        $this->defaultProperties[$name] = $value;
    }

    /**
     * Sets the default properties of this class
     */
    public function set_default_properties($defaultProperties)
    {
        $this->defaultProperties = $defaultProperties;
    }

    /**
     * Returns the exe_id of this Dokeos185TrackEExercices.
     * @return the exe_id.
     */
    public function get_exe_id()
    {
        return $this->get_default_property(self :: PROPERTY_EXE_ID);
    }

    /**
     * Returns the exe_user_id of this Dokeos185TrackEExercices.
     * @return the exe_user_id.
     */
    public function get_exe_user_id()
    {
        return $this->get_default_property(self :: PROPERTY_EXE_USER_ID);
    }

    /**
     * Returns the exe_date of this Dokeos185TrackEExercices.
     * @return the exe_date.
     */
    public function get_exe_date()
    {
        return $this->get_default_property(self :: PROPERTY_EXE_DATE);
    }

    /**
     * Returns the exe_cours_id of this Dokeos185TrackEExercices.
     * @return the exe_cours_id.
     */
    public function get_exe_cours_id()
    {
        return $this->get_default_property(self :: PROPERTY_EXE_COURS_ID);
    }

    /**
     * Returns the exe_exo_id of this Dokeos185TrackEExercices.
     * @return the exe_exo_id.
     */
    public function get_exe_exo_id()
    {
        return $this->get_default_property(self :: PROPERTY_EXE_EXO_ID);
    }

    /**
     * Returns the exe_result of this Dokeos185TrackEExercices.
     * @return the exe_result.
     */
    public function get_exe_result()
    {
        return $this->get_default_property(self :: PROPERTY_EXE_RESULT);
    }

    /**
     * Returns the exe_weighting of this Dokeos185TrackEExercices.
     * @return the exe_weighting.
     */
    public function get_exe_weighting()
    {
        return $this->get_default_property(self :: PROPERTY_EXE_WEIGHTING);
    }

    /**
     * Validation checks
     * @param Array $array
     */
    public function is_valid()
    {
    
    }

    /**
     * Convertion
     * @param Array $array
     */
    public function convert_data()
    {
    
    }

    public static function get_table_name()
    {
        return Utilities :: camelcase_to_underscores(substr(Utilities :: get_classname_from_namespace(__CLASS__), 9));
    }

    public static function get_class_name()
    {
        return self :: CLASS_NAME;
    }

    public function get_database_name()
    {
        return self :: DATABASE_NAME;
    }

}
