<?php
namespace group;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'GroupAjaxPlatformGroupsFeed' => '/ajax/platform_groups_feed.class.php',
         'DataManager' => '/lib/data_manager.class.php',
         'Group' => '/lib/group.class.php',
         'GroupDataManagerInterface' => '/lib/group_data_manager_interface.class.php',
         'GroupMenu' => '/lib/group_menu.class.php',
         'GroupRelUser' => '/lib/group_rel_user.class.php',
         'GroupRightsTemplate' => '/lib/group_rights_template.class.php',
         'GroupTreeMenuDataProvider' => '/lib/group_tree_menu_data_provider.class.php',
         'GroupUsageTreeMenuDataProvider' => '/lib/group_usage_tree_menu_data_provider.class.php',
         'GroupUseGroup' => '/lib/group_use_group.class.php',
         'Mdb2DataManager' => '/lib/data_manager/mdb2.class.php',
         'GroupExportForm' => '/lib/forms/group_export_form.class.php',
         'GroupForm' => '/lib/forms/group_form.class.php',
         'GroupImportForm' => '/lib/forms/group_import_form.class.php',
         'GroupMoveForm' => '/lib/forms/group_move_form.class.php',
         'GroupRightsTemplateManagerForm' => '/lib/forms/group_role_manager_form.class.php',
         'GroupSearchForm' => '/lib/forms/group_search_form.class.php',
         'GroupUsageForm' => '/lib/forms/group_usage_form.class.php',
         'GroupUserImportForm' => '/lib/forms/group_user_import_form.class.php',
         'GroupUserSearchForm' => '/lib/forms/group_user_search_form.class.php',
         'GroupManager' => '/lib/group_manager/group_manager.class.php',
         'GroupManagerBrowserComponent' => '/lib/group_manager/component/browser.class.php',
         'GroupManagerCreatorComponent' => '/lib/group_manager/component/creator.class.php',
         'GroupManagerDeleterComponent' => '/lib/group_manager/component/deleter.class.php',
         'GroupManagerEditorComponent' => '/lib/group_manager/component/editor.class.php',
         'GroupManagerExporterComponent' => '/lib/group_manager/component/exporter.class.php',
         'GroupManagerGroupRightsTemplateManagerComponent' => '/lib/group_manager/component/group_role_manager.class.php',
         'GroupManagerGroupUserImporterComponent' => '/lib/group_manager/component/group_user_importer.class.php',
         'GroupManagerImporterComponent' => '/lib/group_manager/component/importer.class.php',
         'GroupManagerMoverComponent' => '/lib/group_manager/component/mover.class.php',
         'GroupManagerSubscriberComponent' => '/lib/group_manager/component/subscriber.class.php',
         'GroupManagerSubscribeUserBrowserComponent' => '/lib/group_manager/component/subscribe_user_browser.class.php',
         'GroupManagerTruncaterComponent' => '/lib/group_manager/component/truncater.class.php',
         'GroupManagerUnsubscriberComponent' => '/lib/group_manager/component/unsubscriber.class.php',
         'GroupManagerUsageManagerComponent' => '/lib/group_manager/component/usage_manager.class.php',
         'GroupManagerViewerComponent' => '/lib/group_manager/component/viewer.class.php',
         'GroupBrowserTable' => '/lib/group_manager/component/group_browser/group_browser_table.class.php',
         'GroupBrowserTableCellRenderer' => '/lib/group_manager/component/group_browser/group_browser_table_cell_renderer.class.php',
         'GroupBrowserTableColumnModel' => '/lib/group_manager/component/group_browser/group_browser_table_column_model.class.php',
         'GroupBrowserTableDataProvider' => '/lib/group_manager/component/group_browser/group_browser_table_data_provider.class.php',
         'GroupRelUserBrowserTable' => '/lib/group_manager/component/group_rel_user_browser/group_rel_user_browser_table.class.php',
         'GroupRelUserBrowserTableCellRenderer' => '/lib/group_manager/component/group_rel_user_browser/group_rel_user_browser_table_cell_renderer.class.php',
         'GroupRelUserBrowserTableColumnModel' => '/lib/group_manager/component/group_rel_user_browser/group_rel_user_browser_table_column_model.class.php',
         'GroupRelUserBrowserTableDataProvider' => '/lib/group_manager/component/group_rel_user_browser/group_rel_user_browser_table_data_provider.class.php',
         'SubscribeUserBrowserTable' => '/lib/group_manager/component/subscribe_user_browser/subscribe_user_browser_table.class.php',
         'SubscribeUserBrowserTableCellRenderer' => '/lib/group_manager/component/subscribe_user_browser/subscribe_user_browser_table_cell_renderer.class.php',
         'SubscribeUserBrowserTableColumnModel' => '/lib/group_manager/component/subscribe_user_browser/subscribe_user_browser_table_column_model.class.php',
         'SubscribeUserBrowserTableDataProvider' => '/lib/group_manager/component/subscribe_user_browser/subscribe_user_browser_table_data_provider.class.php',
         'DefaultGroupRelUserTableCellRenderer' => '/lib/group_rel_user_table/default_group_rel_user_table_cell_renderer.class.php',
         'DefaultGroupRelUserTableColumnModel' => '/lib/group_rel_user_table/default_group_rel_user_table_column_model.class.php',
         'DefaultGroupTableCellRenderer' => '/lib/group_table/default_group_table_cell_renderer.class.php',
         'DefaultGroupTableColumnModel' => '/lib/group_table/default_group_table_column_model.class.php',
         'DoctrineDataManager' => '/lib/storage/implementation/doctrine.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php',
         'GroupValidator' => '/validator/group_validator.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>