<?php
namespace group;
use common\libraries\Utilities;
use common\libraries\Translation;
use common\libraries\Request;
use common\libraries\ObjectTableFormActions;
use common\libraries\ObjectTableFormAction;
use common\libraries\NewObjectTable;
use common\libraries\NewObjectTableFormActionsSupport;


/**
 * Table to display a list of users not subscribed to a course.
 */
class SubscribeUserBrowserTable extends NewObjectTable implements NewObjectTableFormActionsSupport
{
    const DEFAULT_NAME = 'subscribe_user_browser_table';
    const DEFAULT_ROW_COUNT = 20;


    public static function handle_table_action()
    {
        $class = Utilities :: get_classname_from_namespace(__CLASS__, true);
        $ids = self :: get_selected_ids($class);
        Request :: set_get(GroupManager :: PARAM_USER_ID, $ids);
    }

    public function get_implemented_form_actions()
    {
        $actions = new ObjectTableFormActions(__NAMESPACE__);
        
        $actions->add_form_action(new ObjectTableFormAction(GroupManager :: ACTION_SUBSCRIBE_USER_TO_GROUP, 
                Translation :: get('SubscribeSelected'), false));
        
        return $actions;
    }
}
