<?php
namespace group;

/**
 * $Id: group_installer.class.php 224 2009-11-13 14:40:30Z kariboe $
 *
 * @package group.install
 */
/**
 * This installer can be used to create the storage structure for the group application.
 */
class Installer extends \common\libraries\package\Installer
{

    /**
     * Constructor
     */
    public function __construct($values)
    {
        parent :: __construct($values, DataManager :: get_instance());
    }

    /**
     * Additional installation steps.
     */
    public function extra()
    {
        if (! $this->create_root_group())
        {
            return false;
        }

        return true;
    }

    public function create_root_group()
    {
        $values = $this->get_form_values();

        $group = new Group();
        $group->set_name($values['organization_name']);
        $group->set_parent(0);
        $group->set_code(strtolower($values['organization_name']));
        $group->create();

        return true;
    }

    public function get_additional_packages()
    {
        $installers = array();
        $installers[] = 'group\integration\tracking';
        $installers[] = 'group\integration\webservice';
        return $installers;
    }
}
