<?php
namespace reporting;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'Reporting' => '/lib/reporting.class.php',
         'ReportingBlock' => '/lib/reporting_block.class.php',
         'ReportingData' => '/lib/reporting_data.class.php',
         'ReportingDataManager' => '/lib/reporting_data_manager.class.php',
         'ReportingDataManagerInterface' => '/lib/reporting_data_manager_interface.class.php',
         'ReportingExporter' => '/lib/reporting_exporter.class.php',
         'ReportingFormatter' => '/lib/reporting_formatter.class.php',
         'ReportingTemplate' => '/lib/reporting_template.class.php',
         'ReportingTemplateMenu' => '/lib/reporting_template_menu.class.php',
         'ReportingTemplateRegistration' => '/lib/reporting_template_registration.class.php',
         'ReportingTemplateViewer' => '/lib/reporting_template_viewer.class.php',
         'Mdb2ReportingDataManager' => '/lib/data_manager/mdb2.class.php',
         'ReportingCsvExporter' => '/lib/exporters/reporting_csv_exporter.class.php',
         'ReportingExcelExporter' => '/lib/exporters/reporting_excel_exporter.class.php',
         'ReportingOdsExporter' => '/lib/exporters/reporting_ods_exporter.class.php',
         'ReportingPdfExporter' => '/lib/exporters/reporting_pdf_exporter.class.php',
         'ReportingXmlExporter' => '/lib/exporters/reporting_xml_exporter.class.php',
         'ReportingChartFormatter' => '/lib/formatters/reporting_chart_formatter.class.php',
         'ReportingHtmlFormatter' => '/lib/formatters/reporting_html_formatter.class.php',
         'ReportingTableFormatter' => '/lib/formatters/reporting_table_formatter.class.php',
         'ReportingTextFormatter' => '/lib/formatters/reporting_text_formatter.class.php',
         'BarPchartReportingChartFormatter' => '/lib/formatters/pchart/bar_pchart_reporting_chart_formatter.class.php',
         'FilledCubicPchartReportingChartFormatter' => '/lib/formatters/pchart/filledcubic_pchart_reporting_chart_formatter.class.php',
         'LinePchartReportingChartFormatter' => '/lib/formatters/pchart/line_pchart_reporting_chart_formatter.class.php',
         'PchartReportingChartFormatter' => '/lib/formatters/pchart/pchart_reporting_chart_formatter.class.php',
         'PiePchartReportingChartFormatter' => '/lib/formatters/pchart/pie_pchart_reporting_chart_formatter.class.php',
         'ReportingFormatterForm' => '/lib/forms/reporting_formatter_form.class.php',
         'ReportingTemplateRegistrationForm' => '/lib/forms/reporting_template_registration_form.class.php',
         'ReportingManager' => '/lib/reporting_manager/reporting_manager.class.php',
         'ReportingManagerAddComponent' => '/lib/reporting_manager/component/add.class.php',
         'ReportingManagerBrowserComponent' => '/lib/reporting_manager/component/browser.class.php',
         'ReportingManagerDeleteComponent' => '/lib/reporting_manager/component/delete.class.php',
         'ReportingManagerEditComponent' => '/lib/reporting_manager/component/edit.class.php',
         'ReportingManagerExportComponent' => '/lib/reporting_manager/component/export.class.php',
         'ReportingManagerViewComponent' => '/lib/reporting_manager/component/view.class.php',
         'ReportingTemplateRegistrationBrowserTable' => '/lib/reporting_manager/component/reporting_template_registration_browser_table/reporting_template_registration_browser_table.class.php',
         'ReportingTemplateRegistrationBrowserTableCellRenderer' => '/lib/reporting_manager/component/reporting_template_registration_browser_table/reporting_template_registration_browser_table_cell_renderer.class.php',
         'ReportingTemplateRegistrationBrowserTableColumnModel' => '/lib/reporting_manager/component/reporting_template_registration_browser_table/reporting_template_registration_browser_table_column_model.class.php',
         'ReportingTemplateRegistrationBrowserTableDataProvider' => '/lib/reporting_manager/component/reporting_template_registration_browser_table/reporting_template_registration_browser_table_data_provider.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php',
         'ReportingValidator' => '/validator/reporting_validator.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>