<?php
namespace reporting\viewer;

/**
 *
 * @author Hans De Bisschop & Magali Gillard
 * @package reporting.viewer
 */
abstract class AbstractBlockRenditionImplementation
{

    /**
     *
     * @var \common\libraries\Application
     */
    private $context;

    /**
     *
     * @var \reporting\ReportingBlock
     */
    private $block;

    /**
     *
     * @param \common\libraries\Application $context
     * @param ReportingBlock $block
     */
    public function __construct($context, ReportingBlock $block)
    {
        $this->context = $context;
        $this->block = $block;
    }

    /**
     *
     * @return \common\libraries\Application
     */
    public function get_context()
    {
        return $this->context;
    }

    /**
     *
     * @param \common\libraries\Application $context
     */
    public function set_context($context)
    {
        $this->context = $context;
    }

    /**
     *
     * @return \reporting\ReportingBlock
     */
    public function get_block()
    {
        return $this->block;
    }

    /**
     *
     * @param ReportingBlock $block
     */
    public function set_block(ReportingBlock $block)
    {
        $this->block = $block;
    }

    /**
     *
     * @return string
     */
    abstract public function get_view();

    /**
     *
     * @return string
     */
    abstract public function get_format();
}
