<?php
namespace reporting\viewer;

/**
 *
 * @author Hans De Bisschop & Magali Gillard
 * @package reporting.viewer
 */
class DummyBlockRenditionImplementation extends AbstractBlockRenditionImplementation
{

    /**
     *
     * @var string
     */
    private $format;

    /**
     *
     * @var string
     */
    private $view;

    /**
     *
     * @param \common\libraries\Application $context
     * @param ReportingBlock $block
     * @param string $format
     * @param string $view
     */
    public function __construct($context, ReportingBlock $block, $format, $view)
    {
        parent :: __construct($context, $block);
        $this->format = $format;
        $this->view = $view;
    }

    /**
     *
     * @return string
     */
    public function render()
    {
        return BlockRendition :: launch($this);
    }

    /**
     *
     * @see \reporting\AbstractBlockRenditionImplementation::get_view()
     */
    public function get_view()
    {
        return $this->view;
    }

    /**
     *
     * @see \reporting\AbstractBlockRenditionImplementation::get_format()
     */
    public function get_format()
    {
        return $this->format;
    }
}
