<?php
namespace reporting\viewer;

use common\libraries\Translation;
use common\libraries\Display;
use common\libraries\Utilities;
use common\libraries\Path;

// require_once Path :: get_plugin_path() . '/pChart/pChart/pChart.class';
// require_once Path :: get_plugin_path() . '/pChart/pChart/pData.class';
/**
 *
 * @author Hans De Bisschop & Magali Gillard
 * @package reporting.viewer
 */
abstract class HtmlChartBlockRendition extends HtmlBlockRendition
{

    /**
     *
     * @return string
     */
    public function get_content()
    {
        $path = $this->get_path();
        if ($path)
        {
            return '<img src="' . $this->get_path() . '" border="0" />';
        }
        else
        {
            return Display :: normal_message(Translation :: get('NoDataNoChart'), true);
        }
    }

    /**
     *
     * @return string
     */
    abstract public function get_path();

    /**
     *
     * @return multitype:mixed
     */
    public function convert_reporting_data()
    {
        $reporting_data = $this->get_block()->retrieve_data();
        if ($reporting_data->is_empty())
        {
            return false;
        }
        else
        {
            $chart = array();
            $chart_description = array();
            $chart_data = array();

            $chart_description['Position'] = 'Name';
            $chart_description['Values'] = array();
            $chart_description['Description'] = array();
            foreach ($reporting_data->get_rows() as $row_id => $row_name)
            {
                $chart_description['Values'][$row_id] = 'Serie' . $row_id;
                $chart_description['Description']['Serie' . $row_id] = trim(
                        trim(trim(html_entity_decode(strip_tags($row_name), ENT_COMPAT, 'utf-8')), "\xC2\xA0"));
            }

            $chart[1] = $chart_description;

            foreach ($reporting_data->get_categories() as $category_id => $category_name)
            {
                $category_array = array();
                $category_array['Name'] = trim(
                        trim(html_entity_decode(strip_tags($category_name), ENT_COMPAT, 'utf-8')), "\xC2\xA0");
                foreach ($reporting_data->get_rows() as $row_id => $row_name)
                {
                    $category_array['Serie' . $row_id] = $reporting_data->get_data_category_row($category_id, $row_id);
                }
                $chart_data[] = $category_array;
            }

            $chart[0] = $chart_data;
            return $chart;
        }
    }

    protected function strip_data_names($data)
    {
        foreach ($data as $key => $value)
        {
            foreach ($value as $key2 => $value2)
            {
                if ($key2 == "Name")
                {
                    $value[$key2] = Utilities :: truncate_string(
                            trim(html_entity_decode(strip_tags($value2), ENT_COMPAT, 'utf-8')), 30, false, '...');
                }
            }
            $data[$key] = $value;
        }
        return $data;
    }
}
