<?php
namespace reporting\viewer;

use common\libraries\Utilities;

/**
 *
 * @author Hans De Bisschop & Magali Gillard
 * @package reporting.viewer
 */
abstract class BlockRenditionImplementation extends AbstractBlockRenditionImplementation
{

    /**
     *
     * @param \common\libraries\Application $context
     * @param ReportingBlock $block
     * @param string $format
     * @param string $view
     */
    public static function launch($context, ReportingBlock $block, $format = BlockRendition :: FORMAT_HTML, $view = null)
    {
        return self :: factory($context, $block, $format, $view)->render();
    }

    /**
     *
     * @param \common\libraries\Application $context
     * @param ReportingBlock $block
     * @param string $format
     * @param string $view
     * @return \reporting\DummyContentObjectRenditionImplementation \reporting\BlockRenditionImplementation
     */
    public static function factory($context, ReportingBlock $block, $format = BlockRendition :: FORMAT_HTML, $view = null)
    {
        $namespace = Utilities :: get_namespace_from_object($block);
        $class = $namespace . '\\' . Utilities :: underscores_to_camelcase($format) . Utilities :: underscores_to_camelcase(
                $view) . 'BlockRenditionImplementation';

        if (! class_exists($class, true))
        {
            return new DummyBlockRenditionImplementation($context, $block, $format, $view);
        }
        else
        {
            return new $class($context, $block);
        }
    }

    /**
     *
     * @return string
     */
    public function get_view()
    {
        $class_name_parts = explode('_', Utilities :: get_classname_from_object($this, true));
        return $class_name_parts[1];
    }

    /**
     *
     * @return string
     */
    public function get_format()
    {
        $class_name_parts = explode('_', Utilities :: get_classname_from_object($this, true));
        return $class_name_parts[0];
    }
}
