<?php
namespace reporting\viewer;

use common\libraries\Utilities;
use common\libraries\Translation;

/**
 *
 * @author Hans De Bisschop & Magali Gillard
 * @package reporting.viewer
 */
class XmlDefaultBlockRendition extends XmlBlockRendition
{

    public function render()
    {
        $data = $this->get_block()->retrieve_data();

        $xml_data = array();
        $placeholders = array(' ', '#');
        $replace_by = array('_', 'no');

        foreach ($data->get_categories() as $category_id => $category_name)
        {
            $category_array = array();

            if ($data->is_categories_visible())
            {
                $category_array[str_replace(' ', '_',
                        strtolower(Translation :: get('Category', null, Utilities :: COMMON_LIBRARIES)))] = $category_name;
            }

            foreach ($data->get_rows() as $row_id => $row_name)
            {
                $category_array[str_replace($placeholders, $replace_by, strtolower($row_name))] = strip_tags(
                        $data->get_data_category_row($category_id, $row_id));
            }

            $xml_data[] = $category_array;
        }
        return $xml_data;
    }
}
