<?php
namespace repository\content_object\assessment;

use common\libraries\DelegateComponent;
use common\libraries\Translation;
use repository\ComplexBuilderComponent;
use repository\ComplexBuilder;

/**
 * $Id: browser.class.php 200 2009-11-13 12:30:04Z kariboe $
 *
 * @package repository.lib.complex_builder.assessment.component
 */
class AssessmentBuilderBrowserComponent extends AssessmentBuilder implements DelegateComponent
{

    public function run()
    {
        $browser = ComplexBuilderComponent :: factory(ComplexBuilderComponent :: BROWSER_COMPONENT, $this);
        $browser->run();
    }

    public function get_additional_links()
    {
        $link['type'] = 'merge';
        $link['url'] = $this->get_url(
            array(ComplexBuilder :: PARAM_BUILDER_ACTION => AssessmentBuilder :: ACTION_MERGE_ASSESSMENT));
        $link['title'] = Translation :: get('MergeAssessment');
        $links[] = $link;

        $link['type'] = 'select';
        $link['url'] = $this->get_url(
            array(
                ComplexBuilder :: PARAM_BUILDER_ACTION => self :: ACTION_CREATE_COMPLEX_CONTENT_OBJECT_ITEM,
                \repository\viewer\Manager :: PARAM_ACTION => \repository\viewer\Manager :: ACTION_BROWSER));
        $link['title'] = Translation :: get('SelectQuestions');
        $links[] = $link;

        $link['type'] = 'randomize';
        $link['url'] = $this->get_url(
            array(ComplexBuilder :: PARAM_BUILDER_ACTION => self :: ACTION_RANDOMIZE));
        $link['title'] = Translation :: get('RandomizeQuestionOptions');
        $links[] = $link;

        $link['type'] = 'feedback_option_all';
        $link['url'] = $this->get_url(
            array(ComplexBuilder :: PARAM_BUILDER_ACTION => self :: ACTION_FEEDBACK_OPTION, self :: PARAM_FEEDBACK_OPTION_TYPE => 1));
        $link['title'] = Translation :: get('FeedbackOptionAll');
        $links[] = $link;

        $link['type'] = 'feedback_option_selected';
        $link['url'] = $this->get_url(
            array(ComplexBuilder :: PARAM_BUILDER_ACTION => self :: ACTION_FEEDBACK_OPTION, self :: PARAM_FEEDBACK_OPTION_TYPE => 2));
        $link['title'] = Translation :: get('FeedbackOptionSelected');
        $links[] = $link;

        return $links;
    }

    public function get_complex_content_object_table_column_model()
    {
        return new AssessmentBrowserTableColumnModel($this);
    }

    public function get_complex_content_object_table_cell_renderer()
    {
        return new AssessmentBrowserTableCellRenderer($this, $this->get_complex_content_object_table_condition());
    }
}
