<?php
namespace repository\content_object\assessment;

use repository\content_object\ordering_question\OrderingQuestion;
use repository\content_object\assessment_match_text_question\AssessmentMatchTextQuestion;
use repository\content_object\assessment_match_numeric_question\AssessmentMatchNumericQuestion;
use repository\content_object\assessment_matrix_question\AssessmentMatrixQuestion;
use repository\content_object\assessment_select_question\AssessmentSelectQuestion;
use repository\content_object\assessment_matching_question\AssessmentMatchingQuestion;
use repository\content_object\assessment_multiple_choice_question\AssessmentMultipleChoiceQuestion;
use repository\content_object\fill_in_blanks_question\FillInBlanksQuestion;
use repository\content_object\hotspot_question\HotspotQuestion;
use repository\content_object\assessment_open_question\AssessmentOpenQuestion;
use repository\content_object\assessment_rating_question\AssessmentRatingQuestion;

use repository\ComplexContentObjectItem;
/**
 * $Id: complex_assessment.class.php 200 2009-11-13 12:30:04Z kariboe $
 * @package repository.lib.content_object.assessment
 *
 */
/**
 * This class represents a complex assessment (used to create complex learning objects)
 */
class ComplexAssessment extends ComplexContentObjectItem
{

    public function get_allowed_types()
    {
        $allowed_types = array();
        $allowed_types[] = AssessmentRatingQuestion :: class_name();
        $allowed_types[] = AssessmentOpenQuestion :: class_name();
        $allowed_types[] = HotspotQuestion :: class_name();
        $allowed_types[] = FillInBlanksQuestion :: class_name();
        $allowed_types[] = AssessmentMultipleChoiceQuestion :: class_name();
        $allowed_types[] = AssessmentMatchingQuestion :: class_name();
        $allowed_types[] = AssessmentSelectQuestion :: class_name();
        $allowed_types[] = AssessmentMatrixQuestion :: class_name();
        $allowed_types[] = AssessmentMatchNumericQuestion :: class_name();
        $allowed_types[] = AssessmentMatchTextQuestion :: class_name();
        $allowed_types[] = OrderingQuestion :: class_name();
        return $allowed_types;
    }
}
