<?php
namespace repository\content_object\assessment_multiple_choice_question;

use repository\ComplexContentObjectItem;

/**
 * $Id: complex_assessment_multiple_choice_question.class.php 200 2009-11-13 12:30:04Z kariboe $
 *
 * @package repository.lib.content_object.multiple_choice_question
 */

/**
 * This class represents a complex assessment (used to create complex learning objects)
 */
class ComplexAssessmentMultipleChoiceQuestion extends ComplexContentObjectItem
{
    const PROPERTY_WEIGHT = 'weight';
    const PROPERTY_RANDOM = 'random';
    const PROPERTY_FEEDBACK_OPTIONS = 'feedback_options';
    const PROPERTY_FEEDBACK_ANSWER = 'feedback_answer';
    const FEEDBACK_OPTIONS_ALL = 1;
    const FEEDBACK_OPTIONS_SELECTED = 2;

    public static function get_additional_property_names()
    {
        return array(self :: PROPERTY_WEIGHT, self :: PROPERTY_RANDOM, self :: PROPERTY_FEEDBACK_OPTIONS, self :: PROPERTY_FEEDBACK_ANSWER);
    }

    public function get_weight()
    {
        return $this->get_additional_property(self :: PROPERTY_WEIGHT);
    }

    public function set_weight($value)
    {
        $this->set_additional_property(self :: PROPERTY_WEIGHT, $value);
    }

    public function get_random()
    {
        return $this->get_additional_property(self :: PROPERTY_RANDOM);
    }

    public function set_random($value)
    {
        $this->set_additional_property(self :: PROPERTY_RANDOM, $value);
    }

    public function get_feedback_options()
    {
        return $this->get_additional_property(self :: PROPERTY_FEEDBACK_OPTIONS);
    }

    public function set_feedback_options($value)
    {
        $this->set_additional_property(self :: PROPERTY_FEEDBACK_OPTIONS, $value);
    }

    public function get_feedback_answer()
    {
        return $this->get_additional_property(self :: PROPERTY_FEEDBACK_ANSWER);
    }

    public function set_feedback_answer($value)
    {
        $this->set_additional_property(self :: PROPERTY_FEEDBACK_ANSWER, $value);
    }

    // TODO: should be moved to an additional parent layer "complex_question" which offers this implementation to EACH
    // complex question object.
    public function get_default_question_weight()
    {
        $reference = parent :: get_ref_object();
        if ($reference)
        {
            return $reference->get_default_weight();
        }
        return 1;
    }

    /**
     * If we set the parent, we update the default weight to the parents default.
     */
    public function set_parent($parent)
    {
        // TODO: should be moved to an additional parent layer "complex_question" which offers this implementation to
        // EACH
        // complex question object.
        parent :: set_parent($parent);
        $this->set_weight($this->get_default_question_weight());
    }
}
