<?php
namespace repository\content_object\assessment_open_question;

use repository\ComplexContentObjectItem;

/**
 * $Id: complex_assessment_open_question.class.php 200 2009-11-13 12:30:04Z kariboe $
 * @package repository.lib.content_object.open_question
 */
/**
 * This class represents a complex exercise (used to create complex learning objects)
 */
class ComplexAssessmentOpenQuestion extends ComplexContentObjectItem
{
    
    const PROPERTY_WEIGHT = 'weight';

    public static function get_additional_property_names()
    {
        return array(self :: PROPERTY_WEIGHT);
    }

    public function get_weight()
    {
        return $this->get_additional_property(self :: PROPERTY_WEIGHT);
    }

    public function set_weight($value)
    {
        $this->set_additional_property(self :: PROPERTY_WEIGHT, $value);
    }

    //TODO: should be moved to an additional parent layer "complex_question" which offers this implementation to EACH
    // complex question object.
    public function get_default_question_weight()
    {
        $reference = parent :: get_ref_object();
        if ($reference)
        {
            return $reference->get_default_weight();
        }
        return 1;
    }

    /**
     *If we set the parent, we update the default weight to the parents default.
     */
    public function set_parent($parent)
    {
        //TODO: should be moved to an additional parent layer "complex_question" which offers this implementation to EACH
        // complex question object.
        parent :: set_parent($parent);
        $this->set_weight($this->get_default_question_weight());
    }
}
