<?php
namespace repository\content_object\assignment;

use common\libraries\Session;
use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;

class AssignmentAjaxClearParameter extends AjaxManager
{
    const PARAM_PARAMETER = 'parameter';

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_PARAMETER);
    }

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $parameter = $this->get_parameter(self :: PARAM_PARAMETER);
        $parameter = explode('_', $parameter, 3);
        
        $session = unserialize(Session :: retrieve('advanced_filter'));
        
        if ($parameter[1] == 'assignment')
        {
            switch ($parameter[2])
            {
                case 'start_time' :
                    unset($session[Assignment :: PROPERTY_START_TIME]);
                    break;
                case 'end_time' :
                    unset($session[Assignment :: PROPERTY_END_TIME]);
                    break;
                case 'time' :
                    unset($session[Assignment :: PROPERTY_START_TIME]);
                    unset($session[Assignment :: PROPERTY_END_TIME]);
                    break;
            }
            
            Session :: register('advanced_filter', serialize($session));
            JsonAjaxResult :: success();
        }
        else
        {
            JsonAjaxResult :: bad_request();
        }
    }
}
