<?php
namespace repository\content_object\blog;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'BlogDifference' => '/lib/difference.class.php',
         'BlogDifferenceDisplay' => '/lib/difference_display.class.php',
         'BlogDisplay' => '/lib/display.class.php',
         'BlogBuilder' => '/lib/builder/blog_builder.class.php',
         'BlogBuilderAttachmentViewerComponent' => '/lib/builder/component/attachment_viewer.class.php',
         'BlogBuilderBrowserComponent' => '/lib/builder/component/browser.class.php',
         'BlogBuilderCreatorComponent' => '/lib/builder/component/creator.class.php',
         'BlogBuilderDeleterComponent' => '/lib/builder/component/deleter.class.php',
         'BlogBuilderMoverComponent' => '/lib/builder/component/mover.class.php',
         'BlogBuilderPreviewComponent' => '/lib/builder/component/preview.class.php',
         'BlogBuilderUpdaterComponent' => '/lib/builder/component/updater.class.php',
         'BlogBuilderViewerComponent' => '/lib/builder/component/viewer.class.php',
         'BlogComplexDisplay' => '/lib/complex_display/blog_complex_display.class.php',
         'BlogComplexDisplayPreview' => '/lib/complex_display/blog_complex_display_preview.class.php',
         'BlogComplexDisplaySupport' => '/lib/complex_display/blog_complex_display_support.class.php',
         'BlogComplexDisplayAttachmentViewerComponent' => '/lib/complex_display/component/attachment_viewer.class.php',
         'BlogComplexDisplayCreatorComponent' => '/lib/complex_display/component/creator.class.php',
         'BlogComplexDisplayDeleterComponent' => '/lib/complex_display/component/deleter.class.php',
         'BlogComplexDisplayUpdaterComponent' => '/lib/complex_display/component/updater.class.php',
         'BlogComplexDisplayViewerComponent' => '/lib/complex_display/component/viewer.class.php',
         'BlogLayout' => '/lib/complex_display/component/viewer/blog_layout.class.php',
         'PersonalBlogLayout' => '/lib/complex_display/component/viewer/blog_layout/personal_blog_layout.class.php',
         'ComplexBlog' => '/lib/data_class/complex_content_object_item.class.php',
         'Blog' => '/lib/data_class/content_object.class.php',
         'DataManager' => '/lib/data_manager/data_manager.class.php',
         'DataManagerInterface' => '/lib/data_manager/data_manager_interface.class.php',
         'DoctrineDataManager' => '/lib/data_manager/implementation/doctrine.class.php',
         'Mdb2DataManager' => '/lib/data_manager/implementation/mdb2.class.php',
         'ComplexBlogForm' => '/lib/form/complex_content_object_item.class.php',
         'BlogForm' => '/lib/form/content_object.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php',
         'Remover' => '/package/remove/remover.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>