<?php
namespace repository\content_object\blog;

use common\libraries\Translation;
use common\libraries\Utilities;
use common\libraries\BreadcrumbTrail;
use common\libraries\ActionBarRenderer;
use common\libraries\ToolbarItem;
use common\libraries\Theme;
use common\libraries\DelegateComponent;

use repository\content_object\blog_item\BlogItem;
use repository\ComplexDisplay;

/**
 * $Id: blog_viewer.class.php 200 2009-11-13 12:30:04Z kariboe $
 * 
 * @package repository.lib.complex_display.blog.component
 */

class BlogComplexDisplayViewerComponent extends BlogComplexDisplay implements DelegateComponent
{
    private $action_bar;

    public function run()
    {
        $this->action_bar = $this->get_action_bar();
        
        $blog = $this->get_root_content_object();
        
        $trail = BreadcrumbTrail :: get_instance();
        
        $blog_layout = BlogLayout :: factory($this, $blog);
        
        $this->display_header();
        echo $this->action_bar->as_html();
        $blog_layout->render();
        $this->display_footer();
    }

    public function get_action_bar()
    {
        $action_bar = new ActionBarRenderer(ActionBarRenderer :: TYPE_HORIZONTAL);
        
        if ($this->get_parent()->is_allowed_to_add_child())
        {
            $action_bar->add_common_action(new ToolbarItem(Translation :: get('CreateItem', null, Utilities :: COMMON_LIBRARIES), Theme :: get_common_image_path() . 'action_create.png', $this->get_url(array(
                    ComplexDisplay :: PARAM_DISPLAY_ACTION => ComplexDisplay :: ACTION_CREATE_COMPLEX_CONTENT_OBJECT_ITEM, 
                    ComplexDisplay :: PARAM_TYPE => BlogItem :: class_name())), ToolbarItem :: DISPLAY_ICON_AND_LABEL));
        }
        
        return $action_bar;
    }
}
