<?php
namespace repository\content_object\document;

use common\libraries\AndCondition;
use common\libraries\EqualityCondition;

class DataManager extends \common\libraries\DataManager
{

    /**
     * Gets the type of DataManager to be instantiated
     * 
     * @return string
     */
    public static function get_type()
    {
        return 'doctrine';
    }

    public static function get_document_id_by_hash($hash)
    {
        $condition = new EqualityCondition(Document :: PROPERTY_HASH, $hash);
        $document = \repository\DataManager :: retrieve_active_content_objects(Document :: class_name(), $condition)->next_result();
        
        if ($document)
        {
            return $document->get_id();
        }
        
        return false;
    }

    public static function retrieve_document_from_hash($user_id, $hash)
    {
        $conditions = array();
        $conditions[] = new EqualityCondition(Document :: PROPERTY_HASH, $hash, 'document');
        $conditions[] = new EqualityCondition(Document :: PROPERTY_OWNER_ID, $user_id);
        $condition = new AndCondition($conditions);
        
        return \repository\DataManager :: retrieve_content_object_by_condition(Document :: class_name(), $condition);
    }

    public static function get_document_by_filename($filename)
    {
        $condition = new EqualityCondition(Document :: PROPERTY_FILENAME, $filename, 'document');
        return \repository\DataManager :: retrieve_content_object_by_condition(Document :: class_name(), $condition);
    }

    public static function is_only_document_occurence($path)
    {
        $condition = new EqualityCondition(Document :: PROPERTY_PATH, $path);
        $count = \repository\DataManager :: count_content_objects(Document :: class_name(), $condition);
        
        return ($count == 1 ? true : false);
    }
}
