<?php
namespace repository\content_object\file;

use common\libraries\AndCondition;
use common\libraries\EqualityCondition;

class DataManager extends \common\libraries\DataManager
{

    /**
     * Gets the type of DataManager to be instantiated
     * 
     * @return string
     */
    public static function get_type()
    {
        return 'doctrine';
    }

    public static function get_file_id_by_hash($hash)
    {
        $condition = new EqualityCondition(File :: PROPERTY_HASH, $hash);
        $file = \repository\DataManager :: retrieve_active_content_objects(File :: class_name(), $condition)->next_result();
        
        if ($file)
        {
            return $file->get_id();
        }
        
        return false;
    }

    public static function retrieve_file_from_hash($user_id, $hash)
    {
        $conditions = array();
        $conditions[] = new EqualityCondition(File :: PROPERTY_HASH, $hash, 'file');
        $conditions[] = new EqualityCondition(File :: PROPERTY_OWNER_ID, $user_id);
        $condition = new AndCondition($conditions);
        
        return \repository\DataManager :: retrieve_content_object_by_condition(File :: class_name(), $condition);
    }

    public static function get_file_by_filename($filename)
    {
        $condition = new EqualityCondition(File :: PROPERTY_FILENAME, $filename, 'file');
        return \repository\DataManager :: retrieve_content_object_by_condition(File :: class_name(), $condition);
    }

    public static function is_only_file_occurence($path)
    {
        $condition = new EqualityCondition(File :: PROPERTY_PATH, $path);
        $count = \repository\DataManager :: count_content_objects(File :: class_name(), $condition);
        
        return ($count == 1 ? true : false);
    }
}
