<?php
namespace repository\content_object\file;

use repository\ContentObjectRendition;

use common\libraries\Path;
use common\libraries\ImageManipulation;

class HtmlThumbnailRenditionImplementation extends HtmlRenditionImplementation
{

    public function render()
    {
        $object = $this->get_content_object();
        if ($object->is_image())
        {
            $width = 100;
            $height = 100;
            
            $thumbnail_path = Path :: get_temp_path() . md5($object->get_full_path()) . basename($object->get_full_path());
            $thumbnal_web_path = Path :: get(WEB_TEMP_PATH) . md5($object->get_full_path()) . basename($object->get_full_path());
            if (! is_file($thumbnail_path))
            {
                $thumbnail_creator = ImageManipulation :: factory($object->get_full_path());
                $thumbnail_creator->scale($width, $height);
                $thumbnail_creator->write_to_file($thumbnail_path);
            }
            return '<img src="' . $thumbnal_web_path . '" title="' . $object->get_title() . '" class="thumbnail" />';
        }
        else
        {
            return ContentObjectRendition :: launch($this);
        }
    }
}
