<?php
namespace repository\content_object\forum;

use common\libraries\Translation;
use common\libraries\Utilities;
use common\libraries\Request;
use common\libraries\Breadcrumb;

use repository\content_object\forum_topic\DataManager as ForumTopicDataManager;
use repository\content_object\forum_topic\ForumPost;
use repository\content_object\forum_topic\ForumPostForm;
use repository\ComplexDisplay;

/**
 * @author Mattias De Pauw - Hogeschool Gent
 * @author Maarten Volckaert - Hogeschool Gent
*/
class ForumComplexDisplayForumPostQuoterComponent extends ForumPostFormActionCreate
{
    protected $forumpost;
    protected $form;
    protected $selected_forum_post_id;

    /**
     * makes a new quoter form and if its validate makes a new quoter post 
     */
    public function run()
    {
        $this->selected_forum_post_id = Request :: get(self :: PARAM_SELECTED_FORUM_POST);

        $quote_lo = ForumTopicDataManager :: retrieve_by_id(ForumPost :: class_name(), $this->selected_forum_post_id);
        
        $this->forumpost = new ForumPost();
        
        if (substr($quote_lo->get_title(), 0, 3) == 'RE:')
        {
            $reply = $quote_lo->get_title();
        }
        else
        {
            $reply = 'RE: ' . $quote_lo->get_title();
        }
        
        $this->forumpost->set_title($reply);
        $content = '[quote="' . \user\DataManager :: retrieve(\user\User :: class_name(), (int) $quote_lo->get_user_id())->get_fullname() . '"]' . $quote_lo->get_content() . '[/quote]';
        $this->forumpost->set_content($content);
        
        $this->form = new ForumPostForm(ForumPostForm :: TYPE_QUOTE, $this->get_url(array(
                self :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID => $this->get_complex_content_object_item_id(), 
                self :: PARAM_SELECTED_FORUM_POST => $this->selected_forum_post_id)), $this->forumpost, $this->selected_forum_post_id);
        
        if ($this->form->validate())
        {
            $success = parent :: create_forum_post(ForumPostForm :: TYPE_QUOTE);
            
            $this->my_redirect($success);
        }
        else
        {
            $this->add_common_breadcrumbtrails();
            $this->display_header();
            $this->form->display();
            $this->display_footer();
        }
    }

    /**
     * redirect
     * 
     * @param type $success 
     */
    private function my_redirect($success)
    {
        $message = htmlentities(Translation :: get(($success ? 'ObjectCreated' : 'ObjectNotCreated'), array(
                'OBJECT' => Translation :: get('ForumPost')), Utilities :: COMMON_LIBRARIES));
        $params = array();
        $params[ComplexDisplay :: PARAM_DISPLAY_ACTION] = ForumComplexDisplay :: ACTION_VIEW_TOPIC;
        $params[ComplexDisplay :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID] = $this->get_complex_content_object_item_id();
        $this->redirect($message, ($success ? false : true), $params);
    }

    /**
     * add the breaddcrumps 
     */
    
    public function add_common_breadcrumbtrails()
    {
        $trail = parent :: add_common_breadcrumbtrails();
        $trail->add(new Breadcrumb($this->get_url(array(
                self :: PARAM_SELECTED_FORUM_POST => $this->selected_forum_post_id)), Translation :: get('ReplyOnPost', null, 'repository\content_object\forum_topic')));
    }
}
