<?php
namespace repository\content_object\forum;

use common\libraries\Utilities;
use common\libraries\Translation;

use repository\ComplexDisplay;

/**
 * $Id: sticky.class.php 200 2009-11-13 12:30:04Z kariboe $
 * @package repository.lib.complex_builder.forum.component
 */
class ForumComplexDisplayStickyComponent extends ForumComplexDisplay
{

    public function run()
    {
        $topic = $this->get_selected_complex_content_object_item();
        
        if ($topic->get_forum_type() == 1)
        {
            $topic->set_forum_type(null);
            $message = Translation :: get('TopicUnStickied');
        }
        else
        {
            $topic->set_forum_type(1);
            $message = Translation :: get('TopicStickied');
        }
        $success = $topic->update();
        
        if (! $success)
        {
            $message = Translation :: get('ObjectNotUpdated', array('OBJECT' => Translation :: get('ForumTopic')), Utilities:: COMMON_LIBRARIES);
        }
        
        $params = array();
        $params[ComplexDisplay :: PARAM_DISPLAY_ACTION] = ForumComplexDisplay :: ACTION_VIEW_FORUM;
        $params[ComplexDisplay :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID] = $this->get_complex_content_object_item_id();
        
        $this->redirect($message, ($success ? false : true), $params);
    }
}
