<?php
namespace repository\content_object\forum;

use repository\content_object\forum_topic\DataManager as ForumTopicDataManager;
use repository\ComplexDisplay;
use repository\ContentObject;

use common\libraries\Request;
use common\libraries\Translation;

/**
 * Component class responsible for the unsubscribing process of a topic.
 *
 * @author Mattias De Pauw - Hogeschool Gent
 * @author Maarten Volckaert - Hogeschool Gent
 */
class ForumComplexDisplayTopicUnsubscribeComponent extends ForumComplexDisplay
{
    public function run()
    {
        $success = false;
        $subscribe_id = Request :: get(ForumComplexDisplay :: PARAM_SUBSCRIBE_ID);
        
        if($subscribe_id)
        {
            $subscribe = ForumTopicDataManager :: retrieve_subscribe($subscribe_id, null);
            $success = $subscribe && $subscribe->delete();
        }
        
        $message = Translation :: get($success ? 'SuccesUnsubscribe' : 'UnSuccesUnSubscribe', null, ContentObject :: get_content_object_type_namespace('forum_topic'));
        
        $params = array();
        $params[ComplexDisplay :: PARAM_DISPLAY_ACTION] = ForumComplexDisplay :: ACTION_VIEW_FORUM;
        $params[ComplexDisplay :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID] = $this->get_complex_content_object_item_id();
        $this->redirect($message, ($success ? false : true), $params);
    }
}
