<?php
namespace repository\content_object\forum;

use repository\ComplexDisplayPreview;
use repository\ComplexDisplay;

class ForumComplexDisplayPreview extends ComplexDisplayPreview implements ForumComplexDisplaySupport
{

    public function run()
    {
        ComplexDisplay :: launch(Forum :: class_name(), $this);
    }

    /**
     * Since this is a preview, no actual view event is triggered.
     *
     * @param $complex_topic_id
     */
    public function forum_topic_viewed($complex_topic_id)
    {
    }

    /**
     * Since this is a preview, no views are logged and no count can
     * be retrieved.
     *
     * @param $complex_topic_id
     * @return string
     */
    public function forum_count_topic_views($complex_topic_id)
    {
        return '-';
    }

    /**
     * Considering that this is a preview, always return true
     *
     * @param $right
     * @return boolean
     */
    public function is_allowed($right)
    {
        return true;
    }
    /**
     * checks wether the user is forum manager here in repository is always true
     *
     * @param type $user
     *
     * @return true
     */
    public function is_forum_manager($user) {
        return true;

    }


        // FUNCTIONS FOR COMPLEX DISPLAY SUPPORT
     public function is_allowed_to_edit_content_object()
    {
       return true;
    }

    public function is_allowed_to_view_content_object()
    {
        return true;
    }

    public function is_allowed_to_add_child()
    {
        return true;
    }
    public function is_allowed_to_delete_child()
    {
        return true;
    }
    public function is_allowed_to_delete_feedback()
    {
        return true;
    }
    public function is_allowed_to_edit_feedback()
    {
        return true;
    }
}
