<?php
namespace repository\content_object\forum_topic;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'ForumTopicDifference' => '/lib/difference.class.php',
         'ForumTopicDifferenceDisplay' => '/lib/difference_display.class.php',
         'ForumTopicDisplay' => '/lib/display.class.php',
         'ComplexForumTopic' => '/lib/data_class/complex_content_object_item.class.php',
         'ForumTopic' => '/lib/data_class/content_object.class.php',
         'ForumPost' => '/lib/data_class/forum_post.class.php',
         'ForumPostAttachment' => '/lib/data_class/forum_post_attachment.class.php',
         'ForumTopicSubscribe' => '/lib/data_class/forum_topic_subscribe.class.php',
         'DataManager' => '/lib/data_manager/data_manager.class.php',
         'DataManagerInterface' => '/lib/data_manager/data_manager_interface.class.php',
         'DoctrineDataManager' => '/lib/data_manager/implementation/doctrine.class.php',
         'Mdb2DataManager' => '/lib/data_manager/implementation/mdb2.class.php',
         'ComplexForumTopicForm' => '/lib/form/complex_content_object_item.class.php',
         'ForumTopicForm' => '/lib/form/content_object.class.php',
         'ForumPostForm' => '/lib/form/forum_post.class.php',
         'ExportImplementation' => '/lib/implementation/export.class.php',
         'RenditionImplementation' => '/lib/implementation/rendition.class.php',
         'CpoExportImplementation' => '/lib/implementation/export/cpo.class.php',
         'HtmlExportImplementation' => '/lib/implementation/export/html.class.php',
         'CpoDefaultExportImplementation' => '/lib/implementation/export/cpo/default.class.php',
         'HtmlDefaultExportImplementation' => '/lib/implementation/export/html/default.class.php',
         'HtmlRenditionImplementation' => '/lib/implementation/rendition/html.class.php',
         'HtmlDescriptionRenditionImplementation' => '/lib/implementation/rendition/html/description.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php',
         'Remover' => '/package/remove/remover.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>