<?php
namespace repository\content_object\mediamosa;

use common\extensions\external_repository_manager\ExternalObject;

use common\libraries\Translation;
use common\libraries\Utilities;

use repository\ContentObjectForm;
use repository\ExternalSync;

/**
 * Description of MediamosaForm class
 *
 * @author jevdheyd
 */
class MediamosaForm extends ContentObjectForm
{

    public function build_creation_form()
    {
        parent :: build_creation_form();

        $this->addElement('hidden', ExternalObject :: PROPERTY_EXTERNAL_REPOSITORY_ID);
        $this->addElement('hidden', ExternalObject :: PROPERTY_ID);

        $external_repositories = \repository\ExternalRepositoryComponent :: get_links(
                Utilities :: get_classname_from_namespace(
                        \common\extensions\external_repository_manager\Manager :: CLASS_NAME, true),
                Mediamosa :: get_type_name(), true);
        if ($external_repositories)
        {
            $this->addElement('category', Translation :: get('Media'));
            $this->addElement('static', null, null, $external_repositories);
            $this->addElement('category');
        }

        // $this->streaming_video_clip_form_elements();
    }

    public function build_editing_form()
    {
        parent :: build_editing_form();

        // $this->streaming_video_clip_form_elements();
    }

    public function create_content_object()
    {
        if (parent :: create_content_object())
        {
            $mediamosa = $this->get_content_object();

            $external_respository_sync = new ExternalSync();
            $external_respository_sync->set_external_id(
                    $this->exportValue(ExternalObject :: PROPERTY_EXTERNAL_REPOSITORY_ID));
            $external_respository_sync->set_external_object_id($this->exportValue(ExternalObject :: PROPERTY_ID));

            $object = $external_respository_sync->get_external_object();

            ExternalSync :: quicksave($mediamosa, $object,
                    $this->exportValue(ExternalObject :: PROPERTY_EXTERNAL_REPOSITORY_ID));

            return $mediamosa;
        }
    }
}
