<?php
namespace repository\content_object\portfolio;

use repository\ComplexBuilder;

use common\libraries\Translation;
use common\libraries\Utilities;
use repository\content_object\portfolio_item\PortfolioItem;
use repository\ComplexBrowserTableCellRenderer;
use repository\ContentObject;

class PortfolioBrowserTableCellRenderer extends ComplexBrowserTableCellRenderer
{

    /**
     * Constructor
     * 
     * @param $browser RepositoryManagerBrowserComponent           
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }
    
    private $lpi_ref_object;
    
    // Inherited
    public function render_cell($column, $complex_content_object_item)
    {
        $content_object = $this->retrieve_content_object($complex_content_object_item->get_ref());
        
        if ($content_object instanceof PortfolioItem)
        {
            if (! $this->lpi_ref_object || $this->lpi_ref_object->get_id() != $content_object->get_reference())
            {
                $ref_content_object = \repository\DataManager :: retrieve_content_object($content_object->get_reference());
                $this->lpi_ref_object = $ref_content_object;
            }
            else
            {
                $ref_content_object = $this->lpi_ref_object;
            }
        }
        else
        {
            $ref_content_object = $content_object;
        }
        
        switch ($column->get_name())
        {
            case Translation :: get(Utilities :: underscores_to_camelcase(ContentObject :: PROPERTY_TITLE)) :
                $title = htmlspecialchars($ref_content_object->get_title());
                $title_short = $title;
                
                $title_short = Utilities :: truncate_string($title_short, 53, false);
                
                if ($ref_content_object instanceof Portfolio)
                {
                    $title_short = '<a href="' . $this->browser->get_url(array(
                            ComplexBuilder :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID => $complex_content_object_item->get_id())) . '">' . $title_short . '</a>';
                }
                
                return $title_short;
        }
        
        return parent :: render_cell($column, $complex_content_object_item, $ref_content_object);
    }

}
