<?php
namespace repository\content_object\rss_feed\integration\core\home;

use common\libraries\PropertyConditionVariable;
use common\libraries\Session;
use common\libraries\StaticConditionVariable;
use common\libraries\Translation;
use common\libraries\EqualityCondition;
use repository\ContentObject;

class Connector
{

    public function get_rss_feed_objects()
    {
        $options = array();

        $condition = new EqualityCondition(
            new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_OWNER_ID),
            new StaticConditionVariable(Session :: get_user_id())
        );

        $objects = \repository\DataManager :: retrieve_active_content_objects(
                \repository\content_object\rss_feed\RssFeed :: class_name(), $condition);

        if ($objects->size() == 0)
        {
            $options[0] = Translation :: get('CreateRssFeedFirst');
        }
        else
        {
            $options[0] = Translation :: get('SelectRssFeed');
            while ($object = $objects->next_result())
            {
                $options[$object->get_id()] = $object->get_title();
            }
        }

        return $options;
    }
}
