<?php
namespace repository\content_object\vimeo;

use common\libraries\Includeable;
use common\libraries\Utilities;
use common\libraries\Versionable;
use repository\ContentObject;
use common\libraries\EqualityCondition;
use repository\ExternalInstance;
use common\libraries\AndCondition;

/**
 * $Id: vimeo.class.php 2010-06-08 package repository.lib.content_object.vimeo
 *
 * @author Shoira Mukhsinova
 */
class Vimeo extends ContentObject implements Versionable, Includeable
{
    const CLASS_NAME = __CLASS__;
    const VIMEO_PLAYER_URI = 'http://vimeo.com/moogaloop.swf?clip_id=%s&amp;server=vimeo.com&amp;
    show_title=1&amp;show_byline=1&amp;show_portrait=1&amp;color=ffffff&amp;fullscreen=1"';

    public static function get_type_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }

    public function get_video_url()
    {
        $video_url_custom = sprintf(
            self :: VIMEO_PLAYER_URI,
            $this->get_synchronization_data()->get_external_object_id());

        return $video_url_custom;
    }

    public static function is_type_available()
    {
        $conditions = array();
        $conditions[] = new EqualityCondition(
            ExternalInstance :: PROPERTY_TYPE,
            \common\extensions\external_repository_manager\Manager :: get_namespace('vimeo'));
        $conditions[] = new EqualityCondition(ExternalInstance :: PROPERTY_ENABLED, 1);
        $condition = new AndCondition($conditions);

        $external_repositories = \repository\DataManager :: retrieves(ExternalInstance :: class_name(), $condition);
        return $external_repositories->size() == 1;
    }
}
