<?php
namespace repository\content_object\wiki;

use common\libraries\PropertyConditionVariable;
use common\libraries\EqualityCondition;
use common\libraries\DataClassJoin;
use repository\ComplexContentObjectItem;
use repository\ContentObject;
use common\libraries\Joins;

class DataManager extends \common\libraries\DataManager
{

    /**
     * Gets the type of DataManager to be instantiated
     * 
     * @return string
     */
    public static function get_type()
    {
        return 'doctrine';
    }

    public static function retrieve_complex_wiki_pages($type, $parameters = null)
    {
        $parameters = \repository\DataManager :: prepare_complex_parameters(\repository\DataManager :: ACTION_RETRIEVES, 
                $type, $parameters);
        $join = new DataClassJoin(ContentObject :: class_name(), 
                new EqualityCondition(
                        new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_ID), 
                        new PropertyConditionVariable(ComplexContentObjectItem :: class_name(), 
                                ComplexContentObjectItem :: PROPERTY_REF)));
        
        if ($parameters->get_joins() instanceof Joins)
        {
            $joins = $parameters->get_joins();
            
            $joins->add($join);
        }
        else
        {
            $parameters->set_joins(new Joins(array($join)));
        }
        return self :: retrieves($type, $parameters);
    }
    
    public static function count_complex_wiki_pages($type, $parameters = null)
    {
        $parameters = \repository\DataManager :: prepare_complex_parameters(\repository\DataManager :: ACTION_COUNT,
                $type, $parameters);
        $join = new DataClassJoin(ContentObject :: class_name(),
                new EqualityCondition(
                        new PropertyConditionVariable(ContentObject :: class_name(), ContentObject :: PROPERTY_ID),
                        new PropertyConditionVariable(ComplexContentObjectItem :: class_name(),
                                ComplexContentObjectItem :: PROPERTY_REF)));
    
        if ($parameters->get_joins() instanceof Joins)
        {
            $joins = $parameters->get_joins();
    
            $joins->add($join);
        }
        else
        {
            $parameters->set_joins(new Joins(array($join)));
        }
        return self :: count($type, $parameters);
    }
}
