<?php
namespace repository\content_object\youtube;

use common\libraries\Includeable;
use common\libraries\Utilities;
use common\libraries\Versionable;
use repository\ContentObject;
use common\libraries\EqualityCondition;
use repository\ExternalInstance;
use common\libraries\AndCondition;

/**
 * $Id: youtube.class.php
 *
 * @package repository.lib.content_object.youtube
 */
class Youtube extends ContentObject implements Versionable, Includeable
{
    const CLASS_NAME = __CLASS__;
    const YOUTUBE_PLAYER_URI = 'http://www.youtube.com/v/%s';

    public static function get_type_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }

    public function get_video_url()
    {
        $synchronization_data = $this->get_synchronization_data();

        if ($synchronization_data)
        {
            return sprintf(self :: YOUTUBE_PLAYER_URI, $synchronization_data->get_external_object_id());
        }
    }

    public static function is_type_available()
    {
        $conditions = array();
        $conditions[] = new EqualityCondition(
            ExternalInstance :: PROPERTY_TYPE,
            \common\extensions\external_repository_manager\Manager :: get_namespace('youtube'));
        $conditions[] = new EqualityCondition(ExternalInstance :: PROPERTY_ENABLED, 1);
        $condition = new AndCondition($conditions);

        $external_repositories = \repository\DataManager :: retrieves(ExternalInstance :: class_name(), $condition);
        return $external_repositories->size() == 1;
    }
}
