<?php
namespace repository\integration\webservice;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'CategoryCreateWebserviceHandler' => '/lib/category/create.class.php',
         'CategoryDeleteWebserviceHandler' => '/lib/category/delete.class.php',
         'CategoryGetWebserviceHandler' => '/lib/category/get.class.php',
         'CategoryGetListWebserviceHandler' => '/lib/category/get_list.class.php',
         'CategoryUpdateWebserviceHandler' => '/lib/category/update.class.php',
         'ComplexContentObjectItemCreateWebserviceHandler' => '/lib/complex_content_object_item/create.class.php',
         'ComplexContentObjectItemDeleteWebserviceHandler' => '/lib/complex_content_object_item/delete.class.php',
         'ComplexContentObjectItemGetWebserviceHandler' => '/lib/complex_content_object_item/get.class.php',
         'ComplexContentObjectItemGetListWebserviceHandler' => '/lib/complex_content_object_item/get_list.class.php',
         'ComplexContentObjectItemUpdateWebserviceHandler' => '/lib/complex_content_object_item/update.class.php',
         'ContentObjectCreateWebserviceHandler' => '/lib/content_object/create.class.php',
         'ContentObjectDeleteWebserviceHandler' => '/lib/content_object/delete.class.php',
         'ContentObjectGetWebserviceHandler' => '/lib/content_object/get.class.php',
         'ContentObjectGetListWebserviceHandler' => '/lib/content_object/get_list.class.php',
         'ContentObjectUpdateWebserviceHandler' => '/lib/content_object/update.class.php',
         'ContentObjectAttachmentCreateWebserviceHandler' => '/lib/content_object_attachment/create.class.php',
         'ContentObjectAttachmentDeleteWebserviceHandler' => '/lib/content_object_attachment/delete.class.php',
         'ContentObjectAttachmentGetListWebserviceHandler' => '/lib/content_object_attachment/get_list.class.php',
         'ContentObjectIncludeCreateWebserviceHandler' => '/lib/content_object_include/create.class.php',
         'ContentObjectIncludeDeleteWebserviceHandler' => '/lib/content_object_include/delete.class.php',
         'ContentObjectIncludeGetListWebserviceHandler' => '/lib/content_object_include/get_list.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>