<?php
namespace repository\integration\webservice;

use common\libraries\EqualityCondition;
use common\libraries\Translation;
use common\libraries\CreateObjectWebserviceHandler;

class CategoryCreateWebserviceHandler extends CreateObjectWebserviceHandler
{

    public function get_object()
    {
        return new \repository\RepositoryCategory();
    }

    public function get_object_translation()
    {
        return Translation :: get('Category');
    }

    public function manipulate_data($object, $extra_properties = null)
    {
        $object->set_user_id($this->get_user_id());
        return $object;
    }

    public function is_allowed_to_create_object($object)
    {
        if ($this->get_user()->is_platform_admin() || $object->get_parent() == 0)
        {
            return true;
        }
        $condition = new EqualityCondition(\repository\RepositoryCategory :: PROPERTY_ID, $object->get_parent());
        $category = \repository\DataManager :: retrieve_categories($condition)->next_result();
        if ($category)
        {
            return ($category->get_user_id() == $this->get_user_id());
        }
        return false;
    }
}
