<?php
namespace repository\integration\webservice;

use common\libraries\Translation;
use common\libraries\UpdateObjectWebserviceHandler;

class ComplexContentObjectItemUpdateWebserviceHandler extends UpdateObjectWebserviceHandler
{

    /**
     * Keeps track of the old parent to avoid the move of categories
     */
    private $old_parent;

    public function get_object()
    {
        $complex_content_object_item = \repository\DataManager :: retrieve_complex_content_object_item($this->get_id());

        if ($complex_content_object_item)
        {
            $this->old_parent = $complex_content_object_item->get_parent();
        }

        return $complex_content_object_item;
    }

    public function get_object_translation()
    {
        return Translation :: get('ComplexContentObjectItem');
    }

    public function manipulate_data($object, $extra_properties = null)
    {
        $object->set_user_id($this->get_user_id());
        $object->set_parent($this->old_parent);
        return $object;
    }

    public function is_allowed_to_update_object($object)
    {
        return ($this->get_user()->is_platform_admin() || $object->get_user_id() == $this->get_user_id() ||
                 $object->get_parent_object()->get_owner_id() == $this->get_user_id());
    }
}
