<?php
namespace repository;

use common\libraries\Request;
use common\libraries\Translation;
use common\libraries\JsonAjaxResult;
use common\libraries\AjaxManager;

class RepositoryAjaxCheckTitle extends AjaxManager
{
    const PARAM_TITLE = 'title';
    const PARAM_PARENT_ID = 'parent_id';
    const PARAM_CONTENT_OBJECT_ID = 'content_object_id';
    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_TITLE, self :: PARAM_PARENT_ID);
    }
    
    /*
     * (non-PHPdoc) @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $title = $this->get_parameter(self :: PARAM_TITLE);
        $parent_id = $this->get_parameter(self :: PARAM_PARENT_ID);
        $content_object_id = Request :: post(self :: PARAM_CONTENT_OBJECT_ID);
        
        if (! DataManager :: content_object_title_exists($title, $parent_id, $content_object_id))
        {
            JsonAjaxResult :: success();
        }
        else
        {
            JsonAjaxResult :: error(409, Translation :: get('TitleAlreadyExists'));
        }
    }
}
