<?php
namespace repository;

use common\libraries\AjaxManager;
use common\libraries\JsonAjaxResult;

/**
 * @package repository
 */

class RepositoryAjaxContentObjectUpdate extends AjaxManager
{
    const PARAM_CONTENT_OBJECT_ID = 'content_object_id';
    const PARAM_MODIFICATION_DATE = 'modification_date';
    
    const PROPERTY_ALLOW_UPDATE = 'allow_update';

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::required_parameters()
     */
    public function required_parameters()
    {
        return array(self :: PARAM_CONTENT_OBJECT_ID, self :: PARAM_MODIFICATION_DATE);
    }

    /* (non-PHPdoc)
     * @see common\libraries.AjaxManager::run()
     */
    public function run()
    {
        $content_object_id = $this->get_parameter(self :: PARAM_CONTENT_OBJECT_ID);
        $content_object = \repository\DataManager :: retrieve_content_object($content_object_id);
        
        $modification_date = $this->get_parameter(self :: PARAM_MODIFICATION_DATE);
        $allow_update = ($modification_date >= $content_object->get_modification_date());
        
        $result = new JsonAjaxResult(200);
        $result->set_property(self :: PROPERTY_ALLOW_UPDATE, $allow_update);
        $result->display();
    }
}
