<?php
namespace repository;

use common\libraries\Path;
use common\libraries\Request;
use repository\content_object\document\Document;
use repository\content_object\file\File;

/**
 * $Id: image_properties.php 155 2009-11-10 13:20:56Z vanpouckesven $
 *
 * @package common.javascript.ajax
 */
require_once dirname(__FILE__) . '/../../../common/global.inc.php';

$object = Request :: post('content_object');
$object = DataManager :: retrieve_content_object($object);

$full_path = $object->get_full_path();
$dimensions = getimagesize($full_path);

//added a fix because the web path is relative to this folder
$web_path = Path :: get(WEB_PATH);
$path_parts = explode('/', $web_path);
array_pop($path_parts);
array_pop($path_parts);
array_pop($path_parts);
array_pop($path_parts);
$web_path = implode('/', $path_parts);

$properties = array();
$properties[ContentObject :: PROPERTY_ID] = $object->get_id();
$properties[ContentObject :: PROPERTY_TITLE] = $object->get_title();
$properties['fullPath'] = $full_path;
$properties['webPath'] = $web_path . '/files/repository/' . $object->get_path();

if (ContentObject :: is_type_available('document'))
{
    $properties[Document :: PROPERTY_FILENAME] = $object->get_filename();
    $properties[Document :: PROPERTY_PATH] = $object->get_path();
    $properties[Document :: PROPERTY_FILESIZE] = $object->get_filesize();
}
else
{
    $properties[File :: PROPERTY_FILENAME] = $object->get_filename();
    $properties[File :: PROPERTY_PATH] = $object->get_path();
    $properties[File :: PROPERTY_FILESIZE] = $object->get_filesize();
}

$properties['width'] = $dimensions[0];
$properties['height'] = $dimensions[1];
$properties['type'] = $object->get_extension();

echo json_encode($properties);
