<?php
namespace repository;

use common\libraries\Request;
use common\libraries\Translation;
use common\libraries\EqualityCondition;
use common\libraries\AndCondition;
use common\libraries\Utilities;

/**
 * $Id: mover.class.php 200 2009-11-13 12:30:04Z kariboe $
 * 
 * @package repository.lib.complex_builder.component
 */
/**
 * Repository manager component which provides functionality to delete an object from the users repository.
 */
class ComplexBuilderComponentMoverComponent extends ComplexBuilderComponent
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $id = Request :: get(ComplexBuilder :: PARAM_SELECTED_COMPLEX_CONTENT_OBJECT_ITEM_ID);
        $parent_complex_content_object_item = Request :: get(ComplexBuilder :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID);
        $direction = Request :: get(ComplexBuilder :: PARAM_DIRECTION);
        $succes = true;
        
        if (isset($id))
        {
            $complex_content_object_item = DataManager :: retrieve_complex_content_object_item($id);
            $parent = $complex_content_object_item->get_parent();
            $max = DataManager :: count_complex_content_object_items(ComplexContentObjectItem :: class_name(),
                    new EqualityCondition(ComplexContentObjectItem :: PROPERTY_PARENT, $parent));
            
            $display_order = $complex_content_object_item->get_display_order();
            $new_place = ($display_order + ($direction == RepositoryManager :: PARAM_DIRECTION_UP ? - 1 : 1));
            
            if ($new_place > 0 && $new_place <= $max)
            {
                $complex_content_object_item->set_display_order($new_place);
                
                $conditions[] = new EqualityCondition(ComplexContentObjectItem :: PROPERTY_DISPLAY_ORDER, $new_place, 
                        ComplexContentObjectItem :: get_table_name());
                $conditions[] = new EqualityCondition(ComplexContentObjectItem :: PROPERTY_PARENT, $parent, 
                        ComplexContentObjectItem :: get_table_name());
                $condition = new AndCondition($conditions);
                $items = DataManager :: retrieve_complex_content_object_items(ComplexContentObjectItem :: class_name(), $condition);
                $new_complex_content_object_item = $items->next_result();
                $new_complex_content_object_item->set_display_order($display_order);
                
                if (! $complex_content_object_item->update() || ! $new_complex_content_object_item->update())
                {
                    $succes = false;
                }
            }
            
            if ($parent == $root)
            {
                $parent = null;
            }
            
            $this->redirect(
                    $succes ? Translation :: get('ObjectsMoved', 
                            array('OBJECTS' => Translation :: get('ComplexContentObjectItems')), 
                            Utilities :: COMMON_LIBRARIES) : Translation :: get('ObjectsNotMoved', 
                            array('OBJECTS' => Translation :: get('ComplexContentObjectItems')), 
                            Utilities :: COMMON_LIBRARIES), false, 
                    array(ComplexBuilder :: PARAM_BUILDER_ACTION => ComplexBuilder :: ACTION_BROWSE, 
                            ComplexBuilder :: PARAM_COMPLEX_CONTENT_OBJECT_ITEM_ID => $parent_complex_content_object_item));
        }
        else
        {
            $this->display_error_page(
                    htmlentities(
                            Translation :: get('NoObjectsSelected', 
                                    array('OBJECTS' => Translation :: get('ContentObjectItems')), 
                                    Utilities :: COMMON_LIBRARIES)));
        }
    }
}
