<?php
namespace repository;


use common\libraries\Translation;

/**
 * This component previews the complex content object
 *
 * @author Sven Vanpoucke
 */
class ComplexBuilderComponentPreviewComponent extends ComplexBuilderComponent
{

    /**
     * Runs the component and displays it's output
     */
    public function run()
    {
        ComplexDisplayPreview :: launch($this->get_root_content_object()->get_type(), $this);
    }

    /**
     * Modification of the display header to show the preview mode warning
     *
     * @return string
     */
    public function display_header()
    {
        parent :: display_header();
        
        $html[] = '<br /><div style="border: 1px solid #FFD89B;" class="warning-banner">';
        $html[] = Translation :: get('PreviewModeWarning');
        $html[] = '</div>';
        
        echo implode("\n", $html);
    }
}
