<?php
namespace repository;

use common\libraries\Utilities;

/**
 *
 * @author Magali Gillard
 */
abstract class ContentObjectAdvancedFilter
{

    /**
     *
     * @var \repository\FormValidator
     */
    private $form;

    /**
     *
     * @return multitype:\common\libraries\Condition
     */
    abstract public function get_conditions();

    /**
     *
     * @return string
     */
    abstract public function get_parameters();

    abstract public function add_elements();

    /**
     *
     * @param FormValidator $form
     */
    public function __construct($form)
    {
        $this->form = $form;
    }

    /**
     *
     * @param string $type
     * @param \repository\FormValidator $form
     * @return \repository\ContentObjectAdvancedFilter boolean
     */
    public function factory($type, $form)
    {
        $class = Utilities :: get_namespace_from_classname($type) . '\AdvancedFilter';
        if (class_exists($class))
        {
            return new $class($form);
        }
        else
        {
            return false;
        }
    }

    /**
     *
     * @return \repository\FormValidator
     */
    public function get_form()
    {
        return $this->form;
    }
}
