<?php
namespace repository;

class QtiSerializerExport
{
    private $serializer = null;
    private $controller;
    private $object;

    public static function factory($controller, $object)
    {
        if ($serializer = QtiSerializerBase :: factory($object, '', $controller))
        {
            return new self($object, $serializer, $controller);
        }
        else
        {
            return null;
        }
    }

    public function __construct($object, $serializer, $controller)
    {
        $this->object = $object;
        $this->serializer = $serializer;
        $this->controller = $controller;
    }

    public function get_controller()
    {
        return $this->controller;
    }

    public function get_serializer()
    {
        return $this->serializer;
    }

    public function export_content_object()
    {
        $serializer = $this->get_serializer();
        return $serializer->save($this->object, $this->controller->get_directory(), $this->controller->get_manifest(), $this->controller->get_toc());
    }
}
