<?php
namespace repository;

use common\libraries\FileProperties;

use common\libraries\Filesystem;
use common\libraries\Utilities;

/**
 *
 * @package repository.lib
 */
abstract class ContentObjectExportController
{
    private $parameters;

    /**
     *
     * @param ExportParameters $parameters
     */
    public function __construct(ExportParameters $parameters)
    {
        $this->parameters = $parameters;
    }

    /**
     *
     * @var ExportParameters
     */
    public function get_parameters()
    {
        return $this->parameters;
    }

    public function set_parameters($parameters)
    {
        $this->parameters = $parameters;
    }

    /**
     *
     * @param $parameters ExportParameters
     */
    public static function factory(ExportParameters $parameters)
    {
        $class = __NAMESPACE__ . '\\' . Utilities :: underscores_to_camelcase($parameters->get_format()) . 'ContentObjectExportController';
        return new $class($parameters);
    }

    public function download()
    {
        $path = $this->run();

        $file_properties = FileProperties::from_path($path);
        Filesystem :: file_send_for_download($path, true, $this->get_filename(), $file_properties->get_type());
        Filesystem :: remove($path);
    }

    /**
     *
     * @return string
     */
    abstract public function run();

    /**
     *
     * @return string
     */
    abstract public function get_filename();
}
