<?php
namespace repository;

use common\libraries\ObjectTable;

class ExternalInstanceBrowserTable extends ObjectTable
{
    const DEFAULT_NAME = 'external_instance_browser_table';

    /**
     * Constructor
     * @see ContentObjectTable::ContentObjectTable()
     */
    public function __construct($browser, $parameters, $condition)
    {
        $model = new ExternalInstanceBrowserTableColumnModel();
        $renderer = new ExternalInstanceBrowserTableCellRenderer($browser);
        $data_provider = new ExternalInstanceBrowserTableDataProvider($browser, $condition);
        parent :: __construct($data_provider, self :: DEFAULT_NAME, $model, $renderer);
        
        $this->set_additional_parameters($parameters);
        $this->set_default_row_count(20);
    }
}
