<?php
namespace repository;

use common\libraries\Request;
use common\extensions\new_rights_editor_manager\RightsEditorManager;
use rights\PlatformGroupEntity;
use rights\UserEntity;

/**
 * Repository manager component to edit the rights for the objects in the repository.
 */
class ExternalInstanceManagerRightsEditorComponent extends ExternalInstanceManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $identifiers = Request :: get(self :: PARAM_INSTANCE);
        $this->set_parameter(self :: PARAM_INSTANCE, $identifiers);

        $locations = array();

        if (! $identifiers)
        {
            $locations[] = RepositoryRights :: get_instance()->get_external_instances_subtree_root();
        }

        if ($identifiers && ! is_array($identifiers))
        {
            $identifiers = array($identifiers);
        }

        foreach ($identifiers as $identifier)
        {
            $locations[] = RepositoryRights :: get_instance()->get_location_by_identifier_from_external_instances_subtree(
                    $identifier);
        }

        $entities = array();
        $entities[UserEntity :: ENTITY_TYPE] = new UserEntity();
        $entities[PlatformGroupEntity :: ENTITY_TYPE] = new PlatformGroupEntity();

        RightsEditorManager :: launch($this, __NAMESPACE__, $locations, $entities);
    }

    public function get_available_rights()
    {
        return RepositoryRights :: get_instance()->get_available_rights_for_external_instances_substree();
    }

}
