<?php
namespace repository;

use common\libraries\Utilities;
use common\libraries\ObjectTableCellRenderer;

/**
 * $Id: default_publication_table_cell_renderer.class.php 204 2009-11-13 12:51:30Z kariboe $
 *
 * @package repository.lib.publication_table
 */
class DefaultPublicationTableCellRenderer extends ObjectTableCellRenderer
{

    /**
     * Constructor
     */
    public function __construct()
    {
    }

    /**
     * Renders a table cell
     *
     * @param ContentObjectTableColumnModel $column The column which should be rendered
     * @param Learning Object $content_object The learning object to render
     * @return string A HTML representation of the rendered table cell
     */
    public function render_cell($column, $content_object_publication)
    {
        switch ($column->get_name())
        {
            case ContentObjectPublicationAttributes :: PROPERTY_CONTENT_OBJECT_ID :
                return $content_object_publication->get_content_object_id();
            case ContentObjectPublicationAttributes :: PROPERTY_APPLICATION :
                return Utilities :: underscores_to_camelcase_with_spaces($content_object_publication->get_application());
            case ContentObjectPublicationAttributes :: PROPERTY_LOCATION :
                return $content_object_publication->get_location();
            case ContentObjectPublicationAttributes :: PROPERTY_TITLE :
                $url = $content_object_publication->get_url();
                return '<a href="' . $url . '"><span title="' . $content_object_publication->get_title() . '">' .
                     Utilities :: truncate_string($content_object_publication->get_title(), 50) . '</span></a>';
            case ContentObjectPublicationAttributes :: PROPERTY_DATE :
                return date('Y-m-d, H:i', $content_object_publication->get_date());
            default :
                return '&nbsp;';
        }
    }

    public function render_id_cell($object)
    {
        return $object->get_publication_object_id();
    }
}
