<?php
namespace repository;

use common\libraries\ObjectTableOrder;
use common\libraries\DataClassRetrievesParameters;
use common\libraries\ObjectTableDataProvider;

/**
 * $Id: complex_browser_table_data_provider.class.php 204 2009-11-13 12:51:30Z kariboe $
 *
 * @package repository.lib.repository_manager.component.complex_browser
 */
class ComplexBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     *
     * @param RepositoryManagerComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Gets the content objects
     *
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of matching content objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);

        // We always use title as second sorting parameter
        $order_property[] = new ObjectTableOrder(ComplexContentObjectItem :: PROPERTY_DISPLAY_ORDER);
        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property);

        return DataManager :: retrieve_complex_content_object_items(
            ComplexContentObjectItem :: class_name(),
            $parameters);
    }

    /**
     * Gets the number of content objects in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return DataManager :: count_complex_content_object_items(
            ComplexContentObjectItem :: class_name(),
            $this->get_condition());
    }
}
