<?php
namespace repository;

use common\libraries\Session;
use common\libraries\Request;

/**
 * $Id: content_object_copier.class.php 204 2009-11-13 12:51:30Z kariboe $
 *
 * @package repository.lib.repository_manager.component
 */
class RepositoryManagerCopierComponent extends RepositoryManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        $content_object_ids = Request :: get(RepositoryManager :: PARAM_CONTENT_OBJECT_ID);
        $source_user_id = $this->get_user_id();
        $template = Request :: get(self :: PARAM_TEMPLATE);
        $target_user_id = $template ? 0 : $this->get_user_id();
        $target_category_id = Request :: get(RepositoryManager::PARAM_CATEGORY_ID);

        if(! $target_category_id)
            $target_category_id = 0;

        $copier = new ContentObjectCopier($content_object_ids, $source_user_id, $target_user_id, $target_category_id);
        $copier->run();

        $messages = $copier->get_messages_for_url();
        Session :: register(self :: PARAM_MESSAGES, $messages);
        $parameters = array(self :: PARAM_ACTION => self :: ACTION_BROWSE_CONTENT_OBJECTS);
        $this->simple_redirect($parameters);
    }
}
