<?php
namespace repository;

use common\libraries\InCondition;
use common\libraries\ObjectTableDataProvider;

class ExportBrowserTableDataProvider extends ObjectTableDataProvider
{

    public function __construct($browser)
    {
        parent :: __construct($browser);
    }

    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        return DataManager :: retrieve_active_content_objects(ContentObject :: class_name(), $this->get_condition());
    }

    public function get_object_count()
    {
        return DataManager :: count_active_content_objects(ContentObject :: class_name(), $this->get_condition());
    }

    public function get_condition()
    {
        return new InCondition(ContentObject :: PROPERTY_ID, $this->get_browser()->get_content_object_ids(), 
                ContentObject :: get_table_name());
    }
}
