<?php
namespace repository;

use common\libraries\ObjectTable;

class LinkBrowserTable extends ObjectTable
{
    const DEFAULT_NAME = 'link_browser_table';

    private $type;
    const TYPE_PUBLICATIONS = 1;
    const TYPE_PARENTS = 2;
    const TYPE_CHILDREN = 3;
    const TYPE_ATTACHED_TO = 4;
    const TYPE_ATTACHES = 5;
    const TYPE_INCLUDED_IN = 6;
    const TYPE_INCLUDES = 7;

    public function __construct($browser, $parameters, $condition, $type)
    {
        $this->type = $type;

        $model = new LinkBrowserTableColumnModel($type);
        $renderer = new LinkBrowserTableCellRenderer($browser, $type);
        $data_provider = new LinkBrowserTableDataProvider($browser, $condition, $type);
        parent :: __construct($data_provider, LinkBrowserTable :: DEFAULT_NAME . '_' . $type, $model, $renderer);

        $this->set_additional_parameters($parameters);
        $this->set_default_row_count(20);
    }
}
