<?php
namespace repository;

use common\libraries\DataClassCountParameters;
use common\libraries\DataClassRetrievesParameters;

/**
 * $Id: recycle_bin_browser_table_data_provider.class.php 204 2009-11-13 12:51:30Z kariboe $
 * 
 * @package repository.lib.repository_manager.component.recycle_bin_browser
 */

/**
 * Data provider for the recycle bin browser table
 */
class RecycleBinBrowserTableDataProvider extends RepositoryBrowserTableDataProvider
{

    /**
     * Constructor
     * 
     * @param RepositoryManagerRecycleBinBrowserComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }
    
    // Inherited
    public function get_objects($offset, $count, $order_property = null)
    {
        if (is_null($order_property))
        {
            $order_property = array();
        }
        elseif (! is_array($order_property))
        {
            $order_property = array($order_property);
        }
        
        // We always use title as second sorting parameter
        // $order_property[] = ContentObject :: PROPERTY_TITLE;
        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property);
        
        $objects = DataManager :: retrieve_active_content_objects(ContentObject :: class_name(), $parameters);
        
        return $objects;
    }
    
    // Inherited
    public function get_object_count()
    {
        $parameters = new DataClassCountParameters($this->get_condition());
        
        return DataManager :: count_active_content_objects(ContentObject :: class_name(), $parameters);
    }
}
