<?php
namespace repository;

use common\libraries\DataClassRetrievesParameters;
use common\libraries\ObjectTableDataProvider;

/**
 * $Id: user_view_browser_table_data_provider.class.php 204 2009-11-13 12:51:30Z kariboe $
 * 
 * @package repository.lib.repository_manager.component.user_view_browser
 */

/**
 * Data provider for a repository browser table. This class implements some functions to allow repository browser tables
 * to retrieve information about content objects to display.
 */
class UserViewBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     * 
     * @param RepositoryManagerComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Gets content objects
     * 
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of matching content objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $order_property = $this->get_order_property($order_property);
        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property);
        return DataManager :: retrieves(UserView :: class_name(), $parameters);
    }

    /**
     * Gets the number of content objects in the table
     * 
     * @return int
     */
    public function get_object_count()
    {
        return DataManager :: count(UserView :: class_name(), $this->get_condition());
    }
}
