<?php
namespace repository;

use common\libraries\DataClassCountParameters;

use common\libraries\DataClassRetrievesParameters;
use common\libraries\ObjectTableOrder;
use common\libraries\ObjectTableDataProvider;

/**
 * $Id: repository_browser_table_data_provider.class.php 204 2009-11-13 12:51:30Z kariboe $
 * 
 * @package repository.lib.repository_manager.component.browser
 */
/**
 * Data provider for a repository browser table. This class implements some functions to allow repository browser tables
 * to retrieve information about content objects to display.
 */
class RepositoryVersionBrowserTableDataProvider extends ObjectTableDataProvider
{

    /**
     * Constructor
     * 
     * @param RepositoryManagerComponent $browser
     * @param Condition $condition
     */
    public function __construct($browser, $condition)
    {
        parent :: __construct($browser, $condition);
    }

    /**
     * Gets the learning objects
     * 
     * @param int $offset
     * @param int $count
     * @param string $order_property
     * @return ResultSet A set of matching learning objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        // $order_property = $this->get_order_property($order_property);
        $order_property = new ObjectTableOrder(ContentObject :: PROPERTY_ID, SORT_DESC);
        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property);
        
        return DataManager :: retrieve_content_objects(ContentObject :: class_name(), $parameters);
    }

    /**
     * Gets the number of learning objects in the table
     * 
     * @return int
     */
    public function get_object_count()
    {
        $parameters = new DataClassCountParameters($this->get_condition());
        
        return DataManager :: count_content_objects(ContentObject :: class_name(), $parameters);
    }
}
