<?php
namespace repository;

use common\libraries\Utilities;
use common\libraries\DataClass;

/**
 * $Id: user_view_rel_content_object.class.php 204 2009-11-13 12:51:30Z kariboe $
 * 
 * @package repository.lib
 */

/**
 *
 * @author Sven Vanpoucke
 */
class UserViewRelContentObject extends DataClass
{
    const CLASS_NAME = __CLASS__;
    const PROPERTY_VIEW_ID = 'view_id';
    const PROPERTY_CONTENT_OBJECT_TYPE = 'content_object_type';

    /**
     * Get the default properties of all user_view_rel_content_objects.
     * 
     * @return array The property names.
     */
    public static function get_default_property_names()
    {
        return parent :: get_default_property_names(
                array(self :: PROPERTY_VIEW_ID, self :: PROPERTY_CONTENT_OBJECT_TYPE));
    }

    /**
     * Returns the view_id of this user_view_rel_content_object.
     * 
     * @return int The view_id.
     */
    public function get_view_id()
    {
        return $this->get_default_property(self :: PROPERTY_VIEW_ID);
    }

    /**
     * Sets the user_view_rel_content_object_view_id of this user_view_rel_content_object.
     * 
     * @param int $user_view_rel_content_object_view_id The user_view_rel_content_object_view_id.
     */
    public function set_view_id($view_id)
    {
        $this->set_default_property(self :: PROPERTY_VIEW_ID, $view_id);
    }

    public function get_content_object_type()
    {
        return $this->get_default_property(self :: PROPERTY_CONTENT_OBJECT_TYPE);
    }

    public function set_content_object_type($content_object_type)
    {
        $this->set_default_property(self :: PROPERTY_CONTENT_OBJECT_TYPE, $content_object_type);
    }

    public static function get_table_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }
}
