<?php
namespace repository;

use common\libraries\Translation;

/**
 * $Id: repository_installer.class.php 200 2009-11-13 12:30:04Z kariboe $
 *
 * @package repository.install
 */
/**
 * This installer can be used to create the storage structure for the repository.
 */
class Installer extends \common\libraries\package\Installer
{

    /**
     * Constructor
     */
    public function __construct($values)
    {
        parent :: __construct($values, DataManager :: get_instance());
    }

    /**
     * Runs the install-script.
     * After creating the necessary tables to store the common learning object information,
     * this function will scan the directories of all learning object types. When an XML-file describing a storage unit
     * is found, this function will parse the file and create the storage unit.
     */
    public function extra()
    {
        if (! RepositoryRights :: get_instance()->create_external_instances_subtree_root_location())
        {
            return false;
        }
        else
        {
            $this->add_message(self :: TYPE_NORMAL, Translation :: get('ExternalInstancesSubtreeCreated'));
        }

        return true;
    }

    public function get_additional_packages()
    {
        $installers = array();
        $installers[] = 'repository\quota';
        $installers[] = 'repository\integration\core\home';
        $installers[] = 'repository\integration\webservice';

        return $installers;
    }
}
