<?php
namespace repository\quota\upgrade\v4_0_0;

use common\libraries\CommonDataManager;
use common\libraries\package\Package;

/**
 *
 * @author Hans De Bisschop
 * @author Magali Gillard
 */
class Upgrader extends \common\libraries\package\Upgrader
{

    /**
     * Constructor
     */
    public function __construct()
    {
        parent :: __construct(\repository\quota\DataManager :: get_instance());
    }

    /*
     * (non-PHPdoc) @see \common\libraries\package\Upgrader::run()
     */
    public function run()
    {
        $data_manager = $this->get_data_manager();

        $success = $data_manager->transactional(
            function ($c) use($data_manager)
            {
                $package = Package :: get('repository\quota');
                $registration = CommonDataManager :: get_registration('repository\quota');
                $registration->set_version($package->get_version());
                if (! $registration->update())
                {
                    return false;
                }

                return true;
            });

        return $success;
    }

    /*
     * (non-PHPdoc) @see \common\libraries\package\Upgrader::get_additional_packages()
    */
    public function get_additional_packages()
    {
        $packages = array();
        $packages[] = 'repository\quota\rights';
        return $packages;
    }
}
