<?php
namespace rights;

use common\libraries\AdvancedElementFinderElementType;
use common\libraries\Translation;

/**
 * Extension on the user entity to fix the issue that the feeds don't return 'entity_type'_'entity_id'
 * but return user_entity_id
 *
 * This is the correct way for the user entities and this should be used in the future
 *
 * @author Sven Vanpoucke
 *
 * @deprecated - Use the UserEntity, we have changed the functions to work correctly
 */
class NewUserEntity extends UserEntity
{
    /**
     * Retrieves the type for the advanced element finder for the simple rights editor
     */
    public function get_element_finder_type()
    {
        return new AdvancedElementFinderElementType('users', Translation :: get('Users'),
            RightsManager :: APPLICATION_NAME, 'user_entity_feed', array());
    }

}
