<?php

namespace rights;

use common\libraries\Utilities;

use group\Group;

use common\extensions\new_rights_editor_manager\LocationEntityBrowserTableCellRenderer;

/**
 * Cell renderer for the platform group entity browser
 * @author Sven Vanpoucke
 */
class LocationPlatformGroupBrowserTableCellRenderer extends LocationEntityBrowserTableCellRenderer
{

    /**
     * Renders the cell for the given column and platform group
     * 
     * @param LocationCourseGroupBrowserTableColumnModel $column
     * @param Group $entity_item
     * @return String
     */
    public function render_cell($column, $entity_item)
    {
        switch ($column->get_name())
        {
            case Group :: PROPERTY_DESCRIPTION :
                $description = Utilities :: truncate_string($entity_item->get_description(), 50);
                return Utilities :: truncate_string($description);
            case LocationPlatformGroupBrowserTableColumnModel :: COLUMN_USERS :
                return $entity_item->count_users();
            case LocationPlatformGroupBrowserTableColumnModel :: COLUMN_SUBGROUPS :
                return $entity_item->count_subgroups(true);
        }
        
        return parent :: render_cell($column, $entity_item);
    }
}
