<?php

namespace rights;

use common\libraries\ObjectTableColumn;
use common\libraries\Application;

use user\UserManager;
use user\User;

use common\extensions\new_rights_editor_manager\LocationEntityBrowserTableColumnModel;

/**
 * Cell renderer for the user entity browser
 * @author Sven Vanpoucke
 */
class LocationUserEntityBrowserTableColumnModel extends LocationEntityBrowserTableColumnModel
{

    public function __construct($browser)
    {
        $columns = array();
        parent :: __construct($browser, $this->get_columns());
    }

    /**
     * Determines the default columns for this column model
     * 
     * @return Array[ObjectTableColumn]
     */
    public function get_columns()
    {
        $user_namespace = Application :: determine_namespace(UserManager :: APPLICATION_NAME);
        
        $columns = array();
        $columns[] = new ObjectTableColumn(User :: PROPERTY_OFFICIAL_CODE, true, null, true, $user_namespace);
        $columns[] = new ObjectTableColumn(User :: PROPERTY_USERNAME, true, null, true, $user_namespace);
        $columns[] = new ObjectTableColumn(User :: PROPERTY_FIRSTNAME, true, null, true, $user_namespace);
        $columns[] = new ObjectTableColumn(User :: PROPERTY_LASTNAME, true, null, true, $user_namespace);
        return $columns;
    }
}
