<?php
    
    # @usage
    # php compare_entries.php path1 path2
    #
    # @description
    # This script compares the entries in file <path2> to the entries in file <path1>.
    # Missing entries in file <path2> are reported, the user is prompted for a
    # translation.
    # The new entries are appended to the original file.
    #
    # @author: Klaas Moerman <kmoerman@vub>
    
    # read arguments
    $path1 = $argv[1];
    $path2 = $argv[2];
    
    # read language files
    $strings1 = parse_ini_file($path1);
    $strings2 = parse_ini_file($path2);
    if (!$strings2) $strings2 = array();
    
    $new_strings = array();
    
    # compare entries
    foreach ($strings1 as $key => $value) {
        if (!isset($strings2[$key]) || $strings2[$key] == "") {
            $new_strings[$key] = readline("\033[34m\033[1m$key\033[0m = \"$value\" - Translation: ");
        }
    }
    
    # output new entries to file2
    # file2 will be created when unexisting
    $output = fopen($path2, "a");
    foreach ($new_strings as $key => $value)
        if ($value !== "")
            fputs($output,"\n$key = \"$value\"");
    fclose($output);

?>
