<?php
namespace user\integration\core\home;

use common\libraries\AndCondition;
use common\libraries\PropertyConditionVariable;
use common\libraries\StaticConditionVariable;
use common\libraries\EqualityCondition;
use common\libraries\DataClassRetrieveParameters;
use common\libraries\Translation;

class Installer extends \core\home\HomeInstaller
{

    public function extra()
    {
        if (parent :: extra())
        {
            $conditions = array();
            $conditions[] = new EqualityCondition(
                    new PropertyConditionVariable(\core\home\HomeColumn :: class_name(), \core\home\HomeColumn :: PROPERTY_TITLE),
                    new StaticConditionVariable(Translation :: get('Various', null, 'core\home')));
            $conditions[] = new EqualityCondition(
                    new PropertyConditionVariable(\core\home\HomeColumn :: class_name(), \core\home\HomeColumn :: PROPERTY_USER),
                    new StaticConditionVariable(0));
            $condition = new AndCondition($conditions);

            $parameters = new DataClassRetrieveParameters($condition);
            $column = \core\home\DataManager :: retrieve(\core\home\HomeColumn :: class_name(), $parameters);

            if ($column instanceof \core\home\HomeColumn)
            {

                $block = new \core\home\HomeBlock();
                $block->set_column($column->get_id());
                $block->set_title(Translation :: get('User', null, \user\UserManager :: APPLICATION_NAME));
                $registration = \core\home\DataManager :: retrieve_home_block_registration_by_context_and_block(
                        static :: context(), 'login');
                $block->set_registration_id($registration->get_id());
                $block->set_user('0');
                if (! $block->create())
                {
                    return false;
                }
                return true;
            }
            else
            {
                return false;
            }
        }
        else
        {
            return false;
        }
    }
}
