<?php
namespace user\integration\reporting;

use reporting\ReportingChartFormatter;
use reporting\ReportingFormatter;
use reporting\ReportingData;
use common\libraries\Translation;

class ActiveInactiveBlock extends Block
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $udm = \user\UserDataManager :: get_instance();
        $users = $udm->retrieve_users();
        $active[Translation :: get('Active')] = 0;
        $active[Translation :: get('Inactive')] = 0;
        while ($user = $users->next_result())
        {
            if ($user->get_active())
            {
                $active[Translation :: get('Active')] ++;
            }
            else
            {
                $active[Translation :: get('Inactive')] ++;
            }
        }
        $reporting_data->set_categories(array(Translation :: get('Active'), Translation :: get('Inactive')));
        $reporting_data->set_rows(array(Translation :: get('Count')));
        
        $reporting_data->add_data_category_row(Translation :: get('Active'), Translation :: get('Count'), 
                $active[Translation :: get('Active')]);
        $reporting_data->add_data_category_row(Translation :: get('Inactive'), Translation :: get('Count'), 
                $active[Translation :: get('Inactive')]);
        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \user\UserManager :: APPLICATION_NAME;
    }

    public function get_available_displaymodes()
    {
        $modes = array();
        // $modes[ReportingFormatter::DISPLAY_TEXT] = Translation :: get('Text');
        $modes[ReportingFormatter :: DISPLAY_TABLE] = Translation :: get('Table', null, 'reporting');
        $modes[ReportingChartFormatter :: DISPLAY_PIE] = Translation :: get('Chart:Pie', null, 'reporting');
        $modes[ReportingChartFormatter :: DISPLAY_BAR] = Translation :: get('Chart:Bar', null, 'reporting');
        $modes[ReportingChartFormatter :: DISPLAY_LINE] = Translation :: get('Chart:Line', null, 'reporting');
        $modes[ReportingChartFormatter :: DISPLAY_FILLED_CUBIC] = Translation :: get('Chart:FilledCubic', null, 
                'reporting');
        return $modes;
    }
}
