<?php
namespace user\integration\reporting;

use reporting\ReportingData;
use reporting\Reporting;
use common\libraries\Translation;
use common\libraries\EqualityCondition;

class BrowserBlock extends Block
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $tracker = new \user\integration\tracking\Browser();
        $condition = new EqualityCondition(\user\integration\tracking\Browser :: PROPERTY_TYPE, 'browser');
        $description[0] = Translation :: get('Browsers');
        $data = Reporting :: array_from_tracker($tracker, $condition, $description);
        $keys = array_keys($data);
        $reporting_data->set_categories($keys);
        $reporting_data->set_rows(array(Translation :: get('Browsers')));

        foreach ($keys as $key => $name)
        {
            $reporting_data->add_data_category_row($name, Translation :: get('Browsers'), $data[$name]);
        }
        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \user\UserManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(\reporting\viewer\HtmlBlockRendition :: VIEW_TABLE, \reporting\viewer\HtmlBlockRendition :: VIEW_PIE,
                \reporting\viewer\HtmlBlockRendition :: VIEW_CSV, \reporting\viewer\HtmlBlockRendition :: VIEW_XLSX,
                \reporting\viewer\HtmlBlockRendition :: VIEW_ODS, \reporting\viewer\HtmlBlockRendition :: VIEW_XML);
    }
}
