<?php
namespace user\integration\reporting;

use tracking\Tracker;
use reporting\ReportingData;
use common\libraries\Translation;
use common\libraries\EqualityCondition;
use common\libraries\AndCondition;

class LoginBlock extends Block
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $conditions = array();
        $conditions[] = new EqualityCondition(\user\integration\tracking\LoginLogout :: PROPERTY_TYPE, 'login');
        $user_id = $this->get_user_id();
        if (isset($user_id))
        {
            $conditions[] = new EqualityCondition(\user\integration\tracking\LoginLogout :: PROPERTY_USER_ID, $user_id);
        }
        $condition = new AndCondition($conditions);

        $count = Tracker :: count_data(\user\integration\tracking\LoginLogout :: CLASS_NAME,
                \user\UserManager :: APPLICATION_NAME, $condition);

        $reporting_data->set_categories(array(Translation :: get('Logins')));
        $reporting_data->set_rows(array(Translation :: get('Count')));

        $reporting_data->add_data_category_row(Translation :: get('Logins'), Translation :: get('Count'), $count);

        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \user\UserManager :: APPLICATION_NAME;
    }

    public function get_views()
    {
        return array(\reporting\viewer\HtmlBlockRendition :: VIEW_TABLE, \reporting\viewer\HtmlBlockRendition :: VIEW_CSV,
                \reporting\viewer\HtmlBlockRendition :: VIEW_XLSX, \reporting\viewer\HtmlBlockRendition :: VIEW_ODS,
                \reporting\viewer\HtmlBlockRendition :: VIEW_XML);
    }
}
