<?php
namespace user\integration\reporting;

use reporting\ReportingChartFormatter;
use reporting\ReportingFormatter;
use reporting\Reporting;
use reporting\ReportingData;
use common\libraries\Translation;
use common\libraries\EqualityCondition;

class ProviderBlock extends Block
{

    public function count_data()
    {
        $reporting_data = new ReportingData();
        $tracker = new \user\integration\tracking\Provider();
        $condition = new EqualityCondition(\user\integration\tracking\Provider :: PROPERTY_TYPE, 'provider');
        $description[0] = Translation :: get('Providers');

        $data = Reporting :: array_from_tracker($tracker, $condition, $description);
        $keys = array_keys($data);
        $reporting_data->set_categories($keys);
        $reporting_data->set_rows(array(Translation :: get('Providers')));

        foreach ($keys as $key => $name)
        {
            $reporting_data->add_data_category_row($name, Translation :: get('Providers'), $data[$name]);
        }
        return $reporting_data;
    }

    public function retrieve_data()
    {
        return $this->count_data();
    }

    public function get_application()
    {
        return \user\UserManager :: APPLICATION_NAME;
    }

    public function get_available_displaymodes()
    {
        $modes = array();
        // $modes[ReportingFormatter::DISPLAY_TEXT] = Translation :: get('Text');
        $modes[ReportingFormatter :: DISPLAY_TABLE] = Translation :: get('Table', null, 'reporting');
        $modes[ReportingChartFormatter :: DISPLAY_PIE] = Translation :: get('Chart:Pie', null, 'reporting');
        return $modes;
    }

    public function get_views()
    {
        return array(\reporting\viewer\HtmlBlockRendition :: VIEW_TABLE, \reporting\viewer\HtmlBlockRendition :: VIEW_PIE,
                \reporting\viewer\HtmlBlockRendition :: VIEW_CSV, \reporting\viewer\HtmlBlockRendition :: VIEW_XLSX,
                \reporting\viewer\HtmlBlockRendition :: VIEW_ODS, \reporting\viewer\HtmlBlockRendition :: VIEW_XML);
    }
}
