<?php
namespace user\integration\webservice;

class Autoloader
{

    /**
     * The array mapping class names to paths
     *
     * @var multitype:string
     */
     private static $map = array(
         'Autoloader' => '/autoloader.class.php',
         'WebServicesUser' => '/lib/webservices_user.class.php',
         'UserCreateWebserviceHandler' => '/lib/user/create.class.php',
         'UserDeleteWebserviceHandler' => '/lib/user/delete.class.php',
         'UserGetWebserviceHandler' => '/lib/user/get.class.php',
         'UserGetListWebserviceHandler' => '/lib/user/get_list.class.php',
         'UserUpdateWebserviceHandler' => '/lib/user/update.class.php',
         'Activator' => '/package/activate/activator.class.php',
         'Deactivator' => '/package/deactivate/deactivator.class.php',
         'Installer' => '/package/install/installer.class.php'
    );

    /**
     * Try to load the class
     *
     * @param $classname string
     * @return boolean
     */
    public static function load($classname)
    {
        if (isset(self :: $map[$classname]))
        {
            require_once __DIR__ . self :: $map[$classname];
            return true;
        }

        return false;
    }

    /**
     * Synchronize the autoloader
     *
     * @param $update boolean
     * @return multitype:string
     */
    public static function synch($update)
    {
        return \common\libraries\AutoloaderUtilities :: synch(__DIR__, __DIR__, $update);
    }

}
?>