<?php
namespace user;

use common\libraries\NewObjectTableDataProvider;

use common\libraries\DataClassRetrievesParameters;
/**
 * $Id: admin_user_browser_table_data_provider.class.php 211 2009-11-13
 * 13:28:39Z vanpouckesven $
 *
 * @package user.lib.user_manager.component.admin_user_browser
 */
/**
 * Data provider for a user browser table.
 *
 * This class implements some functions to allow user browser tables to
 * retrieve information about the users to display.
 */
class AdminUserBrowserTableDataProvider extends NewObjectTableDataProvider
{

    /**
     * Gets the users
     *
     * @param $user String
     * @param $category String
     * @param $offset int
     * @param $count int
     * @param $order_property string
     * @return ResultSet A set of matching learning objects.
     */
    public function get_objects($offset, $count, $order_property = null)
    {
        $parameters = new DataClassRetrievesParameters($this->get_condition(), $count, $offset, $order_property);
        return UserDataManager :: get_instance()->retrieve_users($parameters);
    }

    /**
     * Gets the number of users in the table
     *
     * @return int
     */
    public function get_object_count()
    {
        return \user\DataManager :: count(\user\User :: class_name(), $this->get_condition());
    }
}
