<?php

namespace user;

use common\libraries\PlatformSetting;

use common\libraries\Translation;
use common\libraries\Request;
use common\libraries\Display;
use common\libraries\AdministrationComponent;
use common\libraries\Breadcrumb;
use common\libraries\BreadcrumbTrail;
use common\libraries\Utilities;
use common\libraries\Redirect;

/**
 * $Id: change_user.class.php 211 2009-11-13 13:28:39Z vanpouckesven $
 *
 * @package user.lib.user_manager.component
 */
class UserManagerChangeUserComponent extends UserManager implements AdministrationComponent
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
        if (! $this->get_user()->is_platform_admin())
        {
            $this->display_header();
            Display :: error_message(Translation :: get("NotAllowed", null, Utilities :: COMMON_LIBRARIES));
            $this->display_footer();
            exit();
        }

        $id = Request :: get(UserManager :: PARAM_USER_USER_ID);
        if ($id)
        {

            $checkurl = \common\libraries\Session :: retrieve('checkChamiloURL');
            \common\libraries\Session :: clear();
            \common\libraries\Session :: register('_uid', $id);
            \common\libraries\Session :: register('_as_admin', $this->get_user_id());
            \common\libraries\Session :: register('checkChamiloURL', $checkurl);

            $login_page = PlatformSetting :: get('page_after_login');
            if ($login_page == 'home')
            {
                header('Location: index.php');
            }
            else
            {
                header('Location: index.php?application=' . $login_page);
            }

            // $this->redirect(Translation :: get('LoggedInAsUser'), false, $parameters, array(), false, Redirect ::
        // TYPE_LINK, Redirect :: TYPE_INDEX);
        }
        else
        {
            $this->display_error_page(htmlentities(Translation :: get('NoObjectSelected', array(
                    'OBJECT' => Translation :: get('User')), Utilities :: COMMON_LIBRARIES)));
        }
    }

    public function add_additional_breadcrumbs(BreadcrumbTrail $breadcrumbtrail)
    {
        $breadcrumbtrail->add(new Breadcrumb($this->get_url(array(
                UserManager :: PARAM_ACTION => UserManager :: ACTION_BROWSE_USERS)), Translation :: get('UserManagerAdminUserBrowserComponent')));
        $breadcrumbtrail->add_help('user_changer');
    }

    public function get_additional_parameters()
    {
        return array(UserManager :: PARAM_USER_USER_ID);
    }

}
