<?php
namespace user;

use common\libraries\Redirect;
use common\libraries\BreadcrumbTrail;





class UserManagerTermsConditionsViewerComponent extends UserManager
{

    /**
     * Runs this component and displays its output.
     */
    public function run()
    {
       \common\libraries\Session :: unregister('terms_and_conditions_viewed');
        $user = $this->get_user();

        $form = new TermsConditionsForm($user, $this->get_url(), TermsconditionsForm::TYPE_VIEW);

        if ($form->validate())
        {
            $success = $form->register_terms_user();
            if ($success == 1)
            {
                $parameters = array();
                Redirect :: link('', $parameters, array(), false, null);
            }
            else
            {
                $this->display_header();
                $form->display();
                $this->display_footer();
            }
        }
        else
        {
            $this->display_header();
            $form->display();
            $this->display_footer();
        }
    }

    public function add_additional_breadcrumbs(BreadcrumbTrail $breadcrumbtrail)
    {
        $breadcrumbtrail = new BreadCrumbTrail(false);
    	$breadcrumbtrail->add_help('terms_conditions');
    }

	
}
