<?php
namespace user;

use common\libraries\Utilities;
use common\libraries\DataClass;
/**
 *
 * @author Hans de Bisschop
 * @author Dieter De Neef
 * @package user
 */

class UserRightsTemplate extends DataClass
{
    const CLASS_NAME = __CLASS__;

    const PROPERTY_USER_ID = 'user_id';
    const PROPERTY_RIGHTS_TEMPLATE_ID = 'rights_template_id';

    /**
     * Get the default properties of all users quota objects.
     *
     * @return array The property names.
     */
    public static function get_default_property_names()
    {
        return parent :: get_default_property_names(array(self :: PROPERTY_USER_ID,
                self :: PROPERTY_RIGHTS_TEMPLATE_ID));
    }

    /**
     * inherited
     */
    public function get_data_manager()
    {
        return UserDataManager :: get_instance();
    }

    public function get_user_id()
    {
        return $this->get_default_property(self :: PROPERTY_USER_ID);
    }

    public function set_user_id($user_id)
    {
        $this->set_default_property(self :: PROPERTY_USER_ID, $user_id);
    }

    public function get_rights_template_id()
    {
        return $this->get_default_property(self :: PROPERTY_RIGHTS_TEMPLATE_ID);
    }

    public function set_rights_template_id($rights_template_id)
    {
        $this->set_default_property(self :: PROPERTY_RIGHTS_TEMPLATE_ID, $rights_template_id);
    }

    public static function get_table_name()
    {
        return Utilities :: get_classname_from_namespace(self :: CLASS_NAME, true);
    }
}
